# LanguageServer

[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
![](https://github.com/julia-vscode/LanguageServer.jl/workflows/Run%20CI%20on%20master/badge.svg)
[![codecov](https://codecov.io/gh/julia-vscode/LanguageServer.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/julia-vscode/LanguageServer.jl)

## Overview

This package implements the Microsoft [Language Server Protocol](https://github.com/Microsoft/language-server-protocol)
for the [Julia](http://julialang.org/) programming language.

Text editors with a client for the Language Server Protocol are able to
make use of the Julia Language Server for various code editing features:

- [VS Code](https://marketplace.visualstudio.com/items?itemName=julialang.language-julia)
- [Atom](https://github.com/pfitzseb/atom-julia-lsp-client)
- [Vim and Neovim](../../wiki/Vim-and-Neovim)
- [Emacs](../../wiki/Emacs)
- [Sublime Text](https://github.com/tomv564/LSP)
- [Kakoune](../../wiki/Kakoune)
- [Helix](https://uncomfyhalomacro.pl/blog/14/)
- [Kate](../../wiki/Kate)
- [Others](https://microsoft.github.io/language-server-protocol/implementors/tools/)

## Installation and Usage
**Documentation**: [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/LanguageServer.jl/dev)

To install LanguageServer.jl into the current environment:

```julia
using Pkg
Pkg.add("LanguageServer")
```

To run an instance of LanguageServer.jl on `env_path`, you can run
Julia as follows:

```sh
julia --project=/path/to/LanguageServer.jl/environment \
  -e "using LanguageServer; runserver()" \
  <env_path>
```

If `env_path` is not specified, the language server will run on the
parent project of `pwd` or on the default `.julia/environments/v#.#`
if there is no parent project.

## Development of the VSCode extension

See https://github.com/julia-vscode/julia-vscode/wiki for information on how to test this package with the VSCode extension

using LanguageServer:
    JuliaWorkspace,
    add_workspace_folder,
    remove_workspace_folder,
    add_file,
    update_file,
    delete_file

@testitem "Julia workspace" begin
    using LanguageServer: filepath2uri, JuliaWorkspace

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace(Set([pkg_root_uri]))
    @test haskey(jw._packages, project_uri)
end

@testitem "add_workspace_folder" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_workspace_folder

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace()
    jw = add_workspace_folder(jw, pkg_root_uri)
    @test haskey(jw._packages, project_uri)
end

@testitem "add_workspace_folder 2" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_workspace_folder

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace(Set{LanguageServer.URI}([]))
    jw = add_workspace_folder(jw, pkg_root_uri)
    @test haskey(jw._packages, project_uri)
end

@testitem "add_workspace_folder and remove_workspace_folder" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_workspace_folder, remove_workspace_folder

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace()
    jw = add_workspace_folder(jw, pkg_root_uri)
    jw = add_workspace_folder(jw, filepath2uri(joinpath(@__DIR__)))
    jw = remove_workspace_folder(jw, pkg_root_uri)
    @test !haskey(jw._packages, project_uri)
end

@testitem "add_file" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_file

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace()
    jw = add_file(jw, project_file_uri)
    @test haskey(jw._packages, project_uri)
end

@testitem "update_file" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_file, update_file

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace()
    jw = add_file(jw, project_file_uri)
    jw = update_file(jw, project_file_uri)
    @test haskey(jw._packages, project_uri)
end

@testitem "delete_file" begin
    using LanguageServer: filepath2uri, JuliaWorkspace, add_file, delete_file

    pkg_root = abspath(joinpath(@__DIR__, ".."))
    pkg_root_uri = filepath2uri(pkg_root)
    project_file_path = joinpath(pkg_root, "Project.toml")
    project_path = dirname(project_file_path)
    project_file_uri = filepath2uri(project_file_path)
    project_uri = filepath2uri(project_path)

    jw = JuliaWorkspace()
    jw = add_file(jw, project_file_uri)
    jw = delete_file(jw, project_file_uri)
    @test !haskey(jw._packages, project_uri)
end

@testitem "URI conversion" begin
    using LanguageServer.URIs2

    if Sys.iswindows()
        @test LanguageServer.URIs2.uri2filepath(uri"file://SERVER/foo/bar") == "\\\\SERVER\\foo\\bar"
        @test LanguageServer.URIs2.uri2filepath(uri"file://wsl%24/foo/bar") == "\\\\wsl\$\\foo\\bar"
        @test LanguageServer.URIs2.uri2filepath(uri"file:///D:/foo/bar") == "d:\\foo\\bar"
        @test LanguageServer.URIs2.uri2filepath(uri"file:///foo/bar") == "\\foo\\bar"

        @test LanguageServer.filepath2uri("\\\\SERVER\\foo\\bar") == uri"file://SERVER/foo/bar"
        @test LanguageServer.filepath2uri("\\\\wsl\$\\foo\\bar") == uri"file://wsl%24/foo/bar"
        @test LanguageServer.filepath2uri("d:\\foo\\bar") == uri"file:///d%3A/foo/bar"
    else
        @test LanguageServer.URIs2.uri2filepath(uri"file:///foo/bar") == "/foo/bar"

        @test LanguageServer.filepath2uri("/foo/bar") == uri"file:///foo/bar"
    end

end

@testitem "URI comparison" begin
    using LanguageServer.URIs2

    if Sys.iswindows()
        @test string(filepath2uri("C:\\foo\\bar")) == "file:///c%3A/foo/bar"
        @test string(filepath2uri("\\\\wsl\$\\foo\\bar")) == "file://wsl\$/foo/bar"

        @test hash(uri"file:///d:/FOO/bar") == hash(uri"file:///d%3A/FOO/bar")
        @test hash(uri"file:///c:/foo/space bar") == hash(uri"file:///c%3A/foo/space%20bar")
        @test hash(uri"file://wsl$/foo/bar") == hash(uri"file://wsl%24/foo/bar")

        @test uri"file:///d:/FOO/bar" == uri"file:///d%3A/FOO/bar"
        @test uri"file:///c:/foo/space bar" == uri"file:///c%3A/foo/space%20bar"
        @test uri"file://wsl$/foo/bar" == uri"file://wsl%24/foo/bar"
    else
        @test string(uri"file:///foo/bar") == "file:///foo/bar"

        @test hash(uri"file:///foo/bar") == hash(uri"file:///foo/bar")
        @test hash(uri"file:///foo/space bar") == hash(uri"file:///foo/space%20bar")

        @test uri"file:///foo/bar" == uri"file:///foo/bar"
        @test uri"file:///foo/space bar" == uri"file:///foo/space%20bar"
    end

end

@testitem "is_in_target_dir_of_package" begin
    @test LanguageServer.is_in_target_dir_of_package(@__DIR__, "test")
    @test !LanguageServer.is_in_target_dir_of_package(pathof(LanguageServer), "test")
end

@testitem "Hover" begin
    include("../test_shared_server.jl")

    settestdoc("""
    1234
    Base
    +
    vari = 1234
    \"\"\"
        Text
    \"\"\"
    function func(arg) end
    func() = nothing
    module M end
    struct T end
    mutable struct T end
    for i = 1:1 end
    while true end
    begin end
    sin()
    struct S
        a
        b
        c
        d
        e
        f
        g
    end
    S(a,b,c,d,e,f,g)
    """)

    @test hover_test(0, 1) === nothing
    @test hover_test(1, 1) !== nothing
    @test hover_test(2, 1) !== nothing
    @test hover_test(3, 1) !== nothing
    @test hover_test(7, 11) !== nothing
    @test hover_test(8, 2) !== nothing
    @test hover_test(7, 16) !== nothing
    @test hover_test(7, 20) !== nothing
    @test hover_test(9, 11) !== nothing
    @test hover_test(10, 11) !== nothing
    @test hover_test(11, 18) !== nothing
    @test hover_test(12, 14) !== nothing
    @test hover_test(13, 13) !== nothing
    @test hover_test(14, 7) !== nothing
    @test hover_test(15, 2) !== nothing
    @test hover_test(15, 5) === nothing
    @test hover_test(25, 15) !== nothing
end

@testitem "hover docs" begin
    include("../test_shared_server.jl")

    settestdoc("""
    "I have a docstring"
    Base.@kwdef struct SomeStruct
        a
    end
    """)
    @test startswith(hover_test(1, 20).contents.value, "I have a docstring")
end

@testitem "hover argument qualified function" begin
    include("../test_shared_server.jl")

    settestdoc("""
    module M
        f(a,b,c,d,e) = 1
    end
    M.f(1,2,3,4,5)
    """)
    @test hover_test(3, 5).contents.value == "Argument 1 of 5 in call to `M.f`\n"
end

@testitem "get_file_loc" begin
    import CSTParser
    
    str = "(x+y for x in X for y in Y if begin if true end end)"
    cst = CSTParser.parse(str)
    @test LanguageServer.get_file_loc(cst[2][5][1][1]) == (nothing, 20)
end

function textDocument_hover_request(params::TextDocumentPositionParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    env = getenv(doc, server)
    x = get_expr1(getcst(doc), get_offset(doc, params.position))
    x isa EXPR && CSTParser.isoperator(x) && resolve_op_ref(x, env)
    documentation = get_hover(x, "", server, x, env)
    documentation = get_closer_hover(x, documentation)
    documentation = get_fcall_position(x, documentation)
    documentation = sanitize_docstring(documentation)

    return isempty(documentation) ? nothing : Hover(MarkupContent(documentation), missing)
end

get_hover(x, documentation::String, server, expr, env) = documentation

function get_hover(x::EXPR, documentation::String, server, expr, env)
    if (CSTParser.isidentifier(x) || CSTParser.isoperator(x)) && StaticLint.hasref(x)
        r = refof(x)
        documentation = if r isa StaticLint.Binding
            get_hover(r, documentation, server, expr, env)
        elseif r isa SymbolServer.SymStore
            get_hover(r, documentation, server, expr, env)
        else
            documentation
        end
    end
    return documentation
end

function get_tooltip(b::StaticLint.Binding, documentation::String, server, expr = nothing, env = nothing; show_definition = false)
    if b.val isa StaticLint.Binding
        documentation = get_hover(b.val, documentation, server, expr, env)
    elseif b.val isa EXPR
        if CSTParser.defines_function(b.val) || CSTParser.defines_datatype(b.val)
            documentation = get_func_hover(b, documentation, server, expr, env)
            for r in b.refs
                method = StaticLint.get_method(r)
                if method isa EXPR
                    documentation = get_preceding_docs(method, documentation)
                    if CSTParser.defines_function(method)
                        documentation = string(ensure_ends_with(documentation), "```julia\n", to_codeobject(CSTParser.get_sig(method)), "\n```\n")
                    elseif CSTParser.defines_datatype(method)
                        documentation = string(ensure_ends_with(documentation), "```julia\n", to_codeobject(method), "\n```\n")
                    end
                elseif method isa SymbolServer.SymStore
                    documentation = get_hover(method, documentation, server, expr, env)
                end
            end
        else
            documentation = try
                if show_definition
                    documentation = string(
                        ensure_ends_with(documentation),
                        """```julia
                        $(get_typed_definition(b))
                        ```\n
                        """
                    )
                end
                documentation = if binding_has_preceding_docs(b)
                    string(documentation, to_codeobject(maybe_get_doc_expr(b.val).args[3]))
                elseif const_binding_has_preceding_docs(b)
                    string(documentation, to_codeobject(maybe_get_doc_expr(parentof(b.val)).args[3]))
                else
                    documentation
                end
            catch err
                @error "get_hover failed to convert Expr" exception = (err, catch_backtrace())
                throw(LSHoverError(string("get_hover failed to convert Expr")))
            end
        end
    elseif b.val isa SymbolServer.SymStore
        documentation = get_hover(b.val, documentation, server, expr, env)
    end
    return documentation
end

get_hover(b::StaticLint.Binding, documentation::String, server, expr, env) =
    get_tooltip(b, documentation, server, expr, env; show_definition = true)

get_typed_definition(b) = _completion_type(b)
get_typed_definition(b::StaticLint.Binding) =
    prettify_expr(maybe_insert_type_declaration(b))

function maybe_insert_type_declaration(b::StaticLint.Binding)
    if b.val isa CSTParser.EXPR
        maybe_insert_type_declaration(to_codeobject(b.val), _completion_type(b))
    else
        _completion_type(b)
    end
end

maybe_insert_type_declaration(_, type) = coalesce(type, "")
maybe_insert_type_declaration(s::Symbol, ::Missing) = s
maybe_insert_type_declaration(s::Symbol, type) = Expr(
    :(::),
    s,
    Symbol(type)
)
maybe_insert_type_declaration(ex::Expr, ::Missing) = ex
function maybe_insert_type_declaration(ex::Expr, type)
    if ex.head === :(=) && length(ex.args) >= 2
        lhs = ex.args[1]
        if !(lhs isa Expr && lhs.head === :(::))
            ex.args[1] = Expr(
                :(::),
                lhs,
                Symbol(type)
            )
        end
    end
    return ex
end

function _completion_type(b::StaticLint.Binding)
    typ = _inner_completion_type(b.type)
    typ === missing && return missing
    if startswith(typ, "Core.")
        typ = typ[6:end]
    end
    return Symbol(typ)
end
_completion_type(_) = missing

_inner_completion_type(b::SymbolServer.DataTypeStore) = sprint(print, b.name)
_inner_completion_type(b::StaticLint.Binding) = sprint(print, to_codeobject(b.name))
_inner_completion_type(_) = missing

function prettify_expr(ex::Expr)
    if ex.head === :kw && length(ex.args) == 2
        string(ex.args[1], " = ", ex.args[2])
    else
        string(ex)
    end
end

prettify_expr(ex) = string(ex)

# print(io, x::SymStore) methods are defined in SymbolServer
function get_hover(b::SymbolServer.SymStore, documentation::String, server, expr, env)
    if !isempty(b.doc)
        documentation = string(documentation, b.doc, "\n")
    end
    documentation = string(documentation, "```julia\n", b, "\n```")
end

function get_hover(f::SymbolServer.FunctionStore, documentation::String, server, expr, env)
    if !isempty(f.doc)
        documentation = string(documentation, f.doc, "\n\n")
    end

    if expr !== nothing && env !== nothing
        tls = StaticLint.retrieve_toplevel_scope(expr)
        itr = func -> StaticLint.iterate_over_ss_methods(f, tls, env, func)
    else
        itr = func -> begin
            for m in f.methods
                func(m)
            end
        end
    end

    method_count = 0
    totalio = IOBuffer()
    itr() do m
        method_count += 1

        io = IOBuffer()
        print(io, m.name, "(")
        nsig = length(m.sig)
        for (i, sig) = enumerate(m.sig)
            if sig[1] ≠ Symbol("#unused#")
                print(io, sig[1])
            end
            print(io, "::", sig[2])
            i ≠ nsig && print(io, ", ")
        end
        print(io, ")")
        sig = String(take!(io))

        path = replace(m.file, "\\" => "\\\\")
        text = string(path, ':', m.line)
        link = text

        if server.clientInfo !== missing && isabspath(m.file)
            clientname = lowercase(server.clientInfo.name)
            if occursin("code", clientname) || occursin("sublime", clientname)
                link = string(filepath2uri(m.file), "#", m.line)
                text = string(basename(path), ':', m.line)
            end
        end
        println(totalio, "$(method_count). `$(sig)` in `$(m.mod)` at [$(text)]($(link))\n")
        return false
    end

    documentation = string(
        documentation,
        "`$(f.name)` is a function with **$(method_count)** method$(method_count == 1 ? "" : "s")\n",
        String(take!(totalio))
    )

    return documentation
end

get_func_hover(x, documentation, server, expr, env) = documentation
get_func_hover(x::SymbolServer.SymStore, documentation, server, expr, env) = get_hover(x, documentation, server, expr, env)

function get_preceding_docs(expr::EXPR, documentation)
    if expr_has_preceding_docs(expr)
        string(documentation, to_codeobject(maybe_get_doc_expr(expr).args[3]))
    elseif is_const_expr(parentof(expr)) && expr_has_preceding_docs(parentof(expr))
        string(documentation, to_codeobject(maybe_get_doc_expr(parentof(expr)).args[3]))
    else
        documentation
    end
end

ensure_ends_with(s, c = "\n") = endswith(s, c) ? s : string(s, c)

binding_has_preceding_docs(b::StaticLint.Binding) = expr_has_preceding_docs(b.val)

function const_binding_has_preceding_docs(b::StaticLint.Binding)
    p = parentof(b.val)
    is_const_expr(p) && expr_has_preceding_docs(p)
end

function maybe_get_doc_expr(x)
    # The expression may be nested in any number of macros
    while CSTParser.hasparent(x) &&
        CSTParser.ismacrocall(parentof(x))
        x = parentof(x)
        headof(x.args[1]) === :globalrefdoc && return x
    end
    return x
end

expr_has_preceding_docs(x) = false
expr_has_preceding_docs(x::EXPR) = is_doc_expr(maybe_get_doc_expr(x))

is_const_expr(x) = false
is_const_expr(x::EXPR) = headof(x) === :const

is_doc_expr(x) = false
function is_doc_expr(x::EXPR)
    return CSTParser.ismacrocall(x) &&
           length(x.args) == 4 &&
           headof(x.args[1]) === :globalrefdoc &&
           CSTParser.isstring(x.args[3])
end

get_fcall_position(x, documentation, visited=nothing) = documentation

function get_fcall_position(x::EXPR, documentation, visited=Set{EXPR}())
    if x in visited                                      # TODO: remove
        throw(LSInfiniteLoop("Possible infinite loop.")) # TODO: remove
    else                                                 # TODO: remove
        push!(visited, x)                                # TODO: remove
    end                                                  # TODO: remove
    if parentof(x) isa EXPR
        if CSTParser.iscall(parentof(x))
            minargs, _, _ = StaticLint.call_nargs(parentof(x))
            arg_i = 0
            for (i, arg) in enumerate(parentof(x))
                if arg == x
                    arg_i = div(i - 1, 2)
                    break
                end
            end

            # hovering over the function name, so we might as well check the parent
            if arg_i == 0
                return get_fcall_position(parentof(x), documentation, visited)
            end

            minargs < 4 && return documentation

            fname = CSTParser.get_name(parentof(x))
            if StaticLint.hasref(fname) &&
               (refof(fname) isa StaticLint.Binding && refof(fname).val isa EXPR && CSTParser.defines_struct(refof(fname).val) && StaticLint.struct_nargs(refof(fname).val)[1] == minargs)
                dt_ex = refof(fname).val
                args = dt_ex.args[3]
                args.args === nothing || arg_i > length(args.args) && return documentation
                _fieldname = CSTParser.str_value(CSTParser.get_arg_name(args.args[arg_i]))
                documentation = string("Datatype field `$_fieldname` of $(CSTParser.str_value(CSTParser.get_name(dt_ex)))", "\n", documentation)
            elseif StaticLint.hasref(fname) && (refof(fname) isa SymbolServer.DataTypeStore || refof(fname) isa StaticLint.Binding && refof(fname).val isa SymbolServer.DataTypeStore)
                dts = refof(fname) isa StaticLint.Binding ? refof(fname).val : refof(fname)
                if length(dts.fieldnames) == minargs && arg_i <= length(dts.fieldnames)
                    documentation = string("Datatype field `$(dts.fieldnames[arg_i])`", "\n", documentation)
                end
            else
                callname = if CSTParser.is_getfield(fname)
                    CSTParser.str_value(fname.args[1]) * "." * CSTParser.str_value(CSTParser.get_rhs_of_getfield(fname))
                else
                    CSTParser.str_value(fname)
                end
                documentation = string("Argument $arg_i of $(minargs) in call to `", callname, "`\n", documentation)
            end
            return documentation
        else
            return get_fcall_position(parentof(x), documentation, visited)
        end
    end
    return documentation
end

# info on what expression the current token (e.g. a ], ), `end`, etc.)
get_closer_hover(x, documentation) = documentation
function get_closer_hover(x::EXPR, documentation)
    if parentof(x) isa EXPR
        if headof(x) === :END
            if headof(parentof(x)) === :function
                documentation = string(documentation, "Closes function definition for `", to_codeobject(CSTParser.get_sig(parentof(x))), "`\n")
            elseif CSTParser.defines_module(parentof(x)) && length(parentof(x).args) > 1
                documentation = string(documentation, "Closes module definition for `", to_codeobject(parentof(x).args[2]), "`\n")
            elseif CSTParser.defines_struct(parentof(x))
                documentation = string(documentation, "Closes struct definition for `", to_codeobject(CSTParser.get_sig(parentof(x))), "`\n")
            elseif headof(parentof(x)) === :for && length(parentof(x).args) > 2
                documentation = string(documentation, "Closes for-loop expression over `", to_codeobject(parentof(x).args[2]), "`\n")
            elseif headof(parentof(x)) === :while && length(parentof(x).args) > 2
                documentation = string(documentation, "Closes while-loop expression over `", to_codeobject(parentof(x).args[2]), "`\n")
            else
                documentation = "Closes `$(headof(parentof(x)))` expression."
            end
        end
    end
    return documentation
end

mutable struct CancelParams
    id::Union{String,Int64}
end
CancelParams(d::Dict) = CancelParams(d["id"])

const TraceValue = String

struct SetTraceParams
    value::TraceValue
end
SetTraceParams(d::Dict) = SetTraceParams(d["value"])

struct ProgressParams{T}
    token::Union{Int,String} # ProgressToken
    value::T
end

mutable struct DocumentFilter <: Outbound
    language::Union{String,Missing}
    scheme::Union{String,Missing}
    pattern::Union{String,Missing}
end
const DocumentSelector = Vector{DocumentFilter}
const DocumentUri = URI

@dict_readable struct Position
    line::Int
    character::Int
end
Position(line::Integer) = Position(line, 0)

struct Range
    start::Position
    stop::Position
end
# Special case to account for use of 'end' as a fieldname in LSP
Range(d::Dict) = Range(Position(d["start"]), Position(d["end"]))
Range(line::Integer) = Range(Position(line), Position(line))
Range(l0::Integer, c0::Integer, l1::Integer, c1::Integer) = Range(Position(l0, c0), Position(l1, c1))
function JSON.lower(a::Range)
    Dict("start" => a.start, "end" => a.stop)
end

@dict_readable struct Location
    uri::DocumentUri
    range::Range
end
Location(f::String, line::Integer) = Location(f, Range(line))


@dict_readable struct LocationLink <: Outbound
    originalSelectionRange::Union{Range,Missing}
    targetUri::DocumentUri
    targetRange::Range
    targetSelectionRange::Range
end

@dict_readable struct WorkspaceFolder
    uri::DocumentUri
    name::String
end

##############################################################################
# Diagnostics
const DiagnosticSeverity = Int
const DiagnosticSeverities = (Error = 1,
                              Warning = 2,
                              Information = 3,
                              Hint = 4)

const DiagnosticTag = Int
const DiagnosticTags = (Unnecessary = 1,
                        Deprecated = 2)

@dict_readable struct DiagnosticRelatedInformation <: Outbound
    location::Location
    message::String
end

@dict_readable struct CodeDescription <: Outbound
    href::URI
end

@dict_readable struct Diagnostic <: Outbound
    range::Range
    severity::Union{DiagnosticSeverity,Missing}
    code::Union{String,Missing}
    codeDescription::Union{CodeDescription,Missing}
    source::Union{String,Missing}
    message::String
    tags::Union{Vector{DiagnosticTag},Missing}
    relatedInformation::Union{Vector{DiagnosticRelatedInformation},Missing}
end

##############################################################################

struct Command <: Outbound # Use traits for this?
    title::String
    command::String
    arguments::Union{Vector{Any},Missing}
end

struct TextEdit
    range::Range
    newText::String
end

##############################################################################
# Markup
const MarkupKind = String
const MarkupKinds = (PlainText = "plaintext",
                     Markdown = "markdown")

mutable struct MarkupContent
    kind::MarkupKind
    value::String
end
MarkupContent(value::String) = MarkupContent(MarkupKinds.Markdown, value)

mutable struct MarkedString
    language::String
    value::AbstractString
end

Base.convert(::Type{MarkedString}, x::String) = MarkedString("julia", string(x))
MarkedString(x) = MarkedString("julia", string(x))
Base.hash(x::MarkedString) = hash(x.value) # for unique


##############################################################################
# Window
const MessageType = Int
const MessageTypes = (Error = 1,
                      Warning = 2,
                      Info = 3,
                      Log = 4)

struct ShowMessageParams <: Outbound
    type::MessageType
    message::String
end

struct MessageActionItem <: Outbound
    title::String
end

mutable struct ShowMessageRequestParams <: Outbound
    type::MessageType
    message::String
    actions::Union{Vector{MessageActionItem},Missing}
end

mutable struct LogMessageParams <: Outbound
    type::Integer
    message::String
end

##############################################################################
# Progress
struct WorkDoneProgressCreateParams <: Outbound
    token::Union{Int,String} # ProgressToken
end

@dict_readable struct WorkDoneProgressCancelParams
    token::Union{Int,String} # ProgressToken
end

struct WorkDoneProgressBegin <: Outbound
    kind::String
    title::String
    cancellable::Union{Bool,Missing}
    message::Union{String,Missing}
    percentage::Union{Int,Missing}
    function WorkDoneProgressBegin(title, cancellable, message, percentage)
        new("begin", title, cancellable, message, percentage)
    end
end

struct WorkDoneProgressReport <: Outbound
    kind::String
    cancellable::Union{Bool,Missing}
    message::Union{String,Missing}
    percentage::Union{Int,Missing}
    function WorkDoneProgressReport(cancellable, message, percentage)
        new("report", cancellable, message, percentage)
    end
end

struct WorkDoneProgressEnd <: Outbound
    kind::String
    message::Union{String,Missing}
    function WorkDoneProgressEnd(message)
        new("end", message)
    end
end

struct WorkDoneProgressParams <: Outbound
    workDoneToken::Union{Int,String,Missing} # ProgressToken
end

struct WorkDoneProgressOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

##############################################################################
# Partial

struct PartialResultParams <: Outbound
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

# VSCode specific
# ---------------

function nodocument_error(uri, data=nothing)
    return JSONRPC.JSONRPCError(
        -33100,
        "document $(uri) requested but not present in the JLS",
        data
    )
end

function mismatched_version_error(uri, doc, params, msg, data=nothing)
    return JSONRPC.JSONRPCError(
        -33101,
        "version mismatch in $(msg) request for $(uri): JLS $(get_version(doc)), client: $(params.version)",
        data
    )
end

# lookup
# ------

traverse_by_name(f, cache = SymbolServer.stdlibs) = traverse_store!.(f, values(cache))

traverse_store!(_, _) = return
traverse_store!(f, store::SymbolServer.EnvStore) = traverse_store!.(f, values(store))
function traverse_store!(f, store::SymbolServer.ModuleStore)
    for (sym, val) in store.vals
        f(sym, val)
        traverse_store!(f, val)
    end
end

# misc
# ----

function should_file_be_linted(uri, server)
    !server.runlinter && return false

    uri_path = uri2filepath(uri)

    if length(server.workspaceFolders) == 0 || uri_path === nothing
        return false
    else
        return any(i -> startswith(uri_path, i), server.workspaceFolders)
    end
end

# CompletionItemKind(t) = t in [:String, :AbstractString] ? 1 :
#                                 t == :Function ? 3 :
#                                 t == :DataType ? 7 :
#                                 t == :Module ? 9 : 6

# SymbolKind(t) = t in [:String, :AbstractString] ? 15 :
#                         t == :Function ? 12 :
#                         t == :DataType ? 5 :
#                         t == :Module ? 2 :
#                         t == :Bool ? 17 : 13




# Find location of default datatype constructor
const DefaultTypeConstructorLoc = let def = first(methods(Int))
    Base.find_source_file(string(def.file)), def.line
end

# TODO I believe this will also remove files from documents that were added
# not because they are part of the workspace, but by either StaticLint or
# the include follow logic.
function remove_workspace_files(root, server)
    for (uri, doc) in getdocuments_pair(server)
        # We first check whether the doc still exists on the server
        # because a previous loop iteration could have deleted it
        # via dependency removal of files
        hasdocument(server, uri) || continue
        fpath = getpath(doc)
        isempty(fpath) && continue
        get_open_in_editor(doc) && continue
        # If the file is in any other workspace folder, don't delete it
        any(folder -> startswith(fpath, folder), server.workspaceFolders) && continue
            deletedocument!(server, uri)
        end
    end


# TODO DA removed this, make sure it really isn't needed
# function Base.getindex(server::LanguageServerInstance, r::Regex)
#     out = []
#     for (uri, doc) in getdocuments_pair(server)
#         occursin(r, uri._uri) && push!(out, doc)
#     end
#     return out
# end

function _offset_unitrange(r::UnitRange{Int}, first=true)
    return r.start - 1:r.stop
end

function get_toks(doc, offset)
    ts = CSTParser.Tokenize.tokenize(get_text(doc))
    ppt = CSTParser.Tokens.RawToken(CSTParser.Tokens.ERROR, (0, 0), (0, 0), 1, 0, CSTParser.Tokens.NO_ERR, false, false)
    pt = CSTParser.Tokens.RawToken(CSTParser.Tokens.ERROR, (0, 0), (0, 0), 1, 0, CSTParser.Tokens.NO_ERR, false, false)
    t = CSTParser.Tokenize.Lexers.next_token(ts)

    prevpos = -1 # TODO: remove.
    while t.kind != CSTParser.Tokenize.Tokens.ENDMARKER
        if t.startbyte === prevpos # TODO: remove.
            throw(LSInfiniteLoop("Loop did not progress between iterations.")) # TODO: remove.
        else # TODO: remove.
            prevpos = t.startbyte # TODO: remove.
        end # TODO: remove.

        if t.startbyte < offset <= t.endbyte + 1
            break
        end
        ppt = pt
        pt = t
        t = CSTParser.Tokenize.Lexers.next_token(ts)
    end
    return ppt, pt, t
end

function isvalidjlfile(path)
    endswith(path, ".jl")
end

function our_isvalid(s)
    return isvalid(s) && !occursin('\0', s)
end

function get_expr(x, offset, pos=0, ignorewhitespace=false)
    if pos > offset
        return nothing
    end
    if length(x) > 0 && headof(x) !== :NONSTDIDENTIFIER
        for a in x
            if pos < offset <= (pos + a.fullspan)
                return get_expr(a, offset, pos, ignorewhitespace)
            end
            pos += a.fullspan
        end
    elseif pos == 0
        return x
    elseif (pos < offset <= (pos + x.fullspan))
        ignorewhitespace && pos + x.span < offset && return nothing
        return x
    end
end

# like get_expr, but only returns a expr if offset is not on the edge of its span
function get_expr_or_parent(x, offset, pos=0)
    if pos > offset
        return nothing, pos
    end
    ppos = pos
    if length(x) > 0 && headof(x) !== :NONSTDIDENTIFIER
        for a in x
            if pos < offset <= (pos + a.fullspan)
                if pos < offset < (pos + a.span)
                    return get_expr_or_parent(a, offset, pos)
                else
                    return x, ppos
                end
            end
            pos += a.fullspan
        end
    elseif pos == 0
        return x, pos
    elseif (pos < offset <= (pos + x.fullspan))
        if pos + x.span < offset
            return x.parent, ppos
        end
        return x, pos
    end
    return nothing, pos
end

function get_expr(x, offset::UnitRange{Int}, pos=0, ignorewhitespace=false)
    if all(pos .> offset)
        return nothing
    end
    if length(x) > 0 && headof(x) !== :NONSTDIDENTIFIER
        for a in x
            if all(pos .< offset .<= (pos + a.fullspan))
                return get_expr(a, offset, pos, ignorewhitespace)
            end
            pos += a.fullspan
        end
    elseif pos == 0
        return x
    elseif all(pos .< offset .<= (pos + x.fullspan))
        ignorewhitespace && all(pos + x.span .< offset) && return nothing
        return x
    end
    pos -= x.fullspan
    if all(pos .< offset .<= (pos + x.fullspan))
        ignorewhitespace && all(pos + x.span .< offset) && return nothing
        return x
    end
end

get_inner_expr(doc::Document, rng::Range) = get_inner_expr(getcst(doc), get_offset(doc, rng))
# full (not only trivia) expr containing rng, modulo whitespace
function get_inner_expr(x, rng::UnitRange{Int}, pos=0, pos_span = 0)
    if all(pos .> rng)
        return nothing
    end
    if length(x) > 0 && headof(x) !== :NONSTDIDENTIFIER
        pos_span′ = pos_span
        for a in x
            if a in x.args && all(pos_span′ .< rng .<= (pos + a.fullspan))
                return get_inner_expr(a, rng, pos, pos_span′)
            end
            pos += a.fullspan
            pos_span′ = pos - (a.fullspan - a.span)
        end
    elseif pos == 0
        return x
    elseif all(pos_span .< rng .<= (pos + x.fullspan))
        return x
    end
    pos -= x.fullspan
    if all(pos_span .< rng .<= (pos + x.fullspan))
        return x
    end
end

function get_expr1(x, offset, pos=0)
    if length(x) == 0 || headof(x) === :NONSTDIDENTIFIER
        if pos <= offset <= pos + x.span
            return x
        else
            return nothing
        end
    else
        for i = 1:length(x)
            arg = x[i]
            if pos < offset < (pos + arg.span) # def within span
                return get_expr1(arg, offset, pos)
            elseif arg.span == arg.fullspan
                if offset == pos
                    if i == 1
                        return get_expr1(arg, offset, pos)
                    elseif headof(x[i - 1]) === :IDENTIFIER
                        return get_expr1(x[i - 1], offset, pos)
                    else
                        return get_expr1(arg, offset, pos)
                    end
                elseif i == length(x) # offset == pos + arg.fullspan
                    return get_expr1(arg, offset, pos)
                end
            else
                if offset == pos
                    if i == 1
                        return get_expr1(arg, offset, pos)
                    elseif headof(x[i - 1]) === :IDENTIFIER
                        return get_expr1(x[i - 1], offset, pos)
                    else
                        return get_expr1(arg, offset, pos)
                    end
                elseif offset == pos + arg.span
                    return get_expr1(arg, offset, pos)
                elseif offset == pos + arg.fullspan
                elseif pos + arg.span < offset < pos + arg.fullspan
                    return nothing
                end
            end
            pos += arg.fullspan
        end
        return nothing
    end
end


function get_identifier(x, offset, pos=0)
    if pos > offset
        return nothing
    end
    if length(x) > 0
        for a in x
            if pos <= offset <= (pos + a.span)
                return get_identifier(a, offset, pos)
            end
            pos += a.fullspan
        end
    elseif headof(x) === :IDENTIFIER && (pos <= offset <= (pos + x.span)) || pos == 0
        return x
    end
end


if VERSION < v"1.1" || Sys.iswindows() && VERSION < v"1.3"
    _splitdir_nodrive(path::String) = _splitdir_nodrive("", path)
    function _splitdir_nodrive(a::String, b::String)
        m = match(Base.Filesystem.path_dir_splitter, b)
        m === nothing && return (a, b)
        a = string(a, isempty(m.captures[1]) ? m.captures[2][1] : m.captures[1])
        a, String(m.captures[3])
    end
    splitpath(p::AbstractString) = splitpath(String(p))

    function splitpath(p::String)
        drive, p = _splitdrive(p)
        out = String[]
        isempty(p) && (pushfirst!(out, p))  # "" means the current directory.
        while !isempty(p)
            dir, base = _splitdir_nodrive(p)
            dir == p && (pushfirst!(out, dir); break)  # Reached root node.
            if !isempty(base)  # Skip trailing '/' in basename
                pushfirst!(out, base)
            end
            p = dir
        end
        if !isempty(drive)  # Tack the drive back on to the first element.
            out[1] = drive * out[1]  # Note that length(out) is always >= 1.
        end
        return out
    end
    _path_separator    = "\\"
    _path_separator_re = r"[/\\]+"
    function _pathsep(paths::AbstractString...)
        for path in paths
            m = match(_path_separator_re, String(path))
            m !== nothing && return m.match[1:1]
        end
        return _path_separator
    end
    function joinpath(a::String, b::String)
        isabspath(b) && return b
        A, a = _splitdrive(a)
        B, b = _splitdrive(b)
        !isempty(B) && A != B && return string(B,b)
        C = isempty(B) ? A : B
        isempty(a)                              ? string(C,b) :
        occursin(_path_separator_re, a[end:end]) ? string(C,a,b) :
                                                  string(C,a,_pathsep(a,b),b)
    end
    joinpath(a::AbstractString, b::AbstractString) = joinpath(String(a), String(b))
    joinpath(a, b, c, paths...) = joinpath(joinpath(a, b), c, paths...)
end

@static if Sys.iswindows() && VERSION < v"1.3"
    function _splitdir_nodrive(a::String, b::String)
        m = match(r"^(.*?)([/\\]+)([^/\\]*)$", b)
        m === nothing && return (a, b)
        a = string(a, isempty(m.captures[1]) ? m.captures[2][1] : m.captures[1])
        a, String(m.captures[3])
    end
    function _dirname(path::String)
        m = match(r"^([^\\]+:|\\\\[^\\]+\\[^\\]+|\\\\\?\\UNC\\[^\\]+\\[^\\]+|\\\\\?\\[^\\]+:|)(.*)$"s, path)
        m === nothing && return ""
        a, b = String(m.captures[1]), String(m.captures[2])
        _splitdir_nodrive(a, b)[1]
    end
    function _splitdrive(path::String)
        m = match(r"^([^\\]+:|\\\\[^\\]+\\[^\\]+|\\\\\?\\UNC\\[^\\]+\\[^\\]+|\\\\\?\\[^\\]+:|)(.*)$"s, path)
        m === nothing && return "", path
        String(m.captures[1]), String(m.captures[2])
    end
    function _splitdir(path::String)
        a, b = _splitdrive(path)
        _splitdir_nodrive(a, b)
    end
else
    _dirname = dirname
    _splitdir = splitdir
    _splitdrive = splitdrive
end

function valid_id(s::String)
    !isempty(s) && all(i == 1 ? Base.is_id_start_char(c) : Base.is_id_char(c) for (i, c) in enumerate(s))
end

function sanitize_docstring(doc::String)
    doc = replace(doc, "```jldoctest" => "```julia")
    doc = replace(doc, "\n#" => "\n###")
    return doc
end

function parent_file(x::EXPR)
    if parentof(x) isa EXPR
        return parent_file(parentof(x))
    elseif parentof(x) === nothing && StaticLint.haserror(x) && StaticLint.errorof(x) isa Document
        return x.meta.error
    else
        return nothing
    end
end

function resolve_op_ref(x::EXPR, env)
    StaticLint.hasref(x) && return true
    !CSTParser.isoperator(x) && return false
    pf = parent_file(x)
    pf === nothing && return false
    scope = StaticLint.retrieve_scope(x)
    scope === nothing && return false

    return op_resolve_up_scopes(x, CSTParser.str_value(x), scope, env)
end

function op_resolve_up_scopes(x, mn, scope, env)
    scope isa StaticLint.Scope || return false
    if StaticLint.scopehasbinding(scope, mn)
        StaticLint.setref!(x, scope.names[mn])
        return true
    elseif scope.modules isa Dict && length(scope.modules) > 0
        for (_, m) in scope.modules
            if m isa SymbolServer.ModuleStore && StaticLint.isexportedby(Symbol(mn), m)
                StaticLint.setref!(x, StaticLint.maybe_lookup(m[Symbol(mn)], env))
                return true
            elseif m isa StaticLint.Scope && StaticLint.scopehasbinding(m, mn)
                StaticLint.setref!(x, StaticLint.maybe_lookup(m.names[mn], env))
                return true
            end
        end
    end
    CSTParser.defines_module(scope.expr) || !(StaticLint.parentof(scope) isa StaticLint.Scope) && return false
    return op_resolve_up_scopes(x, mn, StaticLint.parentof(scope), env)
end


function is_in_target_dir_of_package(pkgpath, target)
    try # Safe failure - attempts to read disc.
        spaths = splitpath(pkgpath)
        if (i = findfirst(==(target), spaths)) !== nothing && "src" in readdir(joinpath(spaths[1:i - 1]...))
            return true
        end
        return false
    catch
        return false
    end
end

@static if VERSION < v"1.6"
    let
        @inline function __convert_digit(_c::UInt32, base)
            _0 = UInt32('0')
            _9 = UInt32('9')
            _A = UInt32('A')
            _a = UInt32('a')
            _Z = UInt32('Z')
            _z = UInt32('z')
            a::UInt32 = base <= 36 ? 10 : 36
            d = _0 <= _c <= _9 ? _c-_0             :
                _A <= _c <= _Z ? _c-_A+ UInt32(10) :
                _a <= _c <= _z ? _c-_a+a           : UInt32(base)
        end

        @inline function uuid_kernel(s, i, u)
            _c = UInt32(@inbounds codeunit(s, i))
            d = __convert_digit(_c, UInt32(16))
            d >= 16 && return nothing
            u <<= 4
            return u | d
        end

        function Base.tryparse(::Type{UUID}, s::AbstractString)
            u = UInt128(0)
            ncodeunits(s) != 36 && return nothing
            for i in 1:8
                u = uuid_kernel(s, i, u)
                u === nothing && return nothing
            end
            @inbounds codeunit(s, 9) == UInt8('-') || return nothing
            for i in 10:13
                u = uuid_kernel(s, i, u)
                u === nothing && return nothing
            end
            @inbounds codeunit(s, 14) == UInt8('-') || return nothing
            for i in 15:18
                u = uuid_kernel(s, i, u)
                u === nothing && return nothing
            end
            @inbounds codeunit(s, 19) == UInt8('-') || return nothing
            for i in 20:23
                u = uuid_kernel(s, i, u)
                u === nothing && return nothing
            end
            @inbounds codeunit(s, 24) == UInt8('-') || return nothing
            for i in 25:36
                u = uuid_kernel(s, i, u)
                u === nothing && return nothing
            end
            return Base.UUID(u)
        end
    end
end

# some timer utilities
add_timer_message!(did_show_timer, timings, msg::Dict) = add_timer_message!(did_show_timer, timings, string("LSP/", get(msg, "method", "")))
function add_timer_message!(did_show_timer, timings, msg::String)
    if did_show_timer[]
        return
    end

    push!(timings, (msg, time()))

    if should_show_timer_message(timings)
        send_startup_time_message(timings)
        did_show_timer[] = true
    end
end

function should_show_timer_message(timings)
    required_messages = [
        "LSP/initialize",
        "LSP/initialized",
        "initial lint done"
    ]

    return all(in(first.(timings)), required_messages)
end

function send_startup_time_message(timings)
    length(timings) > 1 || return

    io = IOBuffer()
    println(io, "============== Startup timings ==============")
    starttime = prevtime = first(timings)[2]
    for (msg, thistime) in timings
        println(
            io,
            lpad(string(round(thistime - starttime; sigdigits = 5)), 10),
            " - ", msg, " (",
            round(thistime - prevtime; sigdigits = 5),
            "s since last event)"
        )
        prevtime = thistime
    end
    println(io, "=============================================")

    empty!(timings)

    println(stderr, String(take!(io)))
end

function poll_editor_pid(server::LanguageServerInstance)
    if server.editor_pid === nothing
        return
    end
    @info "Monitoring editor process with id $(server.editor_pid)"
    return @async while !server.shutdown_requested
        sleep(10)

        # kill -0 $editor_pid
        r = ccall(:uv_kill, Cint, (Cint, Cint), server.editor_pid, 0)
        if r != 0
            exit(1)
        end
    end
end

function ServerCapabilities(client::ClientCapabilities)
    prepareSupport = !ismissing(client.textDocument) && !ismissing(client.textDocument.rename) && client.textDocument.rename.prepareSupport === true

    ServerCapabilities(
        TextDocumentSyncOptions(
            true,
            TextDocumentSyncKinds.Incremental,
            false,
            false,
            SaveOptions(true)
        ),
        CompletionOptions(false, [".", "@", "\"", "^"], missing),
        true,
        SignatureHelpOptions(["(", ","], missing),
        false,
        true,
        false,
        false,
        true,
        true,
        true,
        true,
        missing,
        DocumentLinkOptions(false, missing),
        false,
        true,
        true,
        missing,
        RenameOptions(missing, prepareSupport),
        false,
        ExecuteCommandOptions(missing, collect(keys(LSActions))),
        true,
        true,
        true,
        WorkspaceOptions(WorkspaceFoldersOptions(true, true)),
        missing
    )

end

hasreadperm(p::String) = (uperm(p) & 0x04) == 0x04

function isjuliabasedir(path)
    try
        fs = readdir(path)
        if "base" in fs && isdir(joinpath(path, "base"))
            return isjuliabasedir(joinpath(path, "base"))
        end
        return all(f -> f in fs, ["coreimg.jl", "coreio.jl", "inference.jl"])
    catch err
        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        return false
    end
end

function has_too_many_files(path, N=5000)
    i = 0

    try
        for (_, _, files) in walkdir(path, onerror=x -> x)
            for file in files
                if endswith(file, ".jl")
                    i += 1
                end
                if i > N
                    @info "Your workspace folder has > $N Julia files, server will not try to load them."
                    return true
                end
            end
        end
    catch err
        is_walkdir_error(err) || rethrow()
        return false
    end

    return false
end

function load_rootpath(path)
    try
        return isdir(path) &&
            hasreadperm(path) &&
            path != "" &&
            path != homedir() &&
            !isjuliabasedir(path) &&
            !has_too_many_files(path)
    catch err
        is_walkdir_error(err) || rethrow()
        return false
    end
end

function load_folder(wf::WorkspaceFolder, server)
    path = uri2filepath(wf.uri)
    load_folder(path, server)
end

function load_folder(path::String, server)
    if load_rootpath(path)
        try
            for (root, _, files) in walkdir(path, onerror=x -> x)
                for file in files
                    filepath = joinpath(root, file)
                    if isvalidjlfile(filepath)
                        uri = filepath2uri(filepath)
                        if hasdocument(server, uri)
                            set_is_workspace_file(getdocument(server, uri), true)
                            continue
                        else
                            content = try
                                s = read(filepath, String)
                                our_isvalid(s) || continue
                                s
                            catch err
                                is_walkdir_error(err) || rethrow()
                                continue
                            end
                            doc = Document(TextDocument(uri, content, 0), true, server)
                            setdocument!(server, uri, doc)
                            try
                                parse_all(doc, server)
                            catch ex
                                @error "Error parsing file $(uri)"
                                rethrow()
                            end
                        end
                    end
                end
            end
        catch err
            is_walkdir_error(err) || rethrow()
        end
    end
end

is_walkdir_error(_) = false
is_walkdir_error(::Base.IOError) = true
is_walkdir_error(::Base.SystemError) = true
@static if VERSION > v"1.3.0-"
    is_walkdir_error(err::Base.TaskFailedException) = is_walkdir_error(err.task.exception)
end

function initialize_request(params::InitializeParams, server::LanguageServerInstance, conn)
    # Only look at rootUri and rootPath if the client doesn't support workspaceFolders
    if !ismissing(params.capabilities.workspace) && (ismissing(params.capabilities.workspace.workspaceFolders) || params.capabilities.workspace.workspaceFolders == false)
        if !(params.rootUri isa Nothing)
            push!(server.workspaceFolders, uri2filepath(params.rootUri))
        elseif !(params.rootPath isa Nothing)
            push!(server.workspaceFolders,  params.rootPath)
        end
    elseif (params.workspaceFolders !== nothing) & (params.workspaceFolders !== missing)
        for wksp in params.workspaceFolders
            if wksp.uri !== nothing
                fpath = uri2filepath(wksp.uri)
                if fpath !== nothing
                    push!(server.workspaceFolders, fpath)
                end
            end
        end
    end

    server.clientCapabilities = params.capabilities
    server.clientInfo = params.clientInfo
    server.editor_pid = params.processId

    if !ismissing(params.capabilities.window) && params.capabilities.window.workDoneProgress
        server.clientcapability_window_workdoneprogress = true
    else
        server.clientcapability_window_workdoneprogress = false
    end

    if !ismissing(params.capabilities.workspace) &&
        !ismissing(params.capabilities.workspace.didChangeConfiguration) &&
        !ismissing(params.capabilities.workspace.didChangeConfiguration.dynamicRegistration) &&
        params.capabilities.workspace.didChangeConfiguration.dynamicRegistration

        server.clientcapability_workspace_didChangeConfiguration = true
    end

    if !ismissing(params.initializationOptions) && params.initializationOptions !== nothing
        server.initialization_options = params.initializationOptions
    end

    return InitializeResult(ServerCapabilities(server.clientCapabilities), missing)
end


function initialized_notification(params::InitializedParams, server::LanguageServerInstance, conn)
    server.status = :running

    if server.clientcapability_workspace_didChangeConfiguration
        JSONRPC.send(
            conn,
            client_registerCapability_request_type,
            RegistrationParams([Registration(string(uuid4()), "workspace/didChangeConfiguration", missing)])
        )
    end

    if server.workspaceFolders !== nothing
        server.workspace = JuliaWorkspace(Set(filepath2uri.(server.workspaceFolders)))

        if server.env_path != "" && isfile(joinpath(server.env_path, "Project.toml")) && isfile(joinpath(server.env_path, "Manifest.toml"))
            server.workspace = add_file(server.workspace, filepath2uri(joinpath(server.env_path, "Project.toml")))
            server.workspace = add_file(server.workspace, filepath2uri(joinpath(server.env_path, "Manifest.toml")))
        elseif server.env_path != "" && isfile(joinpath(server.env_path, "JuliaProject.toml")) && isfile(joinpath(server.env_path, "JuliaManifest.toml"))
            server.workspace = add_file(server.workspace, filepath2uri(joinpath(server.env_path, "JuliaProject.toml")))
            server.workspace = add_file(server.workspace, filepath2uri(joinpath(server.env_path, "JuliaManifest.toml")))
        end

        for wkspc in server.workspaceFolders
            load_folder(wkspc, server)
        end
    end

    request_julia_config(server, conn)

    if server.number_of_outstanding_symserver_requests > 0
        create_symserver_progress_ui(server)
    end
end

function shutdown_request(params::Nothing, server::LanguageServerInstance, conn)
    server.shutdown_requested = true
    return nothing
end

function exit_notification(params::Nothing, server::LanguageServerInstance, conn)
    server.symbol_server.process isa Base.Process && kill(server.symbol_server.process)
    exit(server.shutdown_requested ? 0 : 1)
end

using Pkg
@static if isdefined(Base, :parsed_toml)
    parsed_toml(args...) = Base.parsed_toml(args...)
else
    parsed_toml(file) = Pkg.TOML.parsefile(file)
end

const project_names = ("JuliaProject.toml", "Project.toml")
const manifest_names = ("JuliaManifest.toml", "Manifest.toml")

# return nothing or the project file at env
function env_file(env::String, names = project_names)::Union{Nothing,String}
    if isdir(env)
        for proj in names
            project_file = joinpath(env, proj)
            safe_isfile(project_file) && return project_file
        end
        return nothing
    elseif basename(env) in names && safe_isfile(env)
        return env
    end
    return nothing
end

function is_project_folder_in_env(folder, env_manifest, server)
    project_file = Base.env_project_file(folder)
    project_file isa Bool && return false
    folder_proj = parsed_toml(project_file)
    manifest_pe = get(env_manifest, get(folder_proj, "uuid", ""), nothing)
    if manifest_pe === nothing
        return false
    elseif manifest_pe.path !== nothing
        return Base.Filesystem.samefile(manifest_pe.path, folder)
    elseif manifest_pe.tree_hash isa Base.SHA1
        if Base.Filesystem.samefile(abspath(server.depot_path, "packages", folder_proj.name, Base.version_slug(folder_proj.uuid, manifest_pe.tree_hash, 4)), folder)
            return true
        elseif Base.Filesystem.samefile(abspath(server.depot_path, "packages", folder_proj.name, Base.version_slug(folder_proj.uuid, manifest_pe.tree_hash)), folder)
            return true
        end
    end
    return false
end

function get_env_for_root(doc::Document, server::LanguageServerInstance)
    env_proj_file = env_file(server.env_path, project_names)
    env_manifest_file = env_file(server.env_path, manifest_names)

    (safe_isfile(env_proj_file) && safe_isfile(env_manifest_file)) || return

    # Find which workspace folder the doc is in.
    parent_workspaceFolders = sort(filter(f->startswith(doc._path, f), collect(server.workspaceFolders)), by = length, rev = true)

    isempty(parent_workspaceFolders) && return
    # arbitrarily pick one
    parent_workspaceFolder = first(parent_workspaceFolders)

    project_env = env_file(parent_workspaceFolder, project_names)
    try
        if safe_isfile(project_env)
            folder_proj = parsed_toml(project_env)

            # We point to all caches as, though a package may not be directly available (e.g as
            # a dependency) it may still be accessible as imported by one of the direct dependencies.
            symbols = server.global_env.symbols

            # Will want to limit this to only get extended methods from the dependency tree of
            # the project (e.g. using `complete_dep_tree` below)
            extended_methods = server.global_env.extended_methods

            # This is the list of packages that are directly available
            project_deps = Symbol.(collect(keys(get(folder_proj, "deps", []))))
            if isdir(joinpath(parent_workspaceFolder, "test")) && startswith(doc._path, joinpath(parent_workspaceFolder, "test"))
                # We're in the test folder, add the project iteself to the deps
                # This should actually point to the live code (e.g. the relevant EXPR or Scope)?
                haskey(folder_proj, "name") && push!(project_deps, Symbol(folder_proj["name"]))
                for extra in keys(get(folder_proj, "extras", []))
                    if Symbol(extra) in keys(symbols)
                        push!(project_deps, Symbol(extra))
                    end
                end
            end

            StaticLint.ExternalEnv(symbols, extended_methods, project_deps)
        end
    catch err
        # The specified env is faulty (incorrect format, missing entries, ...)
        # We can't do anything about that except treating it the same as a non-existing env,
        # but showing a warning might be useful.
        msg = "The Julia environment at `$project_env` is invalid. Using the global environment instead."
        if server.jr_endpoint !== nothing
            JSONRPC.send(server.jr_endpoint, window_showMessage_notification_type, ShowMessageParams(
                MessageTypes.Warning,
                msg
            ))
        end
        @error msg exception=(err, catch_backtrace())
    end
end

function complete_dep_tree(uuid, env_manifest, alldeps = Dict{Base.UUID,Pkg.Types.PackageEntry}())
    haskey(alldeps, uuid) && return alldeps
    alldeps[uuid] = env_manifest[uuid]
    for dep_uuid in values(alldeps[uuid].deps)
        complete_dep_tree(dep_uuid, env_manifest, alldeps)
    end
    alldeps
end

@testitem "latex completions" begin
    include("../test_shared_server.jl")

    settestdoc("""
    \\therefor
    .\\therefor
    #\\therefor
    "\\therefor"
    \"\"\"\\therefor\"\"\"
    ^\\therefor
    \\:water_buffal
    """)
    @test completion_test(0, 9).items[1].textEdit.newText == "∴"
    @test completion_test(0, 9).items[1].textEdit.range == LanguageServer.Range(0, 0, 0, 9)

    @test completion_test(1, 10).items[1].textEdit.newText == "∴"
    @test completion_test(1, 10).items[1].textEdit.range == LanguageServer.Range(1, 1, 1, 10)

    @test completion_test(2, 10).items[1].textEdit.newText == "∴"
    @test completion_test(2, 10).items[1].textEdit.range == LanguageServer.Range(2, 1, 2, 10)

    @test completion_test(3, 10).items[1].textEdit.newText == "∴"
    @test completion_test(3, 10).items[1].textEdit.range == LanguageServer.Range(3, 1, 3, 10)

    @test completion_test(4, 12).items[1].textEdit.newText == "∴"
    @test completion_test(4, 12).items[1].textEdit.range == LanguageServer.Range(4, 3, 4, 12)

    @test completion_test(5, 10).items[1].textEdit.newText == "∴"
    @test completion_test(5, 10).items[1].textEdit.range == LanguageServer.Range(5, 1, 5, 10)

    @test completion_test(6, 14).items[1].textEdit.newText == "🐃"
    @test completion_test(6, 14).items[1].textEdit.range == LanguageServer.Range(6, 0, 6, 14)
end

@testitem "path completions" begin
end

@testitem "import completions" begin
    include("../test_shared_server.jl")

    settestdoc("import Base: r")
    @test any(item.label == "rand" for item in completion_test(0, 14).items)

    settestdoc("import ")
    @test (r = all(item.label in ("Main", "Base", "Core") for item in completion_test(0, 7).items)) && !isempty(r)

    settestdoc("""module M end
    import .""")
    @test_broken completion_test(1, 8).items[1].label == "M"

    settestdoc("import Base.M")
    @test any(item.label == "Meta" for item in completion_test(0, 13).items)

    settestdoc("import Bas")
    @test any(item.label == "Base" for item in completion_test(0, 10).items)
end

@testitem "getfield completions" begin
    include("../test_shared_server.jl")

    settestdoc("Base.")
    @test length(completion_test(0, 5).items) > 10

    settestdoc("Base.B")
    @test any(item.label == "Base" for item in completion_test(0, 6).items)

    settestdoc("Base.r")
    @test any(item.label == "rand" for item in completion_test(0, 6).items)

    settestdoc("""
    using Base.Meta
    Base.Meta.
    """)
    @test any(item.label == "quot" for item in completion_test(1, 10).items)

    settestdoc("""
    module M
    inner = 1
    end
    M.
    """)
    @test any(item.label == "inner" for item in completion_test(3, 2).items)

    settestdoc("""
    x = Expr()
    x.
    """)
    @test (r = all(item.label in ("head", "args") for item in completion_test(1, 2).items)) && (!isempty(r))

    settestdoc("""
    struct T
        f1
        f2
    end
    x = T()
    x.
    """)
    @test (r = all(item.label in ("f1", "f2") for item in completion_test(5, 2).items)) && !isempty(r)
end

@testitem "token completions" begin
    include("../test_shared_server.jl")

    settestdoc("B")
    @test any(item.label == "Base" for item in completion_test(0, 1).items)

    settestdoc("r")
    @test any(item.label == "rand" for item in completion_test(0, 1).items)

    settestdoc("@t")
    @test any(item.label == "@time" for item in completion_test(0, 2).items)

    settestdoc("i")
    @test any(item.label == "if" for item in completion_test(0, 1).items)

    settestdoc("i")
    @test any(item.label == "in" for item in completion_test(0, 1).items)

    settestdoc("for")
    @test any(item.label == "for" for item in completion_test(0, 3).items)

    settestdoc("in")
    @test any(item.label == "in" for item in completion_test(0, 2).items)

    settestdoc("isa")
    @test any(item.label == "isa" for item in completion_test(0, 3).items)

    # String macros
    settestdoc("uint12")
    @test any(item.label == "uint128\"" for item in completion_test(0, 6).items)
    @test any(item.label == "@uint128_str" for item in completion_test(0, 6).items)

    settestdoc("@uint12")
    @test any(item.label == "@uint128_str" for item in completion_test(0, 7).items)

    settestdoc("""
    macro foobar_str(ex) ex end
    fooba
    """)
    @test any(item.label == "foobar\"" for item in completion_test(1, 5).items)
    @test any(item.label == "@foobar_str" for item in completion_test(1, 5).items)
end

@testitem "scope var completions" begin
    include("../test_shared_server.jl")

    settestdoc("""
    myvar = 1
    βbb = 2
    bβb = 3
    myv
    βb
    bβ
    """)
    @test any(item.label == "myvar" for item in completion_test(3, 3).items)
    @test any(item.label == "βbb" for item in completion_test(4, 2).items)
    @test any(item.label == "bβb" for item in completion_test(5, 2).items)
end

@testitem "completion kinds" begin
    include("../test_shared_server.jl")

    Kinds = LanguageServer.CompletionItemKinds
    # issue #872
    settestdoc("""
        function f(kind_variable_arg)
            kind_variable_local = 1
            kind_variable_
        end
        """)
    items = completion_test(2, 18).items
    @test any(i -> i.label == "kind_variable_local" && i.kind == Kinds.Variable, items)
    @test any(i -> i.label == "kind_variable_arg" && i.kind == Kinds.Variable, items)
end

@testitem "completion details" begin
    include("../test_shared_server.jl")

    settestdoc("""
        struct Bar end
        struct Foo
            xxx::Int
            yyy::Bar
        end
        b = Bar()
        f = Foo(1, b)
        xxx = f.yyy
        f.yy
        xx
        """)
    items1 = completion_test(8, 4).items
    items2 = completion_test(9, 2).items
    @test any(i -> i.label == "yyy" && occursin("yyy::Bar", i.detail), items1)
    @test any(i -> i.label == "xxx" && occursin("xxx::Bar = f.yyy", i.detail), items2)
end

@dict_readable struct ParameterInformationCapabilities <: Outbound
    labelOffsetSupport::Union{Bool,Missing}
end

@dict_readable struct SignatureInformationCapabilities <: Outbound
    documentationFormat::Union{Vector{String},Missing}
    parameterInformation::Union{ParameterInformationCapabilities,Missing}
end

@dict_readable struct SignatureHelpClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    signatureInformation::Union{SignatureInformationCapabilities,Missing}
    contextSupport::Union{Bool,Missing}
end

const SignatureHelpTriggerKind = Int
const SignatureHelpTriggerKinds = (Invoked = 1,
                                   TriggerCharacter = 2,
                                   ContentChange = 3)

struct SignatureHelpOptions <: Outbound
    triggerCharacters::Union{Vector{String},Missing}
    retriggerCharacters::Union{Vector{String},Missing}
end

struct SignatureHelpRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    triggerCharacters::Union{Vector{String},Missing}
    retriggerCharacters::Union{Vector{String},Missing}
end

struct ParameterInformation <: Outbound
    label::Union{String,Tuple{Int,Int}}
    documentation::Union{String,MarkupContent,Missing}
end

struct SignatureInformation <: Outbound
    label::String
    documentation::Union{String,MarkedString,Missing}
    parameters::Union{Vector{ParameterInformation},Missing}
end

struct SignatureHelp <: Outbound
    signatures::Vector{SignatureInformation}
    activeSignature::Union{Int,Missing}
    activeParameter::Union{Int,Missing}
end

@dict_readable struct SignatureHelpContext <: Outbound
    triggerKind::SignatureHelpTriggerKind
    triggerCharacter::Union{String,Missing}
    isRetrigger::Bool
    activeSignatureHelp::Union{SignatureHelp,Missing}
end

@dict_readable struct SignatureHelpParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    context::Union{SignatureHelpContext,Missing}
    workDoneToken::Union{Int,String,Missing} # ProgressToken
end

mutable struct Document
    _path::String
    _text_document::TextDocument
    _open_in_editor::Bool
    _workspace_file::Bool
    cst::EXPR
    diagnostics::Vector{Diagnostic}
    server
    root::Document

    function Document(text_document::TextDocument, workspace_file::Bool, server=nothing)
        path = something(uri2filepath(get_uri(text_document)), "")
        path == "" || isabspath(path) || throw(LSRelativePath("Relative path `$path` is not valid."))
        cst = CSTParser.parse(get_text(text_document), true)
        doc = new(path, text_document, false, workspace_file, cst, [], server)
        set_doc(doc.cst, doc)
        setroot(doc, doc)
        return doc
    end
end

function Base.show(io::IO, ::MIME"text/plain", doc::Document)
    print(io, "Document: ", get_uri(doc))
end

function set_doc(x::EXPR, doc)
    if !StaticLint.hasmeta(x)
        x.meta = StaticLint.Meta()
    end
    x.meta.error = doc
end

function get_path(doc)
    return doc._path
end

function get_text(doc::Document)
    return get_text(doc._text_document)
end

function get_uri(doc::Document)
    return get_uri(doc._text_document)
end

function get_version(doc::Document)
    return get_version(doc._text_document)
end

function get_text_document(doc::Document)
    return doc._text_document
end

function set_text_document!(doc::Document, text_document)
    doc._text_document = text_document
end

function set_open_in_editor(doc::Document, value::Bool)
    doc._open_in_editor = value
end

function get_open_in_editor(doc::Document)
    return doc._open_in_editor
end

function is_workspace_file(doc::Document)
    return doc._workspace_file
end

function set_is_workspace_file(doc::Document, value::Bool)
    doc._workspace_file = value
end

get_language_id(doc::Document) = doc._text_document._language_id

get_offset(doc::Document, line::Integer, character::Integer) = get_offset(doc._text_document, line, character)
get_offset(doc::Document, p::Position) = get_offset(doc, p.line, p.character)
get_offset(doc::Document, r::Range) = get_offset(doc, r.start):get_offset(doc, r.stop)

# get_offset, but correct
get_offset3(args...) = index_at(args...) - 1

index_at(doc::Document, pos, args...) = index_at(doc._text_document, pos, args...)

get_position_from_offset(doc::Document, offset::Integer) = get_position_from_offset(doc._text_document, offset)

Range(doc::Document, rng::UnitRange) = Range(doc._text_document, rng)

include("basic.jl")
include("document.jl")
include("completion.jl")
include("formatting.jl")
include("hover.jl")
include("goto.jl")
include("highlight.jl")
include("signature.jl")
include("symbols.jl")
include("features.jl")
include("configuration.jl")
include("initialize.jl")
include("messagedefs.jl")

const julia_getModuleAt_request_type = JSONRPC.RequestType("julia/getModuleAt", VersionedTextDocumentPositionParams, String)
const julia_getCurrentBlockRange_request_type = JSONRPC.RequestType("julia/getCurrentBlockRange", VersionedTextDocumentPositionParams, Tuple{Position, Position, Position})
const julia_getDocAt_request_type = JSONRPC.RequestType("julia/getDocAt", VersionedTextDocumentPositionParams, String)
const julia_getDocFromWord_request_type = JSONRPC.RequestType("julia/getDocFromWord", NamedTuple{(:word,),Tuple{String}}, String)
const textDocument_publishTests_notification_type = JSONRPC.NotificationType("julia/publishTests", PublishTestsParams)

@testitem "TextDocument" begin
    include("../test_shared_server.jl")

    empty!(server._documents)

    LanguageServer.textDocument_didOpen_notification(LanguageServer.DidOpenTextDocumentParams(LanguageServer.TextDocumentItem(uri"untitled:none", "julia", 0, "")), server, server.jr_endpoint)
    @test LanguageServer.hasdocument(server, uri"untitled:none")

    LanguageServer.textDocument_didOpen_notification(LanguageServer.DidOpenTextDocumentParams(LanguageServer.TextDocumentItem(uri"untitled:none", "julia", 0, "")), server, server.jr_endpoint)
    @test LanguageServer.hasdocument(server, uri"untitled:none")

    LanguageServer.textDocument_didSave_notification(LanguageServer.DidSaveTextDocumentParams(LanguageServer.TextDocumentIdentifier(uri"untitled:none"), ""), server, server.jr_endpoint)

    LanguageServer.textDocument_didChange_notification(LanguageServer.DidChangeTextDocumentParams(LanguageServer.VersionedTextDocumentIdentifier(uri"untitled:none", 0), [LanguageServer.TextDocumentContentChangeEvent(missing, missing, "ran")]), server, server.jr_endpoint)


    LanguageServer.textDocument_didClose_notification(LanguageServer.DidCloseTextDocumentParams(LanguageServer.TextDocumentIdentifier(uri"untitled:none")), server, server.jr_endpoint)
    @test !LanguageServer.hasdocument(server, uri"untitled:none")
end

@testitem "mark errors to end of file" begin
    include("../test_shared_server.jl")

    # Missing a closing ')'
    doc = settestdoc("println(\"Hello, world!\"")
    diagnostics = LanguageServer.mark_errors(doc)
    @test length(diagnostics) == 1
    @test diagnostics[1].range == LanguageServer.Range(0, 23, 0, 23)
end

function textDocument_signatureHelp_request(params::TextDocumentPositionParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    sigs = SignatureInformation[]
    # TODO The following call is just here for diagnostics
    # We currently have crashes in the call to get_offset in crash reporting
    # but they are fairly rare. So the idea here is to see whether we also get_expr
    # crashes in index_at or not. If we still see crashes in get_offset after this here
    # is merged, then the bug is simply in get_offset and we should migrate this function
    # over to use index_at. If not, then there might still be a problem in the sync protocol.
    index_at(get_text_document(doc), params.position)
    offset = get_offset(doc, params.position)
    x = get_expr(getcst(doc), offset)

    sigs = collect_signatures(x, doc, server)

    if (isempty(sigs) || (headof(x) === :RPAREN))
        return SignatureHelp(SignatureInformation[], 0, 0)
    end

    arg = fcall_arg_number(x)

    return SignatureHelp(filter(s -> length(s.parameters) > arg, sigs), 0, arg)
end

function fcall_arg_number(x)
    if headof(x) === :LPAREN
        0
    else
        sum(headof(a) === :COMMA for a in parentof(x).trivia)
    end
end

function collect_signatures(x, doc, server)
    sigs = SignatureInformation[]

    if x isa EXPR && parentof(x) isa EXPR && CSTParser.iscall(parentof(x))
        if CSTParser.isidentifier(parentof(x).args[1])
            call_name = parentof(x).args[1]
        elseif CSTParser.iscurly(parentof(x).args[1]) && CSTParser.isidentifier(parentof(x).args[1].args[1])
            call_name = parentof(x).args[1].args[1]
        elseif CSTParser.is_getfield_w_quotenode(parentof(x).args[1])
            call_name = parentof(x).args[1].args[2].args[1]
        else
            call_name = nothing
        end
        if call_name !== nothing && (f_binding = refof(call_name)) !== nothing && (tls = StaticLint.retrieve_toplevel_scope(call_name)) !== nothing
            get_signatures(f_binding, tls, sigs, getenv(doc, server))
        end
    end

    return sigs
end

function get_signatures(b, tls::StaticLint.Scope, sigs::Vector{SignatureInformation}, env) end

function get_signatures(b::StaticLint.Binding, tls::StaticLint.Scope, sigs::Vector{SignatureInformation}, env)
    if b.val isa StaticLint.Binding
        get_signatures(b.val, tls, sigs, env)
    end
    if b.type == StaticLint.CoreTypes.Function || b.type == StaticLint.CoreTypes.DataType
        b.val isa SymbolServer.SymStore && get_signatures(b.val, tls, sigs, env)
        for ref in b.refs
            method = StaticLint.get_method(ref)
            if method !== nothing
                get_signatures(method, tls, sigs, env)
            end
        end
    end
end

function get_signatures(b::T, tls::StaticLint.Scope, sigs::Vector{SignatureInformation}, env) where T <: Union{SymbolServer.FunctionStore,SymbolServer.DataTypeStore}
    StaticLint.iterate_over_ss_methods(b, tls, env, function (m)
        push!(sigs, SignatureInformation(string(m), "", (a -> ParameterInformation(string(a[1]), string(a[2]))).(m.sig)))
        return false
    end)
end

function get_signatures(x::EXPR, tls::StaticLint.Scope, sigs::Vector{SignatureInformation}, env)
    if CSTParser.defines_function(x)
        sig = CSTParser.rem_where_decl(CSTParser.get_sig(x))
        params = ParameterInformation[]
        if sig isa EXPR && sig.args !== nothing
            for i = 2:length(sig.args)
                if (argbinding = bindingof(sig.args[i])) !== nothing
                    push!(params, ParameterInformation(valof(argbinding.name) isa String ? valof(argbinding.name) : "", missing))
                end
            end
            push!(sigs, SignatureInformation(string(to_codeobject(sig)), "", params))
        end
    elseif CSTParser.defines_struct(x)
        args = x.args[3]
        if length(args) > 0
            if !any(CSTParser.defines_function, args.args)
                params = ParameterInformation[]
                for field in args.args
                    field_name = CSTParser.rem_decl(field)
                    push!(params, ParameterInformation(field_name isa EXPR && CSTParser.isidentifier(field_name) ? valof(field_name) : "", missing))
                end
                push!(sigs, SignatureInformation(string(to_codeobject(x)), "", params))
            end
        end
    end
end

@testitem "Intellisense" begin
    import Pkg, StaticLint
    using LanguageServer.URIs2

    include("test_shared_server.jl")
    
    testtext = """
    module testmodule
    struct testtype
        a
        b::Float64
        c::Vector{Float64}
    end
    function testfunction(a, b::Float64, c::testtype)
        return c
    end
    end
    testmodule
    f(a,b,c) = 1
    f()
    f(1,)
    f(1,2,)
    """
    LanguageServer.textDocument_didOpen_notification(LanguageServer.DidOpenTextDocumentParams(LanguageServer.TextDocumentItem(uri"untitled:testdoc", "julia", 0, testtext)), server, nothing)

    doc = LanguageServer.getdocument(server, uri"untitled:testdoc")
    LanguageServer.parse_all(doc, server)


    res = LanguageServer.textDocument_hover_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(3, 11)), server, nothing)
    @test res.contents.value == string(LanguageServer.sanitize_docstring(StaticLint.CoreTypes.Float64.doc), "\n```julia\nCore.Float64 <: Core.AbstractFloat\n```")

    res = LanguageServer.textDocument_hover_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(7, 12)), server, nothing)
    @test occursin(r"c::testtype", res.contents.value)

    res = LanguageServer.textDocument_hover_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(9, 1)), server, nothing)
    @test res.contents.value == "Closes module definition for `testmodule`\n"

    res = LanguageServer.textDocument_signatureHelp_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(12, 2)), server, nothing)
    @test res.activeParameter == 0

    res = LanguageServer.textDocument_signatureHelp_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(13, 4)), server, nothing)
    @test res.activeParameter == 1

    res = LanguageServer.textDocument_signatureHelp_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(14, 6)), server, nothing)
    @test res.activeParameter == 2
end

"""
    LanguageServerInstance(pipe_in, pipe_out, env="", depot="", err_handler=nothing, symserver_store_path=nothing)

Construct an instance of the language server.

Once the instance is `run`, it will read JSON-RPC from `pipe_out` and
write JSON-RPC from `pipe_in` according to the [language server
specification](https://microsoft.github.io/language-server-protocol/specifications/specification-3-14/).
For normal usage, the language server can be instantiated with
`LanguageServerInstance(stdin, stdout, false, "/path/to/environment")`.

# Arguments
- `pipe_in::IO`: Pipe to read JSON-RPC from.
- `pipe_out::IO`: Pipe to write JSON-RPC to.
- `env::String`: Path to the
  [environment](https://docs.julialang.org/en/v1.2/manual/code-loading/#Environments-1)
  for which the language server is running. An empty string uses julia's
  default environment.
- `depot::String`: Sets the
  [`JULIA_DEPOT_PATH`](https://docs.julialang.org/en/v1.2/manual/environment-variables/#JULIA_DEPOT_PATH-1)
  where the language server looks for packages required in `env`.
- `err_handler::Union{Nothing,Function}`: If not `nothing`, catch all errors and pass them to an error handler
  function with signature `err_handler(err, bt)`. Mostly used for the VS Code crash reporting implementation.
- `symserver_store_path::Union{Nothing,String}`: if `nothing` is passed, the symbol server cash is stored in
  a folder in the package. If an absolute path is passed, the symbol server will store the cache files in that
  path. The path must exist on disc before this is called.
"""
mutable struct LanguageServerInstance
    jr_endpoint::Union{JSONRPC.JSONRPCEndpoint,Nothing}
    workspaceFolders::Set{String}
    _documents::Dict{URI,Document}

    env_path::String
    depot_path::String
    symbol_server::SymbolServer.SymbolServerInstance
    symbol_results_channel::Channel{Any}
    global_env::StaticLint.ExternalEnv
    roots_env_map::Dict{Document,StaticLint.ExternalEnv}
    symbol_store_ready::Bool

    runlinter::Bool
    lint_options::StaticLint.LintOptions
    lint_missingrefs::Symbol
    lint_disableddirs::Vector{String}
    completion_mode::Symbol
    inlay_hints::Bool
    inlay_hints_variable_types::Bool
    inlay_hints_parameter_names::Symbol

    combined_msg_queue::Channel{Any}

    err_handler::Union{Nothing,Function}

    status::Symbol

    number_of_outstanding_symserver_requests::Int
    symserver_use_download::Bool

    current_symserver_progress_token::Union{Nothing,String}

    clientcapability_window_workdoneprogress::Bool
    clientcapability_workspace_didChangeConfiguration::Bool
    # Can probably drop the above 2 and use the below.
    clientCapabilities::Union{ClientCapabilities,Missing}
    clientInfo::Union{InfoParams,Missing}
    initialization_options::Union{Missing,Dict}

    editor_pid::Union{Nothing,Int}
    shutdown_requested::Bool

    workspace::JuliaWorkspace

    function LanguageServerInstance(@nospecialize(pipe_in), @nospecialize(pipe_out), env_path="", depot_path="", err_handler=nothing, symserver_store_path=nothing, download=true, symbolcache_upstream = nothing)
        new(
            JSONRPC.JSONRPCEndpoint(pipe_in, pipe_out, err_handler),
            Set{String}(),
            Dict{URI,Document}(),
            env_path,
            depot_path,
            SymbolServer.SymbolServerInstance(depot_path, symserver_store_path; symbolcache_upstream=symbolcache_upstream),
            Channel(Inf),
            StaticLint.ExternalEnv(deepcopy(SymbolServer.stdlibs), SymbolServer.collect_extended_methods(SymbolServer.stdlibs), collect(keys(SymbolServer.stdlibs))),
            Dict(),
            false,
            true,
            StaticLint.LintOptions(),
            :all,
            LINT_DIABLED_DIRS,
            :qualify, # options: :import or :qualify, anything else turns this off
            true,
            true,
            :literals,
            Channel{Any}(Inf),
            err_handler,
            :created,
            0,
            download,
            nothing,
            false,
            false,
            missing,
            missing,
            missing,
            nothing,
            false,
            JuliaWorkspace()
        )
    end
end
function Base.display(server::LanguageServerInstance)
    println("Root: ", server.workspaceFolders)
    for d in getdocuments_value(server)
        display(d)
    end
end

function hasdocument(server::LanguageServerInstance, uri::URI)
    return haskey(server._documents, uri)
end

function getdocument(server::LanguageServerInstance, uri::URI)
    return server._documents[uri]
end

function getdocuments_key(server::LanguageServerInstance)
    return keys(server._documents)
end

function getdocuments_pair(server::LanguageServerInstance)
    return pairs(server._documents)
end

function getdocuments_value(server::LanguageServerInstance)
    return values(server._documents)
end

function setdocument!(server::LanguageServerInstance, uri::URI, doc::Document)
    server._documents[uri] = doc
end

function deletedocument!(server::LanguageServerInstance, uri::URI)
    doc = getdocument(server, uri)
    StaticLint.clear_meta(getcst(doc))
    delete!(server._documents, uri)

    for d in getdocuments_value(server)
        if getroot(d) === doc
            setroot(d, d)
            semantic_pass(getroot(d))
        end
    end
end

function create_symserver_progress_ui(server)
    if server.clientcapability_window_workdoneprogress
        token = string(uuid4())
        server.current_symserver_progress_token = token
        JSONRPC.send(server.jr_endpoint, window_workDoneProgress_create_request_type, WorkDoneProgressCreateParams(token))

        JSONRPC.send(
            server.jr_endpoint,
            progress_notification_type,
            ProgressParams(token, WorkDoneProgressBegin("Julia", missing, "Starting async tasks...", missing))
        )
    end
end

function destroy_symserver_progress_ui(server)
    if server.clientcapability_window_workdoneprogress && server.current_symserver_progress_token !== nothing
        progress_token = server.current_symserver_progress_token
        server.current_symserver_progress_token = nothing
        JSONRPC.send(
            server.jr_endpoint,
            progress_notification_type,
            ProgressParams(progress_token, WorkDoneProgressEnd(missing))
        )
    end
end

function trigger_symbolstore_reload(server::LanguageServerInstance)
    server.symbol_store_ready = false
    if server.number_of_outstanding_symserver_requests == 0 && server.status == :running
        create_symserver_progress_ui(server)
    end
    server.number_of_outstanding_symserver_requests += 1

    if server.symserver_use_download
        @debug "Will download symbol server caches for this instance."
    end

    @async try
        ssi_ret, payload = SymbolServer.getstore(
            server.symbol_server,
            server.env_path,
            function (msg, percentage=missing)
                if server.clientcapability_window_workdoneprogress && server.current_symserver_progress_token !== nothing
                    msg = ismissing(percentage) ? msg : string(msg, " ($percentage%)")
                    JSONRPC.send(
                        server.jr_endpoint,
                        progress_notification_type,
                        ProgressParams(server.current_symserver_progress_token, WorkDoneProgressReport(missing, msg, missing))
                    )
                end
                @info msg
            end,
            server.err_handler,
            download=server.symserver_use_download
        )

        server.number_of_outstanding_symserver_requests -= 1

        if server.number_of_outstanding_symserver_requests == 0
            destroy_symserver_progress_ui(server)
        end

        if ssi_ret == :success
            push!(server.symbol_results_channel, payload)
        elseif ssi_ret == :failure
            error_payload = Dict(
                "command" => "symserv_crash",
                "name" => "LSSymbolServerFailure",
                "message" => payload === nothing ? "" : String(take!(payload)),
                "stacktrace" => "")
            JSONRPC.send(
                server.jr_endpoint,
                telemetry_event_notification_type,
                error_payload
            )
        elseif ssi_ret == :package_load_crash
            error_payload = Dict(
                "command" => "symserv_pkgload_crash",
                "name" => payload.package_name,
                "message" => payload.stderr === nothing ? "" : String(take!(payload.stderr)))
            JSONRPC.send(
                server.jr_endpoint,
                telemetry_event_notification_type,
                error_payload
            )
        end
        server.symbol_store_ready = true
    catch err
        bt = catch_backtrace()
        if server.err_handler !== nothing
            server.err_handler(err, bt)
        else
            Base.display_error(stderr, err, bt)
        end
    end
end

# Set to true to reload request handler functions with Revise (requires Revise loaded in Main)
const USE_REVISE = Ref(false)

function request_wrapper(func, server::LanguageServerInstance)
    return function (conn, params)
        if server.shutdown_requested
            # it's fine to always return a value here, even for notifications, because
            # JSONRPC discards it anyways in that case
            return JSONRPC.JSONRPCError(
                -32600,
                "LS shutdown was requested.",
                nothing
            )
        end
        if USE_REVISE[] && isdefined(Main, :Revise)
            try
                Main.Revise.revise()
            catch e
                @warn "Reloading with Revise failed" exception = e
            end
            Base.invokelatest(func, params, server, conn)
        else
            func(params, server, conn)
        end
    end
end

"""
    run(server::LanguageServerInstance)

Run the language `server`.
"""
function Base.run(server::LanguageServerInstance; timings = [])
    did_show_timer = Ref(false)
    add_timer_message!(did_show_timer, timings, "LS startup started")

    server.status = :started

    run(server.jr_endpoint)
    @debug "Connected at $(round(Int, time()))"
    add_timer_message!(did_show_timer, timings, "connection established")

    trigger_symbolstore_reload(server)

    poll_editor_pid(server)

    @async try
        @debug "LS: Starting client listener task."
        add_timer_message!(did_show_timer, timings, "(async) listening to client events")
        while true
            msg = JSONRPC.get_next_message(server.jr_endpoint)
            put!(server.combined_msg_queue, (type=:clientmsg, msg=msg))
        end
    catch err
        bt = catch_backtrace()
        if server.err_handler !== nothing
            server.err_handler(err, bt)
        else
            @warn "LS: An error occurred in the client listener task. This may be normal." exception=(err, bt)
        end
    finally
        if isopen(server.combined_msg_queue)
            put!(server.combined_msg_queue, (type=:close,))
            close(server.combined_msg_queue)
        end
        @debug "LS: Client listener task done."
    end
    yield()

    @async try
        @debug "LS: Starting symbol server listener task."
        add_timer_message!(did_show_timer, timings, "(async) listening to symbol server events")
        while true
            msg = take!(server.symbol_results_channel)
            put!(server.combined_msg_queue, (type=:symservmsg, msg=msg))
        end
    catch err
        bt = catch_backtrace()
        if server.err_handler !== nothing
            server.err_handler(err, bt)
        else
            @error "LS: Queue op failed" ex=(err, bt)
        end
    finally
        if isopen(server.combined_msg_queue)
            put!(server.combined_msg_queue, (type=:close,))
            close(server.combined_msg_queue)
        end
        @debug "LS: Symbol server listener task done."
    end
    yield()

    @debug "async tasks started at $(round(Int, time()))"

    msg_dispatcher = JSONRPC.MsgDispatcher()

    msg_dispatcher[textDocument_codeAction_request_type] = request_wrapper(textDocument_codeAction_request, server)
    msg_dispatcher[workspace_executeCommand_request_type] = request_wrapper(workspace_executeCommand_request, server)
    msg_dispatcher[textDocument_completion_request_type] = request_wrapper(textDocument_completion_request, server)
    msg_dispatcher[textDocument_signatureHelp_request_type] = request_wrapper(textDocument_signatureHelp_request, server)
    msg_dispatcher[textDocument_definition_request_type] = request_wrapper(textDocument_definition_request, server)
    msg_dispatcher[textDocument_formatting_request_type] = request_wrapper(textDocument_formatting_request, server)
    msg_dispatcher[textDocument_range_formatting_request_type] = request_wrapper(textDocument_range_formatting_request, server)
    msg_dispatcher[textDocument_references_request_type] = request_wrapper(textDocument_references_request, server)
    msg_dispatcher[textDocument_rename_request_type] = request_wrapper(textDocument_rename_request, server)
    msg_dispatcher[textDocument_prepareRename_request_type] = request_wrapper(textDocument_prepareRename_request, server)
    msg_dispatcher[textDocument_documentSymbol_request_type] = request_wrapper(textDocument_documentSymbol_request, server)
    msg_dispatcher[textDocument_documentHighlight_request_type] = request_wrapper(textDocument_documentHighlight_request, server)
    msg_dispatcher[julia_getModuleAt_request_type] = request_wrapper(julia_getModuleAt_request, server)
    msg_dispatcher[julia_getDocAt_request_type] = request_wrapper(julia_getDocAt_request, server)
    msg_dispatcher[textDocument_hover_request_type] = request_wrapper(textDocument_hover_request, server)
    msg_dispatcher[initialize_request_type] = request_wrapper(initialize_request, server)
    msg_dispatcher[initialized_notification_type] = request_wrapper(initialized_notification, server)
    msg_dispatcher[shutdown_request_type] = request_wrapper(shutdown_request, server)
    msg_dispatcher[cancel_notification_type] = request_wrapper(cancel_notification, server)
    msg_dispatcher[setTrace_notification_type] = request_wrapper(setTrace_notification, server)
    msg_dispatcher[setTraceNotification_notification_type] = request_wrapper(setTraceNotification_notification, server)
    msg_dispatcher[julia_getCurrentBlockRange_request_type] = request_wrapper(julia_getCurrentBlockRange_request, server)
    msg_dispatcher[julia_activateenvironment_notification_type] = request_wrapper(julia_activateenvironment_notification, server)
    msg_dispatcher[textDocument_didOpen_notification_type] = request_wrapper(textDocument_didOpen_notification, server)
    msg_dispatcher[textDocument_didClose_notification_type] = request_wrapper(textDocument_didClose_notification, server)
    msg_dispatcher[textDocument_didSave_notification_type] = request_wrapper(textDocument_didSave_notification, server)
    msg_dispatcher[textDocument_willSave_notification_type] = request_wrapper(textDocument_willSave_notification, server)
    msg_dispatcher[textDocument_willSaveWaitUntil_request_type] = request_wrapper(textDocument_willSaveWaitUntil_request, server)
    msg_dispatcher[textDocument_didChange_notification_type] = request_wrapper(textDocument_didChange_notification, server)
    msg_dispatcher[workspace_didChangeWatchedFiles_notification_type] = request_wrapper(workspace_didChangeWatchedFiles_notification, server)
    msg_dispatcher[workspace_didChangeConfiguration_notification_type] = request_wrapper(workspace_didChangeConfiguration_notification, server)
    msg_dispatcher[workspace_didChangeWorkspaceFolders_notification_type] = request_wrapper(workspace_didChangeWorkspaceFolders_notification, server)
    msg_dispatcher[workspace_symbol_request_type] = request_wrapper(workspace_symbol_request, server)
    msg_dispatcher[julia_refreshLanguageServer_notification_type] = request_wrapper(julia_refreshLanguageServer_notification, server)
    msg_dispatcher[julia_getDocFromWord_request_type] = request_wrapper(julia_getDocFromWord_request, server)
    msg_dispatcher[textDocument_selectionRange_request_type] = request_wrapper(textDocument_selectionRange_request, server)
    msg_dispatcher[textDocument_documentLink_request_type] = request_wrapper(textDocument_documentLink_request, server)
    msg_dispatcher[textDocument_inlayHint_request_type] = request_wrapper(textDocument_inlayHint_request, server)

    # The exit notification message should not be wrapped in request_wrapper (which checks
    # if the server have been requested to be shut down). Instead, this message needs to be
    # handled directly.
    msg_dispatcher[exit_notification_type] = (conn, params) -> exit_notification(params, server, conn)

    @debug "Starting event listener loop at $(round(Int, time()))"
    add_timer_message!(did_show_timer, timings, "starting combined listener")

    while true
        message = take!(server.combined_msg_queue)

        if message.type == :close
            @debug "Shutting down server instance."
            return
        elseif message.type == :clientmsg
            msg = message.msg

            add_timer_message!(did_show_timer, timings, msg)

            JSONRPC.dispatch_msg(server.jr_endpoint, msg_dispatcher, msg)
        elseif message.type == :symservmsg
            @debug "Received new data from Julia Symbol Server."

            server.global_env.symbols = message.msg
            add_timer_message!(did_show_timer, timings, "symbols received")
            server.global_env.extended_methods = SymbolServer.collect_extended_methods(server.global_env.symbols)
            add_timer_message!(did_show_timer, timings, "extended methods computed")
            server.global_env.project_deps = collect(keys(server.global_env.symbols))
            add_timer_message!(did_show_timer, timings, "project deps computed")

            # redo roots_env_map
            for (root, _) in server.roots_env_map
                @debug "resetting get_env_for_root"
                newenv = get_env_for_root(root, server)
                if newenv === nothing
                    delete!(server.roots_env_map, root)
                else
                    server.roots_env_map[root] = newenv
                end
            end
            add_timer_message!(did_show_timer, timings, "env map computed")

            @debug "Linting started at $(round(Int, time()))"

            relintserver(server)

            @debug "Linting finished at $(round(Int, time()))"
            add_timer_message!(did_show_timer, timings, "initial lint done")
        end
    end
end

function relintserver(server)
    roots = Set{Document}()
    documents = getdocuments_value(server)
    for doc in documents
        StaticLint.clear_meta(getcst(doc))
        set_doc(getcst(doc), doc)
    end
    for doc in documents
        # only do a pass on documents once
        root = getroot(doc)
        if !(root in roots)
            if get_language_id(root) in ("julia", "markdown", "juliamarkdown")
                push!(roots, root)
                semantic_pass(root)
            end
        end
    end
    for doc in documents
        if get_language_id(doc) in ("julia", "markdown", "juliamarkdown")
            lint!(doc, server)
        end
    end
end

struct ServerAction
    id::String
    desc::String
    kind::Union{CodeActionKind,Missing}
    preferred::Union{Bool,Missing}
    when::Function
    handler::Function
end

function client_support_action_kind(s::LanguageServerInstance, _::CodeActionKind=CodeActionKinds.Empty)
    if s.clientCapabilities !== missing &&
       s.clientCapabilities.textDocument !== missing &&
       s.clientCapabilities.textDocument.codeAction !== missing &&
       s.clientCapabilities.textDocument.codeAction.codeActionLiteralSupport !== missing
       s.clientCapabilities.textDocument.codeAction.codeActionLiteralSupport.codeActionKind !== missing
        # From the spec of CodeActionKind (https://microsoft.github.io/language-server-protocol/specifications/lsp/3.17/specification/#codeActionClientCapabilities):
        #
        #     The code action kind values the client supports. When this
        #     property exists the client also guarantees that it will
        #     handle values outside its set gracefully and falls back
        #     to a default value when unknown.
        #
        # so we can always return true here(?).
        return true
    else
        return false
    end
end

function client_preferred_support(s::LanguageServerInstance)::Bool
    if s.clientCapabilities !== missing &&
       s.clientCapabilities.textDocument !== missing &&
       s.clientCapabilities.textDocument.codeAction !== missing &&
       s.clientCapabilities.textDocument.codeAction.isPreferredSupport !== missing
       return s.clientCapabilities.textDocument.codeAction.isPreferredSupport
   else
       return false
    end
end

# TODO: All currently supported CodeActions in LS.jl can be converted "losslessly" to
#       Commands but this might not be true in the future so unless the client support
#       literal code actions those need to be filtered out.
function convert_to_command(ca::CodeAction)
    return ca.command
end

function textDocument_codeAction_request(params::CodeActionParams, server::LanguageServerInstance, conn)
    actions = CodeAction[]
    doc = getdocument(server, params.textDocument.uri)
    offset = index_at(doc, params.range.start)
    x = get_expr(getcst(doc), offset)
    arguments = Any[params.textDocument.uri, offset] # use the same arguments for all commands
    if x isa EXPR
        for (_, sa) in LSActions
            if sa.when(x, params)
                kind = sa.kind
                if sa.kind !== missing && sa.kind == CodeActionKinds.SourceOrganizeImports &&
                    server.clientInfo !== missing && occursin("code", lowercase(server.clientInfo.name))
                    # SourceOrganizeImports doesn't show up in the VS Code UI, so make this a
                    # RefactorRewrite instead
                    kind = CodeActionKinds.RefactorRewrite
                end
                action = CodeAction(
                    sa.desc, # title
                    kind,    # kind
                    missing, # diagnostics
                    client_preferred_support(server) ? sa.preferred : missing, # isPreferred
                    missing, # edit
                    Command(sa.desc, sa.id, arguments), # command
                )
                push!(actions, action)
            end
        end
    end
    if client_support_action_kind(server)
        return actions
    else
        # TODO: Future CodeActions might have to be filtered here.
        return convert_to_command.(actions)
    end
end

function workspace_executeCommand_request(params::ExecuteCommandParams, server::LanguageServerInstance, conn)
    if haskey(LSActions, params.command)
        uri = URI(params.arguments[1])
        offset = params.arguments[2]
        doc = getdocument(server, uri)
        x = get_expr(getcst(doc), offset)
        LSActions[params.command].handler(x, server, conn)
    end
end


function find_using_statement(x::EXPR)
    for ref in refof(x).refs
        if StaticLint.is_in_fexpr(ref, x -> headof(x) === :using || headof(x) === :import)
            return parentof(ref)
        end
    end
    return nothing
end

function explicitly_import_used_variables(x::EXPR, server, conn)
    !(refof(x) isa StaticLint.Binding && refof(x).val isa SymbolServer.ModuleStore) && return
    using_stmt = find_using_statement(x)
    using_stmt isa Nothing && return

    tdes = Dict{URI,TextDocumentEdit}()
    vars = Set{String}() # names that need to be imported
    # Find uses of `x` and mark edits
    for ref in refof(x).refs
        if parentof(ref) isa EXPR && CSTParser.is_getfield_w_quotenode(parentof(ref)) && parentof(ref).args[1] == ref
            childname = parentof(ref).args[2].args[1]
            StaticLint.hasref(childname) && refof(childname) isa StaticLint.Binding && continue # check this isn't the name of something being explictly overwritten
            !haskey(refof(x).val.vals, Symbol(valof(childname))) && continue # skip, perhaps mark as missing ref ?

            file, offset = get_file_loc(ref)
            if !haskey(tdes, get_uri(file))
                tdes[get_uri(file)] = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[])
            end
            push!(tdes[get_uri(file)].edits, TextEdit(Range(file, offset .+ (0:parentof(ref).span)), valof(childname)))
            push!(vars, valof(childname))
        end
    end
    isempty(tdes) && return

    # Add `using x: vars...` statement
    if parentof(using_stmt) isa EXPR && (headof(parentof(using_stmt)) === :block || headof(parentof(using_stmt)) === :file)
        # this should cover all cases
        i1 = 0
        for i = 1:length(parentof(using_stmt).args)
            if using_stmt === parentof(using_stmt).args[i]
                i1 = i
                break
            end
        end
        i1 == 0 && return WorkspaceEdit(missing, missing)

        file, offset = get_file_loc(using_stmt)
        insertpos = get_next_line_offset(using_stmt)
        insertpos == -1 && return

        if !haskey(tdes, get_uri(file))
            tdes[get_uri(file)] = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[])
        end
        push!(tdes[get_uri(file)].edits, TextEdit(Range(file, insertpos .+ (0:0)), string("using ", valof(x), ": ", join(vars, ", "), "\n")))
    else
        return
    end

    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, collect(values(tdes)))))
end

is_single_line_func(x) = CSTParser.defines_function(x) && headof(x) !== :function

function expand_inline_func(x, server, conn)
    func = _get_parent_fexpr(x, is_single_line_func)
    length(func) < 3 && return
    sig = func.args[1]
    op = func.head
    body = func.args[2]
    if headof(body) == :block && length(body) == 1
        file, offset = get_file_loc(func)
        tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
            TextEdit(Range(file, offset .+ (0:func.span)), string("function ", get_text(file)[offset .+ (1:sig.span)], "\n    ", get_text(file)[offset + sig.fullspan + op.fullspan .+ (1:body.span)], "\nend"))
        ])
        JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    elseif (headof(body) === :begin || CSTParser.isbracketed(body)) &&
        headof(body.args[1]) === :block && length(body.args[1]) > 0
        file, offset = get_file_loc(func)
        newtext = string("function ", get_text(file)[offset .+ (1:sig.span)])
        blockoffset = offset + sig.fullspan + op.fullspan + body.trivia[1].fullspan
        for i = 1:length(body.args[1].args)
            newtext = string(newtext, "\n    ", get_text(file)[blockoffset .+ (1:body.args[1].args[i].span)])
            blockoffset += body.args[1].args[i].fullspan
        end
        newtext = string(newtext, "\nend")
        tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[TextEdit(Range(file, offset .+ (0:func.span)), newtext)])
        JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    end
end

function is_in_fexpr(x::EXPR, f)
    if f(x)
        return true
    elseif parentof(x) isa EXPR
        return is_in_fexpr(parentof(x), f)
    else
        return false
    end
end

function _get_parent_fexpr(x::EXPR, f)
    if f(x)
        return x
    elseif parentof(x) isa EXPR
        return _get_parent_fexpr(parentof(x), f)
    end
end
function get_next_line_offset(x)
    file, offset = get_file_loc(x)
    # get next line after using_stmt
    insertpos = -1
    line_offsets = get_line_offsets(get_text_document(file))
    for i = 1:length(line_offsets) - 1
        if line_offsets[i] < offset + x.span <= line_offsets[i + 1]
            insertpos = line_offsets[i + 1]
        end
    end
    return insertpos
end

function reexport_package(x::EXPR, server, conn)
    (refof(x) isa SymbolServer.ModuleStore || refof(x).type === StaticLint.CoreTypes.Module || (refof(x).val isa StaticLint.Binding && refof(x).val.type === StaticLint.CoreTypes.Module)) || (refof(x).val isa SymbolServer.ModuleStore) || return
    mod = if refof(x) isa SymbolServer.ModuleStore
        refof(x)
    elseif refof(x).val isa SymbolServer.ModuleStore
        refof(x).val
    else
        return
    end
    using_stmt = parentof(x)
    file, _ = get_file_loc(x)
    insertpos = get_next_line_offset(using_stmt)
    insertpos == -1 && return

    text_document = get_text_document(file)

    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(text_document), get_version(text_document)), TextEdit[
        TextEdit(Range(file, insertpos .+ (0:0)), string("export ", join(sort([string(n) for (n, v) in mod.vals if StaticLint.isexportedby(n, mod)]), ", "), "\n"))
    ])

    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

# TODO move to StaticL  int
# to be called where typof(x) === CSTParser.ModuleH/BareModule
function find_exported_names(x::EXPR)
    exported_vars = EXPR[]
    for i in 1:length(x.args[3].args)
        expr = x.args[3].args[i]
        if headof(expr) === :export
            for j = 2:length(expr)
                if CSTParser.isidentifier(expr.args[j]) && StaticLint.hasref(expr.args[j])
                    push!(exported_vars, expr.args[j])
                end
            end
        end
    end
    return exported_vars
end

function reexport_module(x::EXPR, server, conn)
    using_stmt = parentof(x)
    mod_expr = refof(x).val isa StaticLint.Binding ? refof(x).val.val : refof(x).val
    (mod_expr.args isa Nothing || length(mod_expr.args) < 3 || headof(mod_expr.args[3]) !== :block || mod_expr.args[3].args isa Nothing) && return # module expr without block
    # find export EXPR
    exported_names = find_exported_names(mod_expr)

    isempty(exported_names) && return
    file, _ = get_file_loc(x)
    insertpos = get_next_line_offset(using_stmt)
    insertpos == -1 && return
    names = filter!(s -> !isempty(s), collect(CSTParser.str_value.(exported_names)))
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, insertpos .+ (0:0)), string("export ", join(sort(names), ", "), "\n"))
    ])

    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function wrap_block(x, server, type, conn) end
function wrap_block(x::EXPR, server, type, conn)
    file, offset = get_file_loc(x) # rese
    if type == :if
        tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
            TextEdit(Range(file, offset .+ (0:0)), "if CONDITION\n"),
            TextEdit(Range(file, offset + x.span .+ (0:0)), "\nend")
        ])
    end

    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end


function is_fixable_missing_ref(x::EXPR, cac::CodeActionContext)
    if !isempty(cac.diagnostics) && any(startswith(d.message, "Missing reference") for d::Diagnostic in cac.diagnostics) && CSTParser.isidentifier(x)
        xname = StaticLint.valofid(x)
        tls = StaticLint.retrieve_toplevel_scope(x)
        if tls isa StaticLint.Scope && tls.modules !== nothing
            for m in values(tls.modules)
                if (m isa SymbolServer.ModuleStore && haskey(m, Symbol(xname))) || (m isa StaticLint.Scope && StaticLint.scopehasbinding(m, xname))
                    return true
                end
            end
        end
    end
    return false
end

function applymissingreffix(x, server, conn)
    xname = StaticLint.valofid(x)
    file, offset = get_file_loc(x)
    tls = StaticLint.retrieve_toplevel_scope(x)
    if tls.modules !== nothing
        for (n, m) in tls.modules
            if (m isa SymbolServer.ModuleStore && haskey(m, Symbol(xname))) || (m isa StaticLint.Scope && StaticLint.scopehasbinding(m, xname))
                tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
                    TextEdit(Range(file, offset .+ (0:0)), string(n, "."))
                ])
                JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
                return # TODO: This should probably offer multiple actions instead of just inserting the first hit
            end
        end
    end
end

function remove_farg_name(x, server, conn)
    x1 = StaticLint.get_parent_fexpr(x, x -> StaticLint.haserror(x) && StaticLint.errorof(x) == StaticLint.UnusedFunctionArgument)
    file, offset = get_file_loc(x1)
    if CSTParser.isdeclaration(x1)
        tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
                        TextEdit(Range(file, offset .+ (0:x1.args[1].fullspan)), "")
                    ])
    else
        tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
                        TextEdit(Range(file, offset .+ (0:x1.fullspan)), "_")
                    ])
    end
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function remove_unused_assignment_name(x, _, conn)
    x1 = StaticLint.get_parent_fexpr(x, x -> StaticLint.haserror(x) && StaticLint.errorof(x) == StaticLint.UnusedBinding && x isa EXPR && x.head === :IDENTIFIER)
    file, offset = get_file_loc(x1)
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
                    TextEdit(Range(file, offset .+ (0:x1.span)), "_")
                ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function double_to_triple_equal(x, _, conn)
    x1 = StaticLint.get_parent_fexpr(x, y -> StaticLint.haserror(y) && StaticLint.errorof(y) in (StaticLint.NothingEquality, StaticLint.NothingNotEq))
    file, offset = get_file_loc(x1)
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, offset .+ (0:x1.span)), StaticLint.errorof(x1) == StaticLint.NothingEquality ? "===" : "!==")
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function get_spdx_header(doc::Document)
    # note the multiline flag - without that, we'd try to match the end of the _document_
    # instead of the end of the line.
    m = match(r"(*ANYCRLF)^# SPDX-License-Identifier:\h+((?:[\w\.-]+)(?:\h+[\w\.-]+)*)\h*$"m, get_text(doc))
    return m === nothing ? m : String(m[1])
end

function in_same_workspace_folder(server::LanguageServerInstance, file1::URI, file2::URI)
    file1_str = uri2filepath(file1)
    file2_str = uri2filepath(file2)
    (file1_str === nothing || file2_str === nothing) && return false
    for ws in server.workspaceFolders
        if startswith(file1_str, ws) &&
           startswith(file2_str, ws)
           return true
       end
    end
    return false
end

function identify_short_identifier(server::LanguageServerInstance, file::Document)
    # First look in tracked files (in the same workspace folder) for existing headers
    candidate_identifiers = Set{String}()
    for doc in getdocuments_value(server)
        in_same_workspace_folder(server, get_uri(file), get_uri(doc)) || continue
        id = get_spdx_header(doc)
        id === nothing || push!(candidate_identifiers, id)
    end
    if length(candidate_identifiers) == 1
        return first(candidate_identifiers)
    else
        numerous = iszero(length(candidate_identifiers)) ? "no" : "multiple"
        @warn "Found $numerous candidates for the SPDX header from open files, falling back to LICENSE" Candidates=candidate_identifiers
    end

    # Fallback to looking for a license file in the same workspace folder
    candidate_files = String[]
    for dir in server.workspaceFolders
        for f in joinpath.(dir, ["LICENSE", "LICENSE.md"])
            if in_same_workspace_folder(server, get_uri(file), filepath2uri(f)) && safe_isfile(f)
                push!(candidate_files, f)
            end
        end
    end

    num_candidates = length(candidate_files)
    if num_candidates != 1
        iszero(num_candidates) && @warn "No candidate for licenses found, can't add identifier!"
        num_candidates > 1 && @warn "More than one candidate for licenses found, choose licensing manually!"
        return nothing
    end

    # This is just a heuristic, but should be OK since this is not something automated, and
    # the programmer will see directly if the wrong license is added.
    license_text = read(first(candidate_files), String)

    # Some known different spellings of some licences
    if contains(license_text, r"^\s*MIT\s+(\"?Expat\"?\s+)?Licen[sc]e")
        return "MIT"
    elseif contains(license_text, r"^\s*EUROPEAN\s+UNION\s+PUBLIC\s+LICEN[CS]E\s+v\."i)
        # the first version should be the EUPL version
        version = match(r"\d\.\d", license_text).match
        return "EUPL-$version"
    end

    @warn "A license was found, but could not be identified! Consider adding its licence identifier once to a file manually so that LanguageServer.jl can find it automatically next time." Location=first(candidate_files)
    return nothing
end

function add_license_header(x, server::LanguageServerInstance, conn)
    file, _ = get_file_loc(x)
    # does the current file already have a header?
    get_spdx_header(file) === nothing || return # TODO: Would be nice to check this already before offering the action
    # no, so try to find one
    short_identifier = identify_short_identifier(server, file)
    short_identifier === nothing && return
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, 0:0), "# SPDX-License-Identifier: $(short_identifier)\n\n")
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function organize_import_block(x, _, conn)
    if !StaticLint.is_in_fexpr(x, x -> headof(x) === :using || headof(x) === :import)
        return
    end

    # Collect all sibling blocks that are also using/import expressions
    siblings = EXPR[]
    using_stmt = StaticLint.get_parent_fexpr(x, y -> headof(y) === :using || headof(y) === :import)
    push!(siblings, using_stmt)
    block = using_stmt.parent
    if block !== nothing
        myidx = findfirst(x -> x === using_stmt, block.args)
        # Find older and younger siblings
        for direction in (-1, 1)
            i = direction
            while true
                s = get(block.args, myidx + i, nothing)
                if s isa EXPR && (s.head === :using || s.head === :import)
                    (direction == 1 ? push! : pushfirst!)(siblings, s)
                    i += direction
                else
                    break
                end
            end
        end
    end

    # Collect all modules and symbols
    using_mods = Set{String}()
    using_syms = Dict{String,Set{String}}()
    import_mods = Set{String}()
    import_syms = Dict{String,Set{String}}()

    # Joins e.g. [".", ".", "Foo", "Bar"] (from "using ..Foo.Bar") to "..Foo.Bar"
    function module_join(x)
        io = IOBuffer()
        for y in x.args[1:end-1]
            print(io, y.val)
            y.val == "." && continue
            print(io, ".")
        end
        print(io, x.args[end].val)
        return String(take!(io))
    end

    for s in siblings
        isusing = s.head === :using
        for a in s.args
            if CSTParser.is_colon(a.head)
                mod = module_join(a.args[1])
                set = get!(Set, isusing ? using_syms : import_syms, mod)
                for i in 2:length(a.args)
                    push!(set, join(y.val for y in a.args[i]))
                end
            elseif CSTParser.is_dot(a.head)
                push!(isusing ? using_mods : import_mods, module_join(a))
            else
                error("unreachable?")
            end
        end
    end

    # Rejoin and sort
    # TODO: Currently regular string sorting is used, which roughly will correspond to
    #       BlueStyle (modules, types, ..., functions) since usually CamelCase is used for
    #       modules, types, etc, but possibly this can be improved by using information
    #       available from SymbolServer
    import_lines = String[]
    for m in import_mods
        push!(import_lines, "import " * m)
    end
    for (m, s) in import_syms
        push!(import_lines, "import " * m * ": " * join(sort!(collect(s)), ", "))
    end
    using_lines = String[]
    for m in using_mods
        push!(using_lines, "using " * m)
    end
    for (m, s) in using_syms
        push!(using_lines, "using " * m * ": " * join(sort!(collect(s)), ", "))
    end
    io = IOBuffer()
    join(io, sort!(import_lines), "\n")
    length(import_lines) > 0 && print(io, "\n\n")
    join(io, sort!(using_lines), "\n")
    str_to_fmt = String(take!(io))

    # Format the new string
    # TODO: Fetch user configuration?
    formatted = JuliaFormatter.format_text(str_to_fmt; join_lines_based_on_source=true)

    # Compute range of original blocks
    file, firstoffset = get_file_loc(first(siblings))
    _, lastoffset = get_file_loc(last(siblings))
    lastoffset += last(siblings).span

    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, firstoffset:lastoffset), formatted)
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
end

function is_string_literal(x::EXPR; inraw::Bool=false)
    if headof(x) === :STRING # CSTParser.isstringliteral(x) # TODO: """/raw""" strings not supported yet
        if x.parent isa EXPR && x.parent.head === :string
            # x is part of a string with interpolation
            return false
        end
        # Special handling if the string was found inside a macro
        if x.parent isa EXPR && CSTParser.ismacrocall(x.parent)
            if x.parent.args[1] isa EXPR && headof(x.parent.args[1]) === :IDENTIFIER &&
               endswith(x.parent.args[1].val, "_str") &&
               ncodeunits(x.parent.args[1].val) - ncodeunits("@_str") == x.parent.args[1].span
                # Disable for literal string macros, foo"...", but allow @foo_str "..."
                return inraw ? x.parent.args[1].val == "@raw_str" : false
            elseif x.parent.args[1] isa EXPR && headof(x.parent.args[1]) === :globalrefdoc
                # Disable action for docstrings
                return false
            else
                # Just some other macro, e.g. @show "hello", allow
            end
        end
        return inraw ? false : true
    end
    return false
end

if isdefined(Base, :escape_raw_string)
    using Base: escape_raw_string
else
    # https://github.com/JuliaLang/julia/pull/35309
    function escape_raw_string(io, str::AbstractString)
        escapes = 0
        for c in str
            if c == '\\'
                escapes += 1
            else
                if c == '"'
                    escapes = escapes * 2 + 1
                end
                while escapes > 0
                    write(io, '\\')
                    escapes -= 1
                end
                escapes = 0
                write(io, c)
            end
        end
        while escapes > 0
            write(io, '\\')
            write(io, '\\')
            escapes -= 1
        end
    end
end

function convert_to_raw(x, _, conn)
    is_string_literal(x) || return
    file, offset = get_file_loc(x)
    quotes = headof(x) === :TRIPLESTRING ? "\"\"\"" : "\"" # TODO: """ not supported yet
    raw = string("raw", quotes, sprint(escape_raw_string, valof(x)), quotes)
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, offset .+ (0:x.span)), raw)
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    return nothing
end

function convert_from_raw(x, _, conn)
    is_string_literal(x; inraw = true) || return
    xparent = x.parent
    file, offset = get_file_loc(xparent)
    quotes = headof(x) === :TRIPLESTRING ? "\"\"" : "" # TODO: raw""" not supported yet
    regular = quotes * repr(valof(x)) * quotes
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, offset .+ (0:xparent.span)), regular)
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    return nothing
end

# Checks if parent is a parent/grandparent/... of child
function is_parent_of(parent::EXPR, child::EXPR)
    while child isa EXPR
        if child == parent
            return true
        end
        child = child.parent
    end
    return false
end

function is_in_function_signature(x::EXPR, params; with_docstring=false)
    func = _get_parent_fexpr(x, CSTParser.defines_function)
    func === nothing && return false
    sig = func.args[1]
    if x.head === :FUNCTION || is_parent_of(sig, x)
        hasdoc = func.parent isa EXPR && func.parent.head === :macrocall && func.parent.args[1] isa EXPR &&
                 func.parent.args[1].head === :globalrefdoc
        return with_docstring == hasdoc
    end
    return false
end

function add_docstring_template(x, _, conn)
    is_in_function_signature(x, nothing) || return
    func = _get_parent_fexpr(x, CSTParser.defines_function)
    func === nothing && return
    file, func_offset = get_file_loc(func)
    sig = func.args[1]
    _, sig_offset = get_file_loc(sig)
    docstr = "\"\"\"\n    " * get_text(file)[sig_offset .+ (1:sig.span)] * "\n\nTBW\n\"\"\"\n"
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, func_offset:func_offset), docstr)
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    return
end

function is_in_docstring_for_function(x::EXPR, _)
    return CSTParser.isstringliteral(x) && x.parent isa EXPR && headof(x.parent) === :macrocall &&
       length(x.parent.args) == 4 && x.parent.args[1] isa EXPR &&
       headof(x.parent.args[1]) === :globalrefdoc && CSTParser.defines_function(x.parent.args[4])
end

function update_docstring_sig(x, _, conn)
    if is_in_function_signature(x, nothing; with_docstring=true)
        func = _get_parent_fexpr(x, CSTParser.defines_function)
    elseif is_in_docstring_for_function(x, nothing)
        # The validity of this access is verified in is_in_docstring_for_function
        func = x.parent.args[4]
    else
        return
    end
    # Current docstring
    docstr_expr = func.parent.args[3]
    docstr = valof(docstr_expr)
    file, docstr_offset = get_file_loc(docstr_expr)
    # New signature in the code
    sig = func.args[1]
    _, sig_offset = get_file_loc(sig)
    sig_str = get_text(file)[sig_offset .+ (1:sig.span)]
    # Heuristic for finding a signature in the current docstring
    reg = r"\A    .*$"m
    if (m = match(reg, valof(docstr_expr)); m !== nothing)
        docstr = replace(docstr, reg => string("    ", sig_str))
    else
        docstr = string("    ", sig_str, "\n\n", docstr)
    end
    newline = endswith(docstr, "\n") ? "" : "\n"
    # Rewrap in """"
    docstr = string("\"\"\"\n", docstr, newline, "\"\"\"")
    tde = TextDocumentEdit(VersionedTextDocumentIdentifier(get_uri(file), get_version(file)), TextEdit[
        TextEdit(Range(file, docstr_offset .+ (0:docstr_expr.span)), docstr)
    ])
    JSONRPC.send(conn, workspace_applyEdit_request_type, ApplyWorkspaceEditParams(missing, WorkspaceEdit(missing, TextDocumentEdit[tde])))
    return
end

# Adding a CodeAction requires defining:
# * a unique id
# * a description
# * an action kind (optionally)
# * a function (.when) called on the currently selected expression and parameters of the CodeAction call;
# * a function (.handler) called on three arguments (current expression, server and the jr connection) to implement the command.
const LSActions = Dict{String,ServerAction}()

LSActions["ExplicitPackageVarImport"] = ServerAction(
    "ExplicitPackageVarImport",
    "Explicitly import used package variables.",
    missing,
    missing,
    (x, params) -> refof(x) isa StaticLint.Binding && refof(x).val isa SymbolServer.ModuleStore,
    explicitly_import_used_variables
)

LSActions["ExpandFunction"] = ServerAction(
    "ExpandFunction",
    "Expand function definition.",
    CodeActionKinds.Refactor,
    missing,
    (x, params) -> is_in_fexpr(x, is_single_line_func),
    expand_inline_func,
)

LSActions["FixMissingRef"] = ServerAction(
    "FixMissingRef",
    "Fix missing reference",
    missing,
    missing,
    (x, params) -> is_fixable_missing_ref(x, params.context),
    applymissingreffix,
)

LSActions["ReexportModule"] = ServerAction(
    "ReexportModule",
    "Re-export package variables.",
    missing,
    missing,
    (x, params) -> StaticLint.is_in_fexpr(x, x -> headof(x) === :using || headof(x) === :import) && (refof(x) isa StaticLint.Binding && (refof(x).type === StaticLint.CoreTypes.Module || (refof(x).val isa StaticLint.Binding && refof(x).val.type === StaticLint.CoreTypes.Module) || refof(x).val isa SymbolServer.ModuleStore) || refof(x) isa SymbolServer.ModuleStore),
    reexport_package,
)

LSActions["DeleteUnusedFunctionArgumentName"] = ServerAction(
    "DeleteUnusedFunctionArgumentName",
    "Delete name of unused function argument.",
    CodeActionKinds.QuickFix,
    missing,
    (x, params) -> StaticLint.is_in_fexpr(x, x -> StaticLint.haserror(x) && StaticLint.errorof(x) == StaticLint.UnusedFunctionArgument),
    remove_farg_name,
)

LSActions["ReplaceUnusedAssignmentName"] = ServerAction(
    "ReplaceUnusedAssignmentName",
    "Replace unused assignment name with _.",
    CodeActionKinds.QuickFix,
    missing,
    (x, params) -> StaticLint.is_in_fexpr(x, x -> StaticLint.haserror(x) && StaticLint.errorof(x) == StaticLint.UnusedBinding && x isa EXPR && x.head === :IDENTIFIER),
    remove_unused_assignment_name,
)

LSActions["CompareNothingWithTripleEqual"] = ServerAction(
    "CompareNothingWithTripleEqual",
    "Change ==/!= to ===/!==.",
    CodeActionKinds.QuickFix,
    true,
    (x, _) -> StaticLint.is_in_fexpr(x, y -> StaticLint.haserror(y) && (StaticLint.errorof(y) in (StaticLint.NothingEquality, StaticLint.NothingNotEq))),
    double_to_triple_equal,
)

LSActions["AddLicenseIdentifier"] = ServerAction(
    "AddLicenseIdentifier",
    "Add SPDX license identifier.",
    missing,
    missing,
    (_, params) -> params.range.start.line == 0,
    add_license_header,
)

LSActions["OrganizeImports"] = ServerAction(
    "OrganizeImports",
    "Organize `using` and `import` statements.",
    CodeActionKinds.SourceOrganizeImports,
    missing,
    (x, _) -> StaticLint.is_in_fexpr(x, x -> headof(x) === :using || headof(x) === :import),
    organize_import_block,
)

LSActions["RewriteAsRawString"] = ServerAction(
    "RewriteAsRawString",
    "Rewrite as raw string",
    CodeActionKinds.RefactorRewrite,
    missing,
    (x, _) -> is_string_literal(x),
    convert_to_raw,
)

LSActions["RewriteAsRegularString"] = ServerAction(
    "RewriteAsRegularString",
    "Rewrite as regular string",
    CodeActionKinds.RefactorRewrite,
    missing,
    (x, _) -> is_string_literal(x; inraw=true),
    convert_from_raw,
)

LSActions["AddDocstringTemplate"] = ServerAction(
    "AddDocstringTemplate",
    "Add docstring template for this method",
    missing,
    missing,
    is_in_function_signature,
    add_docstring_template,
)

LSActions["UpdateDocstringSignature"] = ServerAction(
    "UpdateDocstringSignature",
    "Update method signature in docstring",
    missing,
    missing,
    (args...) -> is_in_function_signature(args...; with_docstring=true) || is_in_docstring_for_function(args...),
    update_docstring_sig,
)

struct PublishDiagnosticsParams <: Outbound
    uri::DocumentUri
    version::Union{Int,Missing}
    diagnostics::Vector{Diagnostic}
end

import Base.==
==(x::CompletionItem, y::CompletionItem) = x.label == y.label
==(m1::MarkedString, m2::MarkedString) = m1.language == m2.language && m1.value == m2.value

##############################################################################
# Code Action
const CodeActionKind = String
const CodeActionKinds = (Empty = "",
                         QuickFix = "quickfix",
                         Refactor = "refactor",
                         RefactorExtract = "refactor.extract",
                         RefactorInline = "refactor.inline",
                         RefactorRewrite = "refactor.rewrite",
                         Source = "source",
                         SourceOrganizeImports = "source.organizeImports")

@dict_readable struct CodeActionKindCapabilities
    valueSet::Vector{CodeActionKind}
end

@dict_readable struct CodeActionLiteralCapabilities
    codeActionKind::CodeActionKindCapabilities
end

@dict_readable struct CodeActionClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    codeActionLiteralSupport::Union{CodeActionLiteralCapabilities,Missing}
    isPreferredSupport::Union{Bool,Missing}
end

struct CodeActionOptions <: Outbound
    codeActionKinds::Union{Vector{CodeActionKind},Missing}
    workDoneProgress::Union{Bool,Missing}
end

struct CodeActionRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    codeActionKinds::Union{Vector{CodeActionKind},Missing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct CodeActionContext <: Outbound
    diagnostics::Vector{Diagnostic}
    only::Union{Vector{CodeActionKind},Missing}
end

@dict_readable struct CodeActionParams
    textDocument::TextDocumentIdentifier
    range::Range
    context::CodeActionContext
end

struct CodeAction <: Outbound
    title::String
    kind::Union{CodeActionKind,Missing}
    diagnostics::Union{Vector{Diagnostic},Missing}
    isPreferred::Union{Bool,Missing}
    edit::Union{WorkspaceEdit,Missing}
    command::Union{Command,Missing}
end


##############################################################################
# Code Lens
@dict_readable struct CodeLensClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct CodeLensOptions <: Outbound
    resolveProvider::Union{Bool,Missing}
    workDoneProgress::Union{Bool,Missing}
end

struct CodeLensRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    resolveProvider::Union{Bool,Missing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct CodeLensParams
    textDocument::TextDocumentIdentifier
end

struct CodeLens <: Outbound
    range::Range
    command::Union{Command,Missing}
    data::Union{Any,Missing}
end


##############################################################################
# Document Link Provider
@dict_readable struct DocumentLinkClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    tooltipSupport::Union{Bool,Missing}
end

struct DocumentLinkOptions <: Outbound
    resolveProvider::Union{Bool,Missing}
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentLinkRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    resolveProvider::Union{Bool,Missing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct DocumentLinkParams
    textDocument::TextDocumentIdentifier
    workDoneToken::Union{Int,String,Missing}
    partialResultToken::Union{Int,String,Missing}
end

struct DocumentLink <: Outbound
    range::Range
    target::Union{DocumentUri,Missing}
    tooltip::Union{String,Missing}
    data::Union{Any,Missing}
end

##############################################################################
# Document Colour

@dict_readable struct DocumentColorClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct DocumentColorOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentColorRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    id::Union{String,Missing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct DocumentColorParams <: Outbound
    textDocument::TextDocumentIdentifier
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

struct Color <: Outbound
    red::Float64
    green::Float64
    blue::Float64
    alpha::Float64
end

struct ColorInformation <: Outbound
    range::Range
    color::Color
end

@dict_readable struct ColorPresentationParams
    textDocument::TextDocumentIdentifier
    color::Color
    range::Range
end

struct ColorPresentaiton <: Outbound
    label::String
    textEdit::Union{TextEdit,Missing}
    additionalTextEdits::Union{Vector{TextEdit},Missing}
end

##############################################################################
# Formatting


##############################################################################
# Rename

@dict_readable struct RenameClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    prepareSupport::Union{Bool,Missing}
end

struct RenameOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    prepareProvider::Union{Bool,Missing}
end

struct RenameRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
    prepareProvider::Union{Bool,Missing}
end

@dict_readable struct RenameParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    newName::String
end

@dict_readable struct PrepareRenameParams
    textDocument::TextDocumentIdentifier
    position::Position
end


##############################################################################
# Folding
const FoldingRangeKind = String
const FoldingRangeKinds = (Comment = "comment",
                           Imports = "imports",
                           Region = "region")

@dict_readable struct FoldingRangeClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    rangeLimit::Union{Int,Missing}
    lineFoldingOnly::Union{Bool,Missing}
end

struct FoldingRangeOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct FoldingRangeRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
    id::Union{String,Missing}
end

@dict_readable struct FoldingRangeParams <: Outbound
    textDocument::TextDocumentIdentifier
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

struct FoldingRange <: Outbound
    startLine::Int
    startCharacter::Union{Int,Missing}
    endLine::Int
    endCharacter::Union{Int,Missing}
    kind::Union{FoldingRangeKind,Missing}
end

##############################################################################
# Selection Range
@dict_readable struct SelectionRangeClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct SelectionRangeOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct SelectionRangeRegistrationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    documentSelector::Union{DocumentSelector,Nothing}
    id::Union{String,Missing}
end

@dict_readable struct SelectionRangeParams <: Outbound
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
    textDocument::TextDocumentIdentifier
    positions::Vector{Position}
end

struct SelectionRange <: Outbound
    range::Range
    parent::Union{SelectionRange,Missing}
end


##############################################################################
# Execute command
@dict_readable struct ExecuteCommandClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct ExecuteCommandOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    commands::Vector{String}
end

mutable struct ExecuteCommandRegistrationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    commands::Vector{String}
end

@dict_readable struct ExecuteCommandParams <: Outbound
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    command::String
    arguments::Union{Vector{Any},Missing}
end

##############################################################################
# inlay hints
@dict_readable struct InlayHintOptions <: Outbound
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    resolveProvider::Bool
end

@dict_readable struct InlayHintRegistrationOptions <: Outbound
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    resolveProvider::Bool # InlayHintOptions
    id::Union{Missing, String} # StaticRegistrationOptions
    documentSelector::Union{Nothing, DocumentSelector} # TextDocumentRegistrationOptions
end

@dict_readable struct InlayHintParams <: Outbound
    textDocument::TextDocumentIdentifier
    range::Range
    workDoneToken::Union{Int,String,Missing} # ProgressToken
end

@dict_readable struct InlayHintLabelPart <: Outbound
    value::String
    tooltip::Union{Missing, String, MarkupContent}
    location::Union{Missing, Location}
    command::Union{Missing, Command}
end

const InlayHintKind = Int
const InlayHintKinds = (
    Type = 1,
    Parameter = 2
)

@dict_readable struct InlayHint <: Outbound
    position::Position
    label::Union{String, Vector{InlayHintLabelPart}}
    kind::Union{Missing, InlayHintKind}
    textEdits::Union{Missing, Vector{TextEdit}}
    tooltip::Union{Missing, String, MarkupContent}
    paddingLeft::Union{Missing, Bool}
    paddingRight::Union{Missing, Bool}
    data::Union{Missing, Any}
end

##############################################################################

struct ApplyWorkspaceEditParams <: Outbound
    label::Union{String,Missing}
    edit::WorkspaceEdit
end

@dict_readable struct ApplyWorkspaceEditResponse <: Outbound
    applied::Bool
    failureReason::Union{String,Missing}
end

@testitem "document 1" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document, set_open_in_editor, is_workspace_file, get_open_in_editor, get_position_from_offset, get_text_document, get_line_offsets, get_offset, get_text

    s1 = """
    123456
    abcde
    ABCDEFG
    """
    d1 = Document(TextDocument(uri"untitled:none", s1, 0), false)
    @test get_text(d1) == s1
    @test get_offset(d1, 0, 4) == 4
    @test get_offset(d1, 1, 2) == 9
    @test get_line_offsets(get_text_document(d1)) == [0, 7, 13, 21]
    @test get_position_from_offset(d1, 1) == (0, 1)
    @test get_position_from_offset(d1, 8) == (1, 1)
    @test get_position_from_offset(d1, 15) == (2, 2)
    @test get_open_in_editor(d1) == false
    set_open_in_editor(d1, true)
    @test get_open_in_editor(d1) == true
    set_open_in_editor(d1, false)
    @test get_open_in_editor(d1) == false
    @test is_workspace_file(d1) == false
end

@testitem "document 2" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document, get_text_document, set_text_document!, Range, apply_text_edits, get_line_offsets, is_workspace_file, get_position_from_offset, get_offset

    s2 = """
    12μ456
    abηde
    ABCDEFG"""
    d2 = Document(TextDocument(uri"untitled:none", s2, 0), true)
    @test get_offset(d2, 0, 4) == 5
    @test get_offset(d2, 1, 2) == 10
    @test get_line_offsets(get_text_document(d2)) == [0, 8, 15]
    @test get_position_from_offset(d2, 1) == (0, 1)
    @test get_position_from_offset(d2, 9) == (1, 1)
    @test get_position_from_offset(d2, 17) == (2, 2)
    @test is_workspace_file(d2) == true


    set_text_document!(d2, apply_text_edits(get_text_document(d2), [LanguageServer.TextDocumentContentChangeEvent(Range(1), 0, "12")], 1))
    @test get_line_offsets(get_text_document(d2)) == [0, 8, 17]
end

@testitem "document 3" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document

    s4 = "1234\r\nabcd"
    d4 = Document(TextDocument(uri"untitled:none", s4, 0), false)
    @test_broken get_line_offsets(get_text_document(d4)) == [0, 5]
end

@testitem "document 4" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document, get_line_offsets, get_text_document

    s5 = "1234\nabcd\n"
    d5 = Document(TextDocument(uri"untitled:none", s5, 0), false)
    @test get_line_offsets(get_text_document(d5)) == [0, 5, 10]
end

@testitem "document 5" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document, get_line_offsets, get_text_document

    s6 = "\n"
    d6 = Document(TextDocument(uri"untitled:none", s6, 0), false)
    @test get_line_offsets(get_text_document(d6)) == [0,1]
end

@testitem "apply_text_edits" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, TextDocumentContentChangeEvent, Range, Position, apply_text_edits, LSOffsetError, apply_text_edits, get_text

    version = 0
    doc = TextDocument(uri"file:///example/path/example.jl", "function foo()", version)
    c1 = TextDocumentContentChangeEvent(Range(Position(0, 14), Position(0, 14)), 0, "\n")
    c2 = TextDocumentContentChangeEvent(Range(Position(1, 0), Position(1, 0)), 0, "    ")
    c3 = TextDocumentContentChangeEvent(missing, missing, "println(\"Hello World\")")

    doc = apply_text_edits(doc, [c1], version += 1)
    @test get_text(doc) == "function foo()\n"
    # Implicitly test for issue #403
    doc = apply_text_edits(doc, [c2], version += 1)
    @test get_text(doc) == "function foo()\n    "
    doc = apply_text_edits(doc, [c3], version += 1)
    @test get_text(doc) == "println(\"Hello World\")"

    # Test muliple edits (#1118)
    doc = TextDocument(uri"file:///example/path/example.jl", "module Crash\n\n\n\nend # module Crash\n", version)
    edits = [
        TextDocumentContentChangeEvent(Range(Position(2, 0), Position(2, 0)), 0, "p"),
        TextDocumentContentChangeEvent(Range(Position(2, 1), Position(2, 1)), 0, "r"),
        TextDocumentContentChangeEvent(Range(Position(2, 2), Position(2, 2)), 0, "i"),
        TextDocumentContentChangeEvent(Range(Position(2, 3), Position(2, 3)), 0, "n"),
        TextDocumentContentChangeEvent(Range(Position(2, 4), Position(2, 4)), 0, "t"),
    ]
    doc = apply_text_edits(doc, edits, version += 1)
    @test get_text(doc) == "module Crash\n\nprint\n\nend # module Crash\n"

    # doc currently has only one line, applying change to 2nd line should throw
    doc = apply_text_edits(doc, [c3], version += 1)
    @test_throws LSOffsetError apply_text_edits(doc, [c2], version + 1)
end

@testitem "UTF16 handling" begin
    using LanguageServer.URIs2
    using LanguageServer: TextDocument, Document

    doc = LanguageServer.Document(TextDocument(uri"", "aaa", 0), false)
    @test sizeof(LanguageServer.get_text(doc)) == 3
    @test LanguageServer.get_offset(doc, 0, 0) == 0
    @test LanguageServer.get_position_from_offset(doc, 0) == (0, 0)
    @test LanguageServer.get_offset(doc, 0, 1) == 1
    @test LanguageServer.get_position_from_offset(doc, 1) == (0, 1)
    @test LanguageServer.get_offset(doc, 0, 2) == 2
    @test LanguageServer.get_position_from_offset(doc, 2) == (0, 2)
    @test LanguageServer.get_offset(doc, 0, 3) == 3
    @test LanguageServer.get_position_from_offset(doc, 3) == (0, 3)


    doc = LanguageServer.Document(TextDocument(uri"", "ααα", 0), false)
    @test sizeof(LanguageServer.get_text(doc)) == 6
    @test LanguageServer.get_offset(doc, 0, 0) == 0
    @test LanguageServer.get_position_from_offset(doc, 0) == (0, 0)
    @test LanguageServer.get_offset(doc, 0, 1) == 1
    @test LanguageServer.get_position_from_offset(doc, 1) == (0, 1)
    @test LanguageServer.get_offset(doc, 0, 2) == 3
    @test LanguageServer.get_position_from_offset(doc, 3) == (0, 2)
    @test LanguageServer.get_offset(doc, 0, 3) == 5
    @test LanguageServer.get_position_from_offset(doc, 5) == (0, 3)

    doc = LanguageServer.Document(TextDocument(uri"", "ࠀࠀࠀ", 0), false) # 0x0800
    @test sizeof(LanguageServer.get_text(doc)) == 9
    @test LanguageServer.get_offset(doc, 0, 0) == 0
    @test LanguageServer.get_position_from_offset(doc, 0) == (0, 0)
    @test LanguageServer.get_offset(doc, 0, 1) == 1
    @test LanguageServer.get_position_from_offset(doc, 1) == (0, 1)
    @test LanguageServer.get_offset(doc, 0, 2) == 4
    @test LanguageServer.get_position_from_offset(doc, 4) == (0, 2)
    @test LanguageServer.get_offset(doc, 0, 3) == 7
    @test LanguageServer.get_position_from_offset(doc, 7) == (0, 3)

    doc = LanguageServer.Document(TextDocument(uri"", "𐐀𐐀𐐀", 0), false)
    @test sizeof(LanguageServer.get_text(doc)) == 12
    @test LanguageServer.get_offset(doc, 0, 0) == 0
    @test LanguageServer.get_position_from_offset(doc, 0) == (0, 0)
    @test LanguageServer.get_offset(doc, 0, 2) == 1
    @test LanguageServer.get_position_from_offset(doc, 1) == (0, 2)
    @test LanguageServer.get_offset(doc, 0, 4) == 5
    @test LanguageServer.get_position_from_offset(doc, 5) == (0, 4)
    @test LanguageServer.get_offset(doc, 0, 6) == 9
    @test LanguageServer.get_position_from_offset(doc, 9) == (0, 6)

    doc = LanguageServer.Document(TextDocument(uri"", "𐀀𐀀𐀀", 0), false) # 0x010000
    @test sizeof(LanguageServer.get_text(doc)) == 12
    @test LanguageServer.get_offset(doc, 0, 0) == 0
    @test LanguageServer.get_position_from_offset(doc, 0) == (0, 0)
    @test LanguageServer.get_offset(doc, 0, 2) == 1
    @test LanguageServer.get_position_from_offset(doc, 1) == (0, 2)
    @test LanguageServer.get_offset(doc, 0, 4) == 5
    @test LanguageServer.get_position_from_offset(doc, 5) == (0, 4)
    @test LanguageServer.get_offset(doc, 0, 6) == 9
    @test LanguageServer.get_position_from_offset(doc, 9) == (0, 6)
end

@testitem "document link provider" begin
    using LanguageServer: TextDocument, Document, filepath2uri, DocumentLink, getcst, find_document_links

    doc = Document(TextDocument(filepath2uri(@__FILE__), """
    include("test_document.jl")
    include("runtests_does_not_exist.jl")
    """, 0), false)
    links = DocumentLink[]
    find_document_links(getcst(doc), doc, 0, links)
    @test length(links) == 1
    @test links[1].target == filepath2uri(@__FILE__)
end

@testitem "Base.show for (Text)Document" begin
    using LanguageServer: TextDocument

    tdoc = TextDocument(LanguageServer.URIs2.URI("file:///tmp/foo.jl"), "foo", 0)
    @test sprint(show, MIME("text/plain"), tdoc) == "TextDocument: file:///tmp/foo.jl"
    doc = LanguageServer.Document(tdoc, false)
    @test sprint(show, MIME("text/plain"), doc) == "Document: file:///tmp/foo.jl"
end

"""
    runserver(pipe_in=stdin, pipe_out=stdout[, env_path])

Run a `LanguageServerInstance` reading from `pipe_in` and writing to `pipe_out`.

The same options can be passed to `runserver` as to
[`LanguageServerInstance`](@ref). If `env_path` is not specified,
attempt to pick an environment by considering in order of priority:

1. [`ARGS`[1]](@ref): the first command-line argument passed to the
   invocation of `julia`.
2. The Julia project containing [`pwd()`](@ref).
3. The default Julia environment withing `.julia/environments/v#.#`.

# Examples

The following invocation of Julia would set `env_path` to
`/home/example/repos/Example.jl`:

```sh
julia --project=/path/to/LanguageServer.jl \\
  -e "using LanguageServer; runserver()" \\
  /home/example/repos/Example.jl
```

If there was a `Project.toml` or `JuliaProject.toml` in
`/home/example/repos/Example.jl/`, the following invocation would set
`env_path` to `/home/example/repos/Example.jl/`; otherwise it would be
set to `.julia/environments/v#.#` where `v#.#` is the major/minor
version of Julia being invoked.

```sh
julia --project=/path/to/LanguageServer.jl \\
  -e "using LanguageServer; runserver()"
```
"""
function runserver(@nospecialize(pipe_in)=stdin, pipe_out=stdout, env_path=choose_env(),
                   depot_path="", err_handler=nothing, symserver_store_path=nothing)
    server = LanguageServerInstance(pipe_in, pipe_out, env_path, depot_path,
                                    err_handler, symserver_store_path)
    run(server)
end

function choose_env()
    maybe_dirname = x -> x !== nothing ? dirname(x) : nothing
    something(get(ARGS, 1, nothing),                            # 1. path passed explicitly
              maybe_dirname(Base.current_project(pwd())),       # 2. parent project of pwd()
              maybe_dirname(Base.load_path_expand("@v#.#")))    # 3. default "global" env
end

##############################################################################
# From client
const FailureHandlingKind = String
const FailureHandlingKinds = (Abort = "abort",
                              Transactional = "transactional",
                              TextOnlyTransactional = "textOnlyTransactional",
                              Undo = "undo")

const ResourceOperationKind = String
const ResourceOperationKinds = (Create = "create",
                                Rename = "rename",
                                Delete = "delete")

@dict_readable struct WorkspaceEditClientCapabilities <: Outbound
    documentChanges::Union{Bool,Missing}
    resourceOperations::Union{Vector{ResourceOperationKind},Missing}
    failureHandling::Union{FailureHandlingKind,Missing}
end

@dict_readable struct DidChangeConfigurationClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

@dict_readable struct DidChangeWatchedFilesClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

@dict_readable struct WorkspaceClientCapabilities <: Outbound
    applyEdit::Union{Bool,Missing}
    workspaceEdit::Union{WorkspaceEditClientCapabilities,Missing}
    didChangeConfiguration::Union{DidChangeConfigurationClientCapabilities,Missing}
    didChangeWatchedFiles::Union{DidChangeWatchedFilesClientCapabilities,Missing}
    symbol::Union{WorkspaceSymbolClientCapabilities,Missing}
    executeCommand::Union{ExecuteCommandClientCapabilities,Missing}
    workspaceFolders::Union{Bool,Missing}
    configuration::Union{Bool,Missing}
end

@dict_readable struct TextDocumentSyncClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    willSave::Union{Bool,Missing}
    willSaveWaitUntil::Union{Bool,Missing}
    didSave::Union{Bool,Missing}
end


@dict_readable struct TagClientCapabilities
    valueSet::Vector{DiagnosticTag}
end

@dict_readable struct PublishDiagnosticsClientCapabilities <: Outbound
    relatedInformation::Union{Bool,Missing}
    tagSupport::Union{TagClientCapabilities,Missing}
    versionSupport::Union{Bool,Missing}
end

@dict_readable struct TextDocumentClientCapabilities <: Outbound
    synchronization::Union{TextDocumentSyncClientCapabilities,Missing}
    completion::Union{CompletionClientCapabilities,Missing}
    hover::Union{HoverClientCapabilities,Missing}
    signatureHelp::Union{SignatureHelpClientCapabilities,Missing}
    declaration::Union{DeclarationClientCapabilities,Missing}
    definition::Union{DefinitionClientCapabilities,Missing}
    typeDefinition::Union{TypeDefinitionClientCapabilities,Missing}
    implementation::Union{ImplementationClientCapabilities,Missing}
    references::Union{ReferenceClientCapabilities,Missing}
    documentHighlight::Union{DocumentHighlightClientCapabilities,Missing}
    documentSymbol::Union{DocumentSymbolClientCapabilities,Missing}
    codeAction::Union{CodeActionClientCapabilities,Missing}
    codeLens::Union{CodeLensClientCapabilities,Missing}
    documentLink::Union{DocumentLinkClientCapabilities,Missing}
    colorProvider::Union{DocumentColorClientCapabilities,Missing}
    formatting::Union{DocumentFormattingClientCapabilities,Missing}
    rangeFormatting::Union{DocumentRangeFormattingClientCapabilities,Missing}
    onTypeFormatting::Union{DocumentOnTypeFormattingClientCapabilities,Missing}
    rename::Union{RenameClientCapabilities,Missing}
    publishDiagnostics::Union{PublishDiagnosticsClientCapabilities,Missing}
    foldingRange::Union{FoldingRangeClientCapabilities,Missing}
    selectionRange::Union{SelectionRangeClientCapabilities,Missing}
end

@dict_readable struct WindowClientCapabilities <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct ClientCapabilities <: Outbound
    workspace::Union{WorkspaceClientCapabilities,Missing}
    textDocument::Union{TextDocumentClientCapabilities,Missing}
    window::Union{WindowClientCapabilities,Missing}
    experimental::Union{Any,Missing}
end
@dict_readable struct InfoParams <: Outbound
    name::String
    version::Union{String,Missing}
end

struct InitializeParams <: Outbound
    processId::Union{Int,Nothing}
    clientInfo::Union{InfoParams,Missing}
    rootPath::Union{String,Nothing,Missing}
    rootUri::Union{DocumentUri,Nothing}
    initializationOptions::Union{Any,Missing}
    capabilities::ClientCapabilities
    trace::Union{String,Missing}
    workspaceFolders::Union{Vector{WorkspaceFolder},Nothing,Missing}
    workDoneToken::Union{Int,String,Missing} # ProgressToken
end

# Requires handwritten implementaiton to account for 3-part Unions
function InitializeParams(dict::Dict)
    InitializeParams(dict["processId"],
    haskey(dict, "clientInfo") ? InfoParams(dict["clientInfo"]) : missing,
    !haskey(dict, "rootPath") ? missing : dict["rootPath"],
    # LS specification says this key should always exist, but neovim 0.5.1 doesn't seem to
    # send it (seems fixed in neovim 0.6). For now, just assume it might not exist here.
    (rootUri = get(dict, "rootUri", nothing); rootUri === nothing) ? nothing : DocumentUri(rootUri),
    get(dict, "initializationOptions", missing),
    ClientCapabilities(dict["capabilities"]),
    haskey(dict, "trace") ? String(dict["trace"]) : missing ,
    !haskey(dict, "workspaceFolders") ? missing : dict["workspaceFolders"] === nothing ? nothing : WorkspaceFolder.(dict["workspaceFolders"]),
    haskey(dict, "workDoneToken") ? dict["workDoneToken"] : missing)
end
##############################################################################




##############################################################################
# Server Response
struct SaveOptions <: Outbound
    includeText::Union{Bool,Missing}
end

struct ColorProviderOptions <: Outbound end

const TextDocumentSyncKind = Int
const TextDocumentSyncKinds = (None = 0,
                               Full = 1,
                               Incremental = 2)

struct TextDocumentSyncOptions <: Outbound
    openClose::Union{Bool,Missing}
    change::Union{TextDocumentSyncKind,Missing}
    willSave::Union{Bool,Missing}
    willSaveWaitUntil::Union{Bool,Missing}
    save::Union{SaveOptions,Missing}
end

struct WorkspaceFoldersOptions <: Outbound
    supported::Union{Bool,Missing}
    changeNotifications::Union{Bool,String,Missing}
end

struct WorkspaceOptions <: Outbound
    workspaceFolders::Union{WorkspaceFoldersOptions,Missing}
end

struct WorkspaceFoldersServerCapabilities <: Outbound
    supported::Union{Bool,Missing}
    changeNotifications::Union{String,Bool,Missing}
end

struct ServerCapabilities <: Outbound
    textDocumentSync::Union{TextDocumentSyncOptions,Int,Missing}
    completionProvider::Union{CompletionOptions,Missing}
    hoverProvider::Union{Bool,HoverOptions,Missing}
    signatureHelpProvider::Union{SignatureHelpOptions,Missing}
    declarationProvider::Union{Bool,DeclarationOptions,DeclarationRegistrationOptions,Missing}
    definitionProvider::Union{Bool,DefinitionOptions,Missing}
    typeDefinitionProvider::Union{Bool,TypeDefinitionOptions,TypeDefinitionRegistrationOptions,Missing}
    implementationProvider::Union{Bool,ImplementationOptions,ImplementationRegistrationOptions,Missing}
    referencesProvider::Union{Bool,ReferenceOptions,Missing}
    documentHighlightProvider::Union{Bool,DocumentHighlightOptions,Missing}
    documentSymbolProvider::Union{Bool,DocumentSymbolOptions,Missing}
    codeActionProvider::Union{Bool,CodeActionOptions,Missing}
    codeLensProvider::Union{CodeLensOptions,Missing}
    documentLinkProvider::Union{DocumentLinkOptions,Missing}
    colorProvider::Union{Bool,DocumentColorOptions,DocumentColorRegistrationOptions,Missing}
    documentFormattingProvider::Union{Bool,DocumentFormattingOptions,Missing}
    documentRangeFormattingProvider::Union{Bool,DocumentRangeFormattingOptions,Missing}
    documentOnTypeFormattingProvider::Union{DocumentOnTypeFormattingOptions,Missing}
    renameProvider::Union{Bool,RenameOptions,Missing}
    foldingRangeProvider::Union{Bool,FoldingRangeOptions,FoldingRangeRegistrationOptions,Missing}
    executeCommandProvider::Union{ExecuteCommandOptions,Missing}
    selectionRangeProvider::Union{Bool,SelectionRangeOptions,SelectionRangeRegistrationOptions,Missing}
    inlayHintProvider::Union{Bool,InlayHintOptions,InlayHintRegistrationOptions}
    workspaceSymbolProvider::Union{Bool,Missing}
    workspace::Union{WorkspaceOptions,Missing}
    experimental::Union{Any,Missing}
end

struct InitializeResult <: Outbound
    capabilities::ServerCapabilities
    serverInfo::Union{InfoParams,Missing}
end

##############################################################################
@dict_readable struct InitializedParams
end

import StaticLint: hasfile, canloadfile, loadfile, setfile, getfile, getsymbols, getsymbolextendeds, getenv
import StaticLint: getpath, getroot, setroot, getcst, setcst, semantic_pass, getserver, setserver
hasfile(server::LanguageServerInstance, path::String) = !isempty(path) && hasdocument(server, filepath2uri(path))
function canloadfile(server::LanguageServerInstance, path::String)
    try
        return !isempty(path) && safe_isfile(path)
    catch err
        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        return false
    end
end
function loadfile(server::LanguageServerInstance, path::String)
    source = try
        s = read(path, String)
        our_isvalid(s) || return
        s
    catch err
        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        return
    end
    uri = filepath2uri(path)
    doc = Document(TextDocument(uri, source, 0), true, server)
    StaticLint.setfile(server, path, doc)
end
function setfile(server::LanguageServerInstance, path::String, x::Document)
    uri = filepath2uri(path)
    if hasdocument(server, uri)
        error("StaticLint should not try to set documents that are already tracked.")
    end

    setdocument!(server, uri, x)
end
getfile(server::LanguageServerInstance, path::String) = getdocument(server, filepath2uri(path))

function getenv(doc::Document, server::LanguageServerInstance)
    get(server.roots_env_map, doc.root, server.global_env)
end
getenv(doc::Document) = getenv(doc, doc.server)
getenv(server::LanguageServerInstance) = server.global_env

getpath(d::Document) = d._path

getroot(d::Document) = d.root
function setroot(doc::Document, root::Document)
    if isdefined(doc, :root) && doc == doc.root && root !== doc
        # doc is being unset as a root - remove ExternalEnv if there is one
        if doc.server isa LanguageServerInstance && haskey(doc.server.roots_env_map, doc)
            delete!(doc.server.roots_env_map, doc)
        end
    end
    doc.root = root
    if doc == root && doc.server isa LanguageServerInstance
        # doc is being set as it's own root, lets find
        extenv = get_env_for_root(doc, doc.server)
        if extenv !== nothing
            doc.server.roots_env_map[doc] = extenv
        end
    end
    return doc
end

getcst(d::Document) = d.cst
function setcst(d::Document, cst::EXPR)
    d.cst = cst
    return d
end

getserver(file::Document) = file.server
function setserver(file::Document, server::LanguageServerInstance)
    file.server = server
    return file
end

function lint!(doc::Document, server)
    StaticLint.check_all(getcst(doc), server.lint_options, getenv(doc, server))
    empty!(doc.diagnostics)
    mark_errors(doc, doc.diagnostics)
    # TODO Ideally we would not want to acces jr_endpoint here
    publish_diagnostics(doc, server, server.jr_endpoint)

    find_tests!(doc, server, server.jr_endpoint)
end

@testitem "filepath2uri to string" begin
    using LanguageServer.URIs2

    # TODO Remove this Windows flag later, it is not in the original, but we need support for relative paths first
    if Sys.iswindows()
        @test filepath2uri("c:/win/path") |> string == "file:///c%3A/win/path"
        @test filepath2uri("C:/win/path") |> string == "file:///c%3A/win/path"
        @test filepath2uri("c:/win/path/") |> string == "file:///c%3A/win/path/"
    end
    @test filepath2uri("/c:/win/path") |> string == "file:///c%3A/win/path"
end

@testitem "filepath2uri to string - Windows special" begin
    using LanguageServer.URIs2

    if Sys.iswindows()
        @test filepath2uri("c:\\win\\path") |> string == "file:///c%3A/win/path"
        @test filepath2uri("c:\\win/path") |> string == "file:///c%3A/win/path"
    # else TODO Put this else back in once we support these paths on Unix
        # @test filepath2uri("c:\\win\\path") |> string == "file:///c%3A%5Cwin%5Cpath"
        # @test filepath2uri("c:\\win/path") |> string == "file:///c%3A%5Cwin/path"
    end
end

@testitem "uri2filepath to string - Windows special" begin
    using LanguageServer.URIs2

    if Sys.iswindows()
        @test uri2filepath(filepath2uri("c:\\win\\path")) == "c:\\win\\path"
        @test uri2filepath(filepath2uri("c:\\win/path")) == "c:\\win\\path"

        @test uri2filepath(filepath2uri("c:/win/path")) == "c:\\win\\path"
        @test uri2filepath(filepath2uri("c:/win/path/")) == "c:\\win\\path\\"
        @test uri2filepath(filepath2uri("C:/win/path")) == "c:\\win\\path"
        @test uri2filepath(filepath2uri("/c:/win/path")) == "c:\\win\\path"
        @test_broken uri2filepath(filepath2uri("./c/win/path")) == "\\.\\c\\win\\path"
        # else TODO Put this else back in once we support relative paths
        # @test uri2filepath(filepath2uri("c:/win/path")) == "c:/win/path"
        # @test uri2filepath(filepath2uri("c:/win/path/")) == "c:/win/path/"
        # @test uri2filepath(filepath2uri("C:/win/path")) == "c:/win/path"
        # @test uri2filepath(filepath2uri("/c:/win/path")) == "c:/win/path"
        # @test_broken uri2filepath(filepath2uri("./c/win/path")) == "/./c/win/path"
    end
end

@testitem "uri2filepath - no `uri2filepath` when no `path`" begin
    using LanguageServer.URIs2

    value = URI("file://%2Fhome%2Fticino%2Fdesktop%2Fcpluscplus%2Ftest.cpp")

    @test value.authority == "/home/ticino/desktop/cpluscplus/test.cpp"
    @test_broken value.path == "/"
    if Sys.iswindows()
        @test_broken uri2filepath(value) == "\\"
    else
        @test_broken uri2filepath(value) == "/"
    end
end

@testitem "parse" begin
    using LanguageServer.URIs2
    
    value = URI("http:/api/files/test.me?t=1234")
    @test value.scheme == "http"
    @test_broken value.authority == ""
    @test value.path == "/api/files/test.me"
    @test value.query == "t=1234"
    @test value.fragment === nothing

    value = URI("http://api/files/test.me?t=1234")
    @test value.scheme == "http"
    @test value.authority == "api"
    @test value.path == "/files/test.me"
    @test value.query == "t=1234"
    @test value.fragment === nothing

    value = URI("file:///c:/test/me")
    @test value.scheme == "file"
    @test value.authority == ""
    @test value.path == "/c:/test/me"
    @test value.fragment === nothing
    @test value.query=== nothing
    @test uri2filepath(value) == (Sys.iswindows() ? "c:\\test\\me" : "c:/test/me")

    value = URI("file://shares/files/c%23/p.cs")
    @test value.scheme == "file"
    @test value.authority == "shares"
    @test value.path == "/files/c#/p.cs"
    @test value.fragment === nothing
    @test value.query === nothing
    @test uri2filepath(value) == (Sys.iswindows() ? "\\\\shares\\files\\c#\\p.cs" : "//shares/files/c#/p.cs")

    value = URI("file:///c:/Source/Z%C3%BCrich%20or%20Zurich%20(%CB%88zj%CA%8A%C9%99r%C9%AAk,/Code/resources/app/plugins/c%23/plugin.json")
    @test value.scheme == "file"
    @test value.authority == ""
    @test value.path == "/c:/Source/Zürich or Zurich (ˈzjʊərɪk,/Code/resources/app/plugins/c#/plugin.json"
    @test value.fragment === nothing
    @test value.query === nothing

    value = URI("file:///c:/test %25/path")
    @test value.scheme == "file"
    @test value.authority == ""
    @test value.path == "/c:/test %/path"
    @test value.fragment === nothing
    @test value.query === nothing

    value = URI("inmemory:")
    @test value.scheme == "inmemory"
    @test value.authority === nothing
    @test value.path === ""
    @test value.query === nothing
    @test value.fragment === nothing

    value = URI("foo:api/files/test")
    @test value.scheme == "foo"
    @test value.authority === nothing
    @test value.path == "api/files/test"
    @test value.query === nothing
    @test value.fragment === nothing

    value = URI("file:?q")
    @test value.scheme == "file"
    @test_broken value.authority == ""
    @test_broken value.path == "/"
    @test value.query == "q"
    @test value.fragment === nothing

    value = URI("file:#d")
    @test value.scheme == "file"
    @test value.authority === nothing
    @test_broken value.path == "/"
    @test value.query === nothing
    @test value.fragment == "d"

    value = URI("f3ile:#d")
    @test value.scheme == "f3ile"
    @test value.authority === nothing
    @test value.path === ""
    @test value.query === nothing
    @test value.fragment == "d"

    value = URI("foo+bar:path")
    @test value.scheme == "foo+bar"
    @test value.authority === nothing
    @test value.path == "path"
    @test value.query === nothing
    @test value.fragment === nothing

    value = URI("foo-bar:path")
    @test value.scheme == "foo-bar"
    @test value.authority === nothing
    @test value.path == "path"
    @test value.query === nothing
    @test value.fragment === nothing

    value = URI("foo.bar:path")
    @test value.scheme == "foo.bar"
    @test value.authority === nothing
    @test value.path == "path"
    @test value.query === nothing
    @test value.fragment === nothing
end

@testitem "brute force tests" begin
    using LanguageServer: get_text, get_uri
    include("test_shared_server.jl")

    function on_all_docs(server, f)
        for doc in values(server._documents)
            f(doc)
        end
    end

    function on_all_offsets(doc, f)
        offset = 1
        while offset <= lastindex(get_text(doc))
            f(doc, offset)
            offset = nextind(get_text(doc), offset)
        end
    end    

    @info "Self-parse test"
    if get(ENV, "CI", false) != false
        @info "skipping brute-force tests on CI"
    else
        # run tests against each position in each document
        empty!(server._documents)
        LanguageServer.load_folder(dirname(String(first(methods(LanguageServer.eval)).file)), server)
        on_all_docs(server, doc -> begin
            @info "Testing LS functionality at all offsets" file=get_uri(doc)
            on_all_offsets(doc, function (doc, offset)
                tdi = LanguageServer.TextDocumentIdentifier(get_uri(doc))
                pos = LanguageServer.Position(LanguageServer.get_position_from_offset(doc, offset)...)
                @test LanguageServer.get_offset(doc, LanguageServer.get_position_from_offset(doc, offset)...) == offset
                LanguageServer.textDocument_completion_request(LanguageServer.CompletionParams(tdi, pos, missing), server, server.jr_endpoint)
                LanguageServer.textDocument_hover_request(LanguageServer.TextDocumentPositionParams(tdi, pos), server, server.jr_endpoint)
                LanguageServer.textDocument_signatureHelp_request(LanguageServer.TextDocumentPositionParams(tdi, pos), server, server.jr_endpoint)
                LanguageServer.textDocument_definition_request(LanguageServer.TextDocumentPositionParams(tdi, pos), server, server.jr_endpoint)
                LanguageServer.textDocument_references_request(LanguageServer.ReferenceParams(tdi, pos, missing, missing, LanguageServer.ReferenceContext(true)), server, server.jr_endpoint)
                LanguageServer.textDocument_rename_request(LanguageServer.RenameParams(tdi, pos, missing, "newname"), server, server.jr_endpoint)
            end)
        end)

        on_all_docs(server, doc -> begin
            symbols=length(LanguageServer.textDocument_documentSymbol_request(LanguageServer.DocumentSymbolParams(LanguageServer.TextDocumentIdentifier(get_uri(doc)),missing, missing), server, server.jr_endpoint))
            @info "Found $symbols symbols" file=get_uri(doc)
        end)

        LanguageServer.workspace_symbol_request(LanguageServer.WorkspaceSymbolParams("", missing, missing), server, server.jr_endpoint)
    end
end

@setup_workload begin
    iob = IOBuffer()
    println(iob)
    @compile_workload begin
        # Suppress errors
        if get(ENV, "JULIA_DEBUG", "") in ("all", "LanguageServer")
            precompile_logger = Logging.ConsoleLogger()
        else
            precompile_logger = Logging.NullLogger()
        end
        Logging.with_logger(precompile_logger) do
            runserver(iob)
        end
    end
end
precompile(runserver, ())

@testitem "getCurrentBlockRange" begin
    include("../test_shared_server.jl")

    doc = settestdoc("ab")

    res = (LanguageServer.Position(0, 0), LanguageServer.Position(0, 2), LanguageServer.Position(0, 2))
    
    @test LanguageServer.julia_getCurrentBlockRange_request(LanguageServer.VersionedTextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), 0, LanguageServer.Position(0, 0)), server, server.jr_endpoint) == res

    @test LanguageServer.julia_getCurrentBlockRange_request(LanguageServer.VersionedTextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), 0, LanguageServer.Position(0, 1)), server, server.jr_endpoint) == res

    @test LanguageServer.julia_getCurrentBlockRange_request(LanguageServer.VersionedTextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), 0, LanguageServer.Position(0, 2)), server, server.jr_endpoint) == res
end

function textDocument_didOpen_notification(params::DidOpenTextDocumentParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri
    if hasdocument(server, uri)
        doc = getdocument(server, uri)
        set_text_document!(doc, TextDocument(uri, params.textDocument.text, params.textDocument.version, params.textDocument.languageId))
        set_open_in_editor(doc, true)
    else
        doc = Document(TextDocument(uri, params.textDocument.text, params.textDocument.version, params.textDocument.languageId), false, server)
        setdocument!(server, uri, doc)
        doc._workspace_file = any(i -> startswith(string(uri), string(filepath2uri(i))), server.workspaceFolders)
        set_open_in_editor(doc, true)

        fpath = getpath(doc)

        !isempty(fpath) && try_to_load_parents(fpath, server)
    end
    parse_all(doc, server)
end


function textDocument_didClose_notification(params::DidCloseTextDocumentParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri
    doc = getdocument(server, uri)

    if is_workspace_file(doc)
        set_open_in_editor(doc, false)
    else
        if any(getroot(d) == getroot(doc) && (d._open_in_editor || is_workspace_file(d)) for (uri, d::Document) in getdocuments_pair(server) if d != doc)
            # If any other open document shares doc's root we just mark it as closed...
            set_open_in_editor(doc, false)
        else
            # ...otherwise we delete all documents that share root with doc.
            for (u, d) in getdocuments_pair(server)
                if getroot(d) == getroot(doc)
                    deletedocument!(server, u)
                    empty!(doc.diagnostics)
                    publish_diagnostics(doc, server, conn)
                end
            end
        end
    end
end

function textDocument_didSave_notification(params::DidSaveTextDocumentParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri
    doc = getdocument(server, uri)
    if params.text isa String
        if get_text(doc) != params.text
            println(stderr, "Mismatch between server and client text")
            println(stderr, "========== BEGIN SERVER SIDE TEXT ==========")
            println(stderr, get_text(doc))
            println(stderr, "========== END SERVER SIDE TEXT ==========")
            println(stderr, "========== BEGIN CLIENT SIDE TEXT ==========")
            println(stderr, params.text)
            println(stderr, "========== END CLIENT SIDE TEXT ==========")
            JSONRPC.send(conn, window_showMessage_notification_type, ShowMessageParams(MessageTypes.Error, "Julia Extension: Please contact us! Your extension just crashed with a bug that we have been trying to replicate for a long time. You could help the development team a lot by contacting us at https://github.com/julia-vscode/julia-vscode so that we can work together to fix this issue."))
            throw(LSSyncMismatch("Mismatch between server and client text for $(get_uri(doc)). _open_in_editor is $(doc._open_in_editor). _workspace_file is $(doc._workspace_file). _version is $(get_version(doc))."))
        end
    end
    parse_all(doc, server)
end

function textDocument_willSave_notification(params::WillSaveTextDocumentParams, server::LanguageServerInstance, conn)
end

function textDocument_willSaveWaitUntil_request(params::WillSaveTextDocumentParams, server::LanguageServerInstance, conn)
    return TextEdit[]
end

comp(x, y) = x == y
function comp(x::CSTParser.EXPR, y::CSTParser.EXPR)
    comp(x.head, y.head) &&
    x.span == y.span &&
    x.fullspan == y.fullspan &&
    x.val == y.val &&
    length(x) == length(y) &&
    all(comp(x[i], y[i]) for i = 1:length(x))
end

function textDocument_didChange_notification(params::DidChangeTextDocumentParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)

    s0 = get_text(doc)

    if params.textDocument.version < get_version(doc)
        error("The client and server have different textDocument versions for $(get_uri(doc)). LS version is $(get_version(doc)), request version is $(params.textDocument.version).")
    end

    new_text_document = apply_text_edits(get_text_document(doc), params.contentChanges, params.textDocument.version)
    set_text_document!(doc, new_text_document)

    if get_language_id(doc) in ("markdown", "juliamarkdown")
        parse_all(doc, server)
    else get_language_id(doc) == "julia"
        cst0, cst1 = getcst(doc), CSTParser.parse(get_text(doc), true)
        r1, r2, r3 = CSTParser.minimal_reparse(s0, get_text(doc), cst0, cst1, inds = true)
        for i in setdiff(1:length(cst0.args), r1 , r3) # clean meta from deleted expr
            StaticLint.clear_meta(cst0[i])
        end
        setcst(doc, EXPR(cst0.head, EXPR[cst0.args[r1]; cst1.args[r2]; cst0.args[r3]], nothing))
        sizeof(get_text(doc)) == getcst(doc).fullspan || @error "CST does not match input string length."
        headof(doc.cst) === :file ? set_doc(doc.cst, doc) : @info "headof(doc) isn't :file for $(doc._path)"

        target_exprs = getcst(doc).args[last(r1) .+ (1:length(r2))]
        semantic_pass(getroot(doc), target_exprs)
        lint!(doc, server)
    end
end

function parse_all(doc::Document, server::LanguageServerInstance)
    StaticLint.clear_meta(getcst(doc))
    if get_language_id(doc) in ("markdown", "juliamarkdown")
        doc.cst, ps = parse_jmd(get_text(doc))
    elseif get_language_id(doc) == "julia"
        t = @elapsed begin
            ps = CSTParser.ParseState(get_text(doc))
            doc.cst, ps = CSTParser.parse(ps, true)
        end
        if t > 1
            # warn to help debugging in the wild
            @warn "CSTParser took a long time ($(round(Int, t)) seconds) to parse $(repr(getpath(doc)))"
        end
    else
        return
    end
    sizeof(get_text(doc)) == getcst(doc).fullspan || @error "CST does not match input string length."
    if headof(doc.cst) === :file
        set_doc(doc.cst, doc)
    end
    semantic_pass(getroot(doc))

    lint!(doc, server)
end

function mark_errors(doc, out=Diagnostic[])
    line_offsets = get_line_offsets(get_text_document(doc))
    # Extend line_offsets by one to consider up to EOF
    line_offsets = vcat(line_offsets, length(get_text(doc)) + 1)
    errs = StaticLint.collect_hints(getcst(doc), getenv(doc), doc.server.lint_missingrefs)
    n = length(errs)
    n == 0 && return out
    i = 1
    start = true
    offset = errs[i][1]
    r = Int[0, 0]
    nlines = length(line_offsets)
    if offset > last(line_offsets)
        line = nlines
    else
        line = 1
        io = IOBuffer(get_text(doc))
        while line < nlines
            seek(io, line_offsets[line])
            char = 0
            while line_offsets[line] <= offset < line_offsets[line + 1]
                while offset > position(io)
                    c = read(io, Char)
                    if UInt32(c) >= 0x010000
                        char += 1
                    end
                    char += 1
                end
                if start
                    r[1] = line
                    r[2] = char
                    offset += errs[i][2].span
                else
                    rng = Range(r[1] - 1, r[2], line - 1, char)
                    if headof(errs[i][2]) === :errortoken
                        push!(out, Diagnostic(rng, DiagnosticSeverities.Error, missing, missing, "Julia", "Parsing error", missing, missing))
                    elseif CSTParser.isidentifier(errs[i][2]) && !StaticLint.haserror(errs[i][2])
                        push!(out, Diagnostic(rng, DiagnosticSeverities.Warning, missing, missing, "Julia", "Missing reference: $(errs[i][2].val)", missing, missing))
                    elseif StaticLint.haserror(errs[i][2]) && StaticLint.errorof(errs[i][2]) isa StaticLint.LintCodes
                        code = StaticLint.errorof(errs[i][2])
                        description = get(StaticLint.LintCodeDescriptions, code, "")
                        severity, tags = if code in (StaticLint.UnusedFunctionArgument, StaticLint.UnusedBinding, StaticLint.UnusedTypeParameter)
                            DiagnosticSeverities.Hint, [DiagnosticTags.Unnecessary]
                        else
                            DiagnosticSeverities.Information, missing
                        end
                        code_details = if isdefined(StaticLint, :IndexFromLength) && code === StaticLint.IndexFromLength
                            CodeDescription(URI("https://docs.julialang.org/en/v1/base/arrays/#Base.eachindex"))
                        else
                            missing
                        end
                        push!(out, Diagnostic(rng, severity, string(code), code_details, "Julia", description, tags, missing))
                    end
                    i += 1
                    i > n && break
                    offset = errs[i][1]
                end
                start = !start
                offset = start ? errs[i][1] : errs[i][1] + errs[i][2].span
            end
            line += 1
        end
        close(io)
    end
    return out
end

isunsavedfile(doc::Document) = get_uri(doc).scheme == "untitled" # Not clear if this is consistent across editors.

"""
is_diag_dependent_on_env(diag::Diagnostic)::Bool

Is this diagnostic reliant on the current environment being accurately represented?
"""
function is_diag_dependent_on_env(diag::Diagnostic)
    startswith(diag.message, "Missing reference: ") ||
    startswith(diag.message, "Possible method call error") ||
    startswith(diag.message, "An imported")
end


function publish_diagnostics(doc::Document, server, conn)
    diagnostics = if server.runlinter && (is_workspace_file(doc) || isunsavedfile(doc))
        pkgpath = getpath(doc)
        if any(is_in_target_dir_of_package.(Ref(pkgpath), server.lint_disableddirs))
            filter!(!is_diag_dependent_on_env, doc.diagnostics)
        end
        doc.diagnostics
    else
        Diagnostic[]
    end
    text_document = get_text_document(doc)
    params = PublishDiagnosticsParams(get_uri(text_document), get_version(text_document), diagnostics)
    JSONRPC.send(conn, textDocument_publishDiagnostics_notification_type, params)
end

function clear_diagnostics(uri::URI, server, conn)
    doc = getdocument(server, uri)
    empty!(doc.diagnostics)
    publishDiagnosticsParams = PublishDiagnosticsParams(get_uri(doc), get_version(doc), Diagnostic[])
    JSONRPC.send(conn, textDocument_publishDiagnostics_notification_type, publishDiagnosticsParams)
end

function clear_diagnostics(server, conn)
    for uri in getdocuments_key(server)
        clear_diagnostics(uri, server, conn)
    end
end

function print_substitute_line(io::IO, line)
    if endswith(line, '\n')
        println(io, ' '^(sizeof(line) - 1))
    else
        print(io, ' '^sizeof(line))
    end
end

function parse_jmd(str)
    cleaned = IOBuffer()
    in_julia_block = false
    for line in eachline(IOBuffer(str), keep=true)
        if startswith(line, r"^```({?julia|@example|@setup)")
            in_julia_block = true
            print_substitute_line(cleaned, line)
            continue
        elseif startswith(line, r"\s*```")
            in_julia_block = false
        end
        if in_julia_block
            print(cleaned, line)
        else
            print_substitute_line(cleaned, line)
        end
    end

    ps = CSTParser.ParseState(String(take!(cleaned)))
    return CSTParser.parse(ps, true)
end

function search_for_parent(dir::String, file::String, drop=3, parents=String[])
    drop < 1 && return parents
    try
        !isdir(dir) && return parents
        !hasreadperm(dir) && return parents
        for f in readdir(dir)
            filename = joinpath(dir, f)
            if isvalidjlfile(filename)
                # Could be sped up?
                content = try
                    s = read(filename, String)
                    our_isvalid(s) || continue
                    s
                catch err
                    isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
                    continue
                end
                occursin(file, content) && push!(parents, joinpath(dir, f))
            end
        end
        search_for_parent(splitdir(dir)[1], file, drop - 1, parents)
    catch err
        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        return parents
    end

    return parents
end


function is_parentof(parent_path, child_path, server)
    !isvalidjlfile(parent_path) && return false
    previous_server_docs = collect(getdocuments_key(server)) # additions to this to be removed at end
    # load parent file
    puri = filepath2uri(parent_path)
    if !hasdocument(server, puri)
        content = try
            s = read(parent_path, String)
            our_isvalid(s) || return false
            s
        catch err
            isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
            return false
        end
        pdoc = Document(TextDocument(puri, content, 0), false, server)
        setdocument!(server, puri, pdoc)
        CSTParser.parse(get_text(pdoc), true)
        if headof(pdoc.cst) === :file
            set_doc(pdoc.cst, pdoc)
        end
    else
        pdoc = getdocument(server, puri)
    end
    semantic_pass(getroot(pdoc))
    # check whether child has been included automatically
    if any(getpath(d) == child_path for (k, d) in getdocuments_pair(server) if !(k in previous_server_docs))
        cdoc = getdocument(server, filepath2uri(child_path))
        parse_all(cdoc, server)
        semantic_pass(getroot(cdoc))
        return true, "", CSTParser.Tokens.STRING
    else
        # clean up
        foreach(k -> !(k in previous_server_docs) && deletedocument!(server, k), getdocuments_key(server))
        return false
    end
end

function try_to_load_parents(child_path, server)
    for p in search_for_parent(splitdir(child_path)...)
        p == child_path && continue
        success = is_parentof(p, child_path, server)
        if success
            return try_to_load_parents(p, server)
        end
    end
end



function vec_startswith(a, b)
    if length(a) < length(b)
        return false
    end

    for (i,v) in enumerate(b)
        if a[i] != v
            return false
        end
    end
    return true
end

function find_package_for_file(jw::JuliaWorkspace, file::URI)
    file_path = uri2filepath(file)
    package = jw._packages |>
        keys |>
        collect |>
        x -> map(x) do i
            package_folder_path = uri2filepath(i)
            parts = splitpath(package_folder_path)
            return (uri = i, parts = parts)
        end |>
        x -> filter(x) do i
            return vec_startswith(splitpath(file_path), i.parts)
        end |>
        x -> sort(x, by=i->length(i.parts), rev=true) |>
        x -> length(x) == 0 ? nothing : first(x).uri

    return package
end

function find_project_for_file(jw::JuliaWorkspace, file::URI)
    file_path = uri2filepath(file)
    project = jw._projects |>
        keys |>
        collect |>
        x -> map(x) do i
            project_folder_path = uri2filepath(i)
            parts = splitpath(project_folder_path)
            return (uri = i, parts = parts)
        end |>
        x -> filter(x) do i
            return vec_startswith(splitpath(file_path), i.parts)
        end |>
        x -> sort(x, by=i->length(i.parts), rev=true) |>
        x -> length(x) == 0 ? nothing : first(x).uri

    return project
end

function find_tests!(doc, server::LanguageServerInstance, jr_endpoint)
    if !ismissing(server.initialization_options) && get(server.initialization_options, "julialangTestItemIdentification", false)
        # Find which workspace folder the doc is in.
        parent_workspaceFolders = sort(filter(f -> startswith(doc._path, f), collect(server.workspaceFolders)), by=length, rev=true)

        # If the file is not in the workspace, we don't report nothing
        isempty(parent_workspaceFolders) && return

        project_uri = find_project_for_file(server.workspace,  get_uri(doc))
        package_uri = find_package_for_file(server.workspace,  get_uri(doc))

        if project_uri === nothing
            project_uri = filepath2uri(server.env_path)
        end

        if package_uri === nothing
            package_path = ""
            package_name = ""
        else
            package_path = uri2filepath(package_uri)
            package_name = server.workspace._packages[package_uri].name
        end

        project_path = ""
        if project_uri == package_uri
            project_path = uri2filepath(project_uri)
        elseif haskey(server.workspace._projects, project_uri)
            relevant_project = server.workspace._projects[project_uri]

            if haskey(relevant_project.deved_packages, package_uri)
                project_path = uri2filepath(project_uri)
            end
        end

        cst = getcst(doc)

        testitems = []
        testsetups = []
        testerrors = []

        for i in cst.args
            file_testitems = []
            file_testsetups = []
            file_errors = []

            TestItemDetection.find_test_detail!(i, file_testitems, file_testsetups, file_errors)

            append!(testitems, [TestItemDetail(i.name, i.name, Range(doc, i.range), get_text(doc)[i.code_range], Range(doc, i.code_range), i.option_default_imports, string.(i.option_tags)) for i in file_testitems])
            append!(testsetups, [TestSetupDetail(i.name, Range(doc, i.range), get_text(doc)[i.code_range], Range(doc, i.code_range), ) for i in file_testsetups])
            append!(testerrors, [TestErrorDetail(Range(doc, i.range), i.error) for i in file_errors])
        end

        params = PublishTestsParams(
            get_uri(doc),
            get_version(doc),
            project_path,
            package_path,
            package_name,
            testitems,
            testsetups,
            testerrors
        )
        JSONRPC.send(jr_endpoint, textDocument_publishTests_notification_type, params)
    end
end

const textDocument_codeAction_request_type = JSONRPC.RequestType("textDocument/codeAction", CodeActionParams, Union{Vector{Command}, Vector{CodeAction}, Nothing})
const textDocument_completion_request_type = JSONRPC.RequestType("textDocument/completion", CompletionParams, Union{CompletionList, Vector{CompletionItem}, Nothing})
const textDocument_signatureHelp_request_type = JSONRPC.RequestType("textDocument/signatureHelp", TextDocumentPositionParams, Union{SignatureHelp, Nothing})
const textDocument_definition_request_type = JSONRPC.RequestType("textDocument/definition", TextDocumentPositionParams, Union{Location, Vector{Location}, Vector{LocationLink}, Nothing})
const textDocument_formatting_request_type = JSONRPC.RequestType("textDocument/formatting", DocumentFormattingParams, Union{Vector{TextEdit}, Nothing})
const textDocument_range_formatting_request_type = JSONRPC.RequestType("textDocument/rangeFormatting", DocumentRangeFormattingParams, Union{Vector{TextEdit}, Nothing})
const textDocument_references_request_type = JSONRPC.RequestType("textDocument/references", ReferenceParams, Union{Vector{Location}, Nothing})
const textDocument_rename_request_type = JSONRPC.RequestType("textDocument/rename", RenameParams, Union{WorkspaceEdit, Nothing})
const textDocument_prepareRename_request_type = JSONRPC.RequestType("textDocument/prepareRename", PrepareRenameParams, Union{Range,Nothing})
const textDocument_documentSymbol_request_type = JSONRPC.RequestType("textDocument/documentSymbol", DocumentSymbolParams, Union{Vector{DocumentSymbol}, Vector{SymbolInformation}, Nothing})
const textDocument_documentHighlight_request_type = JSONRPC.RequestType("textDocument/documentHighlight", DocumentHighlightParams, Union{Vector{DocumentHighlight}, Nothing})
const textDocument_hover_request_type = JSONRPC.RequestType("textDocument/hover", TextDocumentPositionParams, Union{Hover, Nothing})
const textDocument_didOpen_notification_type = JSONRPC.NotificationType("textDocument/didOpen", DidOpenTextDocumentParams)
const textDocument_didClose_notification_type = JSONRPC.NotificationType("textDocument/didClose", DidCloseTextDocumentParams)
const textDocument_didChange_notification_type = JSONRPC.NotificationType("textDocument/didChange", DidChangeTextDocumentParams)
const textDocument_didSave_notification_type = JSONRPC.NotificationType("textDocument/didSave", DidSaveTextDocumentParams)
const textDocument_willSave_notification_type = JSONRPC.NotificationType("textDocument/willSave", WillSaveTextDocumentParams)
const textDocument_willSaveWaitUntil_request_type = JSONRPC.RequestType("textDocument/willSaveWaitUntil", WillSaveTextDocumentParams, Union{Vector{TextEdit}, Nothing})
const textDocument_publishDiagnostics_notification_type = JSONRPC.NotificationType("textDocument/publishDiagnostics", PublishDiagnosticsParams)
const textDocument_selectionRange_request_type = JSONRPC.RequestType("textDocument/selectionRange", SelectionRangeParams, Union{Vector{SelectionRange}, Nothing})
const textDocument_documentLink_request_type = JSONRPC.RequestType("textDocument/documentLink", DocumentLinkParams, Union{Vector{DocumentLink}, Nothing})
const textDocument_inlayHint_request_type = JSONRPC.RequestType("textDocument/inlayHint", InlayHintParams, Union{Vector{InlayHint}, Nothing})

const workspace_executeCommand_request_type = JSONRPC.RequestType("workspace/executeCommand", ExecuteCommandParams, Any)
const workspace_symbol_request_type = JSONRPC.RequestType("workspace/symbol", WorkspaceSymbolParams, Union{Vector{SymbolInformation}, Nothing})
const workspace_didChangeWatchedFiles_notification_type = JSONRPC.NotificationType("workspace/didChangeWatchedFiles", DidChangeWatchedFilesParams)
const workspace_didChangeConfiguration_notification_type = JSONRPC.NotificationType("workspace/didChangeConfiguration", DidChangeConfigurationParams)
const workspace_didChangeWorkspaceFolders_notification_type = JSONRPC.NotificationType("workspace/didChangeWorkspaceFolders", DidChangeWorkspaceFoldersParams)
const workspace_applyEdit_request_type = JSONRPC.RequestType("workspace/applyEdit", ApplyWorkspaceEditParams, ApplyWorkspaceEditResponse)
const workspace_configuration_request_type = JSONRPC.RequestType("workspace/configuration", ConfigurationParams, Vector{Any})
const julia_activateenvironment_notification_type = JSONRPC.NotificationType("julia/activateenvironment", NamedTuple{(:envPath,),Tuple{String}})
const julia_refreshLanguageServer_notification_type = JSONRPC.NotificationType("julia/refreshLanguageServer", Nothing)

const initialize_request_type = JSONRPC.RequestType("initialize", InitializeParams, InitializeResult)
const initialized_notification_type = JSONRPC.NotificationType("initialized", InitializedParams)
const shutdown_request_type = JSONRPC.RequestType("shutdown", Nothing, Nothing)
const exit_notification_type = JSONRPC.NotificationType("exit", Nothing)
const client_registerCapability_request_type = JSONRPC.RequestType("client/registerCapability", RegistrationParams, Nothing)

const cancel_notification_type = JSONRPC.NotificationType("\$/cancelRequest", CancelParams)
const setTrace_notification_type = JSONRPC.NotificationType("\$/setTrace", SetTraceParams)
# TODO This seems to not exist in the spec?
const setTraceNotification_notification_type = JSONRPC.NotificationType("\$/setTraceNotification", Nothing)

const window_workDoneProgress_create_request_type = JSONRPC.RequestType("window/workDoneProgress/create", WorkDoneProgressCreateParams, Nothing)
const window_showMessage_notification_type = JSONRPC.NotificationType("window/showMessage", ShowMessageParams)
const window_showMessage_request_type = JSONRPC.RequestType("window/showMessageRequest", ShowMessageRequestParams, Union{MessageActionItem, Nothing})

const progress_notification_type = JSONRPC.NotificationType("\$/progress", ProgressParams)

const telemetry_event_notification_type = JSONRPC.NotificationType("telemetry/event", Any)

const DocumentHighlightKind = Int
const DocumentHighlightKinds = (Text = 1,
                                Read = 2,
                                Write = 3)

@dict_readable struct DocumentHighlightClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct DocumentHighlightOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentHighlightRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct DocumentHighlightParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

struct DocumentHighlight <: Outbound
    range::Range
    kind::Union{DocumentHighlightKind,Missing}
end

import JSONRPC, LanguageServer

init_request = LanguageServer.InitializeParams(
        9902,
        missing,
        nothing,
        nothing,
        missing,
        LanguageServer.ClientCapabilities(
            LanguageServer.WorkspaceClientCapabilities(
                true,
                LanguageServer.WorkspaceEditClientCapabilities(true, missing, missing),
                LanguageServer.DidChangeConfigurationClientCapabilities(false),
                LanguageServer.DidChangeWatchedFilesClientCapabilities(false,),
                LanguageServer.WorkspaceSymbolClientCapabilities(true, missing),
                LanguageServer.ExecuteCommandClientCapabilities(true),
                missing,
                missing
            ),
            LanguageServer.TextDocumentClientCapabilities(
                LanguageServer.TextDocumentSyncClientCapabilities(true, true, true, true),
                LanguageServer.CompletionClientCapabilities(true, LanguageServer.CompletionItemClientCapabilities(true, missing, missing, missing, missing, missing), missing, missing),
                LanguageServer.HoverClientCapabilities(true, missing),
                LanguageServer.SignatureHelpClientCapabilities(true, missing, missing),
                LanguageServer.DeclarationClientCapabilities(false, missing),
                missing, # DefinitionClientCapabilities(),
                missing, # TypeDefinitionClientCapabilities(),
                missing, # ImplementationClientCapabilities(),
                missing, # ReferenceClientCapabilities(),
                LanguageServer.DocumentHighlightClientCapabilities(true),
                LanguageServer.DocumentSymbolClientCapabilities(true, missing, missing),
                LanguageServer.CodeActionClientCapabilities(true, missing, missing),
                LanguageServer.CodeLensClientCapabilities(true),
                missing, # DocumentLinkClientCapabilities(),
                missing, # DocumentColorClientCapabilities(),
                LanguageServer.DocumentFormattingClientCapabilities(true),
                missing, # DocumentRangeFormattingClientCapabilities(),
                missing, # DocumentOnTypeFormattingClientCapabilities(),
                LanguageServer.RenameClientCapabilities(true, true),
                missing, # PublishDiagnosticsClientCapabilities(),
                missing, # FoldingRangeClientCapabilities(),
                missing, # SelectionRangeClientCapabilities()
            ),
            missing,
            missing
        ),
        "off",
        missing,
        missing
    )

@dict_readable struct WorkspaceFoldersChangeEvent
    added::Vector{WorkspaceFolder}
    removed::Vector{WorkspaceFolder}
end

@dict_readable struct DidChangeWorkspaceFoldersParams
    event::WorkspaceFoldersChangeEvent
end

struct DidChangeConfigurationParams
    settings::Any
    function DidChangeConfigurationParams(d)
        if d isa Dict && length(d) == 1 && haskey(d, "settings")
            new(d["settings"])
        else
            new(d)
        end
    end
end

struct ConfigurationItem <: Outbound
    scopeUri::Union{DocumentUri,Missing}
    section::Union{String,Missing}
end

struct ConfigurationParams <: Outbound
    items::Vector{ConfigurationItem}
end

##############################################################################
# File watching
const FileChangeType = Int
const FileChangeTypes = (Created = 1,
                         Changed = 2,
                         Deleted = 3)

const WatchKind = Int
const WatchKinds = (Create = 1,
                    Change = 2,
                    Delete = 4)


@dict_readable struct FileEvent
    uri::DocumentUri
    type::FileChangeType
end

@dict_readable struct DidChangeWatchedFilesParams
    changes::Vector{FileEvent}
end

struct FileSystemWatcher <: Outbound
    globPattern::String
    kind::Union{WatchKind,Missing}
end

struct DidChangeWatchedFilesRegistrationOptions <: Outbound
    watchers::Vector{FileSystemWatcher}
end


##############################################################################
# Registration

struct Registration <: Outbound
    id::String
    method::String
    registerOptions::Union{Any,Missing}
end

struct RegistrationParams <: Outbound
    registrations::Vector{Registration}
end

struct TextDocumentRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
end

struct TextDocumentChangeRegistrationOptions <: Outbound
    documentSelector::DocumentSelector
    syncKind::Int
end

struct TextDocumentSaveRegistrationOptions <: Outbound
    documentSelector::DocumentSelector
    includeText::Union{Bool,Missing}
end

struct Unregistration <: Outbound
    id::String
    method::String
end

struct UnregistrationParams <: Outbound
    unregistrations::Vector{Unregistration}
end


struct StaticRegistrationOptions <: Outbound
    id::Union{String,Missing}
end

##############################################################################

const SymbolKind = Int
const SymbolKinds = (File = 1,
                    Module = 2,
                    Namespace = 3,
                    Package = 4,
                    Class = 5,
                    Method = 6,
                    Property = 7,
                    Field = 8,
                    Constructor = 9,
                    Enum = 10,
                    Interface = 11,
                    Function = 12,
                    Variable = 13,
                    Constant = 14,
                    String = 15,
                    Number = 16,
                    Boolean = 17,
                    Array = 18,
                    Object = 19,
                    Key = 20,
                    Null = 21,
                    EnumMember = 22,
                    Struct = 23,
                    Event = 24,
                    Operator = 25,
                    TypeParameter = 26)

@dict_readable struct SymbolKindCapabilities <: Outbound
    valueSet::Union{Vector{SymbolKind},Missing}
end

@dict_readable struct DocumentSymbolClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    symbolKind::Union{SymbolKindCapabilities,Missing}
    hierarchicalDocumentSymbolSupport::Union{Bool,Missing}
end

@dict_readable mutable struct WorkspaceSymbolClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    symbolKind::Union{SymbolKindCapabilities,Missing}
end

struct DocumentSymbolOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentSymbolRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

struct WorkspaceSymbolOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct WorkspaceSymbolRegistrationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end


@dict_readable struct DocumentSymbolParams <: Outbound
    textDocument::TextDocumentIdentifier
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

@dict_readable struct WorkspaceSymbolParams <: Outbound
    query::String
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

struct SymbolInformation <: Outbound
    name::String
    kind::SymbolKind
    deprecated::Union{Bool,Missing}
    location::Location
    containerName::Union{String,Missing}
end

struct DocumentSymbol <: Outbound
    name::String
    detail::Union{String,Missing}
    kind::SymbolKind
    deprecated::Union{Bool,Missing}
    range::Range
    selectionRange::Range
    children::Union{Vector{DocumentSymbol},Missing}
end

@testitem "signatures" begin
    include("../test_shared_server.jl")

    doc = settestdoc("""
    rand()
    Base.rand()
    func(arg) = 1
    func()
    struct T
        a
        b
    end
    T()
    struct S{R}
        a
        S() = new(1)
    end
    using Base:argtail
    argtail()
    S{R}()
    """)
    @test !isempty(sig_test(0, 5).signatures)
    @test !isempty(sig_test(1, 10).signatures)
    @test !isempty(sig_test(3, 5).signatures)
    @test !isempty(sig_test(8, 2).signatures)
    @test_broken !isempty(sig_test(15, 5).signatures)

    let sigs = LanguageServer.SignatureInformation[]
        LanguageServer.get_signatures(doc.cst[3].meta.binding, doc.cst.meta.scope, sigs, LanguageServer.getenv(server))
        @test length(sigs) == 1
    end
    let sigs = LanguageServer.SignatureInformation[]
        LanguageServer.get_signatures(doc.cst[5].meta.binding, doc.cst.meta.scope, sigs, LanguageServer.getenv(server))
        @test length(sigs) == 1
    end
    let sigs = LanguageServer.SignatureInformation[]
        LanguageServer.get_signatures(doc.cst[1][1].meta.ref, doc.cst.meta.scope, sigs, LanguageServer.getenv(server))
        @test length(sigs) > 0
    end
    let sigs = LanguageServer.SignatureInformation[]
        LanguageServer.get_signatures(doc.cst[7].meta.binding, doc.cst.meta.scope, sigs, LanguageServer.getenv(server))
        @test length(sigs) == 1
    end
    let sigs = LanguageServer.SignatureInformation[]
        LanguageServer.get_signatures(doc.cst[9][1].meta.ref, doc.cst.meta.scope, sigs, LanguageServer.getenv(server))
        @test length(sigs) == 1
    end
end

@testitem "definitions" begin
    include("../test_shared_server.jl")

    settestdoc("""
    rand()
    func(arg) = 1
    func()
    Float64
    """)
    # @test !isempty(def_test(0, 3))
    @test !isempty(def_test(2, 3))
    @test !isempty(def_test(3, 3))
end

@testitem "references" begin
    include("../test_shared_server.jl")

    settestdoc("""
    func(arg) = 1
    func()
    """)
    @test length(ref_test(1, 2)) == 2
end

@testitem "rename" begin
    include("../test_shared_server.jl")

    settestdoc("""
    func(arg) = 1
    func()
    """)
    @test length(rename_test(0, 2).documentChanges[1].edits) == 2
end

@testitem "get_file_loc" begin
    include("../test_shared_server.jl")

    doc = settestdoc("""
    func(arg) = 1
    func()
    """)
    @test LanguageServer.get_file_loc(doc.cst.args[2].args[1]) == (doc, 14)
end

@testitem "doc symbols" begin
    include("../test_shared_server.jl")

    doc = settestdoc("""
    a = 1
    b = 2
    function func() end
    function (::Bar)() end
    function (::Type{Foo})() end
    """)
    @test all(item.name in ("a", "b", "func", "::Bar", "::Type{Foo}") for item in LanguageServer.textDocument_documentSymbol_request(LanguageServer.DocumentSymbolParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), missing, missing), server, server.jr_endpoint))
end

@testitem "range formatting" begin
    include("../test_shared_server.jl")

    doc = settestdoc("""
    map([A,B,C]) do x
    if x<0 && iseven(x)
    return 0
    elseif x==0
    return 1
    else
    return x
    end
    end
    """)
    @test range_formatting_test(0, 0, 8, 0)[1].newText == """
    map([A, B, C]) do x
        if x < 0 && iseven(x)
            return 0
        elseif x == 0
            return 1
        else
            return x
        end
    end
    """

    doc = settestdoc("""
    map([A,B,C]) do x
    if x<0 && iseven(x)
    return 0
    elseif x==0
    return 1
    else
    return x
    end
    end
    """)
    @test range_formatting_test(2, 0, 2, 0)[1].newText == "        return 0\n"

    doc = settestdoc("""
    function add(a,b) a+b end
    function sub(a,b) a-b end
    function mul(a,b) a*b end
    """)
    @test range_formatting_test(1, 0, 1, 0)[1].newText == """
    function sub(a, b)
        a - b
    end
    """

    doc = settestdoc("""
    function sub(a, b)
        a - b
    end
    """)
    @test range_formatting_test(0, 0, 2, 0) == LanguageServer.TextEdit[]

    # \r\n line endings
    doc = settestdoc("function foo(a,  b)\r\na - b\r\n end\r\n")
    @test range_formatting_test(0, 0, 2, 0)[1].newText == "function foo(a, b)\r\n    a - b\r\nend\r\n"

    # no trailing newline
    doc = settestdoc("function foo(a,  b)\na - b\n end")
    @test range_formatting_test(0, 0, 2, 0)[1].newText == "function foo(a, b)\n    a - b\nend"
end

struct LSSymbolServerFailure <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSSymbolServerFailure)
    print(io, ex.msg)
end

struct LSUriConversionFailure <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSUriConversionFailure)
    print(io, ex.msg)
end

struct LSOffsetError <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSOffsetError)
    print(io, ex.msg)
end

struct LSSyncMismatch <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSSyncMismatch)
    print(io, ex.msg)
end

struct LSHoverError <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSHoverError)
    print(io, ex.msg)
end

struct LSPositionToOffsetException <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSPositionToOffsetException)
    print(io, ex.msg)
end

struct LSRelativePath <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSRelativePath)
    print(io, ex.msg)
end

struct LSInfiniteLoop <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSInfiniteLoop)
    print(io, ex.msg)
end

struct LSInvalidFile <: Exception
    msg::AbstractString
end

function Base.showerror(io::IO, ex::LSInvalidFile)
    print(io, ex.msg)
end

# Declaration
@dict_readable struct DeclarationClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    linkSupport::Union{Bool,Missing}
end

struct DeclarationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DeclarationRegistrationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    documentSelector::Union{DocumentSelector,Nothing}
    id::Union{String,Missing}
end

@dict_readable struct DeclarationParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

##############################################################################
# Definition
@dict_readable struct DefinitionClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    linkSupport::Union{Bool,Missing}
end

struct DefinitionOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DefinitionRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct DefinitionParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

##############################################################################
# Type definition
@dict_readable struct TypeDefinitionClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    linkSupport::Union{Bool,Missing}
end

struct TypeDefinitionOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct TypeDefinitionRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
    id::Union{String,Missing}
end

@dict_readable struct TypeDefinitionParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

##############################################################################
# Implementation
@dict_readable struct ImplementationClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    linkSupport::Union{Bool,Missing}
end

struct ImplementationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct ImplementationRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
    id::Union{String,Missing}
end

@dict_readable struct ImplementationParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
end

##############################################################################
# References
@dict_readable struct ReferenceClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct ReferenceOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct ReferenceRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct ReferenceContext
    includeDeclaration::Bool
end

@dict_readable struct ReferenceParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
    partialResultToken::Union{Int,String,Missing} # ProgressToken
    context::ReferenceContext
end

# Julia-specific extensions to the LSP

@dict_readable struct VersionedTextDocumentPositionParams
    textDocument::TextDocumentIdentifier
    version::Int
    position::Position
end

@dict_readable struct TestItemDetail <: Outbound
    id::String
    label::String
    range::Range
    code::Union{Nothing,String}
    code_range::Union{Nothing,Range}
    option_default_imports::Union{Nothing,Bool}
    option_tags::Union{Nothing,Vector{String}}
end

@dict_readable struct TestSetupDetail <: Outbound
    name::String
    range::Range
    code::Union{Nothing,String}
    code_range::Union{Nothing,Range}
end

@dict_readable struct TestErrorDetail <: Outbound
    range::Range
    error::String
end

struct PublishTestsParams <: Outbound
    uri::DocumentUri
    version::Union{Int,Missing}
    project_path::String
    package_path::String
    package_name::String
    testitemdetails::Vector{TestItemDetail}
    testsetupdetails::Vector{TestSetupDetail}
    testerrordetails::Vector{TestErrorDetail}
end

include("messagedefs.jl")

# Document
@dict_readable struct DocumentFormattingClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct DocumentFormattingOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentFormattingRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct FormattingOptions <: Outbound
    tabSize::Integer
    insertSpaces::Bool
    trimTrailingWhitespace::Union{Bool,Missing}
    insertFinalNewline::Union{Bool,Missing}
    trimFinalNewlines::Union{Bool,Missing}
end

@dict_readable struct DocumentFormattingParams <: Outbound
    textDocument::TextDocumentIdentifier
    options::FormattingOptions
end


# Range
@dict_readable struct DocumentRangeFormattingClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct DocumentRangeFormattingOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct DocumentRangeFormattingRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    workDoneProgress::Union{Bool,Missing}
end

@dict_readable struct DocumentRangeFormattingParams
    textDocument::TextDocumentIdentifier
    range::Range
    options::FormattingOptions
end


# On type
@dict_readable struct DocumentOnTypeFormattingClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
end

struct DocumentOnTypeFormattingOptions <: Outbound
    firstTriggerCharacter::String
    moreTriggerCharacters::Union{Vector{String},Missing}
end

struct DocumentOnTypeFormattingRegistrationOptions <: Outbound
    documentSelector::DocumentSelector
    firstTriggerCharacter::String
    moreTriggerCharacer::Vector{String}
end

@dict_readable struct DocumentOnTypeFormattingParams
    textDocument::TextDocumentIdentifier
    position::Position
    ch::String
    options::FormattingOptions
end

@testitem "reexport" begin
    include("../test_shared_server.jl")

    settestdoc("using Base.Meta\n")
    @test any(c.command == "ReexportModule" for c in action_request_test(0, 15))
    c = filter(c -> c.command == "ReexportModule", action_request_test(0, 15))[1]
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "inline expand" begin
    include("../test_shared_server.jl")

    settestdoc("f(x) = x")
    @test any(c.command == "ExpandFunction" for c in action_request_test(0, 5))
    c = filter(c -> c.command == "ExpandFunction", action_request_test(0, 5))[1]

    settestdoc("g(x) = x\nf(x) = x")
    @test any(c.command == "ExpandFunction" for c in action_request_test(0, 0))
    @test any(c.command == "ExpandFunction" for c in action_request_test(1, 0))
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)

    settestdoc("f(x) = begin x end")
    @test any(c.command == "ExpandFunction" for c in action_request_test(0, 5))
    c = filter(c -> c.command == "ExpandFunction", action_request_test(0, 5))[1]
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "fixmissingref" begin
    include("../test_shared_server.jl")

    doc = settestdoc("argtail\n")
    e = LanguageServer.mark_errors(doc)[1]
    @test any(c.command == "FixMissingRef" for c in action_request_test(0, 5, diags=[e]))
    c = filter(c -> c.command == "FixMissingRef", action_request_test(0, 5, diags=[e]))[1]
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "explicit import" begin
    include("../test_shared_server.jl")

    doc = settestdoc("using Base.Meta\nMeta.quot")
    @test LanguageServer.find_using_statement(doc.cst.args[2].args[1]) !== nothing
    
    @test any(c.command == "ExplicitPackageVarImport" for c in action_request_test(1, 1))
    c = filter(c -> c.command == "ExplicitPackageVarImport", action_request_test(1, 1))[1]
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "farg unused" begin
    include("../test_shared_server.jl")

    doc = settestdoc("function f(arg::T) end\n")
    
    @test any(c.command == "DeleteUnusedFunctionArgumentName" for c in action_request_test(0, 12))
    c = filter(c -> c.command == "DeleteUnusedFunctionArgumentName", action_request_test(0, 12))[1]
    
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "unused assignment" begin
    include("../test_shared_server.jl")

    doc = settestdoc("function f()\n    x = 1 + 2\n    return 3\nend\n")

    @test any(c.command == "ReplaceUnusedAssignmentName" for c in action_request_test(1, 4))
    c = filter(c -> c.command == "ReplaceUnusedAssignmentName", action_request_test(1, 4))[1]

    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "===/!== for nothing comparison" begin
    include("../test_shared_server.jl")

    for str in ("x = 1\nif x == nothing end", "x = 1\nif x != nothing end")
        doc = settestdoc(str)
        @test any(c.command == "CompareNothingWithTripleEqual" for c in action_request_test(1, 6))
        c = filter(c -> c.command == "CompareNothingWithTripleEqual", action_request_test(1, 6))[1]
        LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
    end
end

@testitem "Add license header" begin
    include("../test_shared_server.jl")

    doc = settestdoc("hello\nworld\n")

    @test !any(c.command == "AddLicenseIdentifier" for c in action_request_test(1, 1))

    @test any(c.command == "AddLicenseIdentifier" for c in action_request_test(0, 1))
    c = filter(c -> c.command == "AddLicenseIdentifier", action_request_test(0, 1))[1]

    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "Organize imports" begin
    include("../test_shared_server.jl")

    doc = settestdoc("using JSON\nusing Example: foo, bar\nf(x) = x\n")

    @test any(c.command == "OrganizeImports" for c in action_request_test(0, 1))
    @test any(c.command == "OrganizeImports" for c in action_request_test(1, 10))
    @test !any(c.command == "OrganizeImports" for c in action_request_test(2, 2))

    c = filter(c -> c.command == "OrganizeImports", action_request_test(0, 1))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)

    settestdoc("using .LocalModule: foo\n")
    c = filter(c -> c.command == "OrganizeImports", action_request_test(0, 1))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "Convert between string and raw strings" begin
    include("../test_shared_server.jl")

    # "..." -> raw"..."
    doc = settestdoc("""
        "this is fine"

        @show "this is fine"

        @raw_str "this is fine"

        r"not fine"

        "not \$(fine) either"

        "docstring"
        f(x) = x
        """)

    @test any(c.command == "RewriteAsRawString" for c in action_request_test(0, 2))
    @test any(c.command == "RewriteAsRawString" for c in action_request_test(2, 10))
    @test any(c.command == "RewriteAsRawString" for c in action_request_test(4, 12))
    @test !any(c.command == "RewriteAsRawString" for c in action_request_test(6, 4))
    @test !any(c.command == "RewriteAsRawString" for c in action_request_test(8, 2))
    @test !any(c.command == "RewriteAsRawString" for c in action_request_test(10, 3))

    c = filter(c -> c.command == "RewriteAsRawString", action_request_test(0, 2))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)

    # Test the internal method doing the conversion, with `quotes = "\""`
    # raw = string("raw", quotes, sprint(escape_raw_string, valof(x)), quotes)
    str = "he\$\"llo"
    raw_str = "he\$\\\"llo" # Will be `he$\"llo` when unescaped/printed
    @test sprint(LanguageServer.escape_raw_string, str) == raw_str

    # raw"..." -> "..."
    doc = settestdoc("""
        raw"this is fine"

        @raw_str "not fine"

        "not fine"
        """)

    @test any(c.command == "RewriteAsRegularString" for c in action_request_test(0, 5))
    @test !any(c.command == "RewriteAsRegularString" for c in action_request_test(2, 12))
    @test !any(c.command == "RewriteAsRegularString" for c in action_request_test(4, 3))

    c = filter(c -> c.command == "RewriteAsRegularString", action_request_test(0, 5))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)

    # Test the internal method doing the conversion, with `quotes = ""`
    # regular = quotes * repr(valof(x)) * quotes
    raw_str = "he\$l\"lo"
    str = "\"he\\\$l\\\"lo\"" # Will be `"he\$l\"lo` when unescaped/printed
    @test repr(raw_str) == str
end

@testitem "Add docstring template" begin
    include("../test_shared_server.jl")

    doc = settestdoc("""
        f(x) = x

        @inline f(x) = x

        f(x::T) where T <: Int = x

        function g(x)
        end

        function g(x::T) where T <: Int
        end

        "docstring"
        h(x) = x

        "docstring"
        function h(x)
        end
        """)

    ok_locations = [
        [(0, i) for i in 0:3],
        [(2, i) for i in 8:11],
        [(4, i) for i in 0:21],
        [(6, i) for i in 0:12],
        [(9, i) for i in 0:30],
    ]
    not_ok_locations = [
        [(13, i) for i in 0:4],
        [(16, i) for i in 0:12],
    ]
    for loc in Iterators.flatten(ok_locations)
        @test any(c.command == "AddDocstringTemplate" for c in action_request_test(loc...))
    end
    for loc in Iterators.flatten(not_ok_locations)
        @test !any(c.command == "AddDocstringTemplate" for c in action_request_test(loc...))
    end

    c = filter(c -> c.command == "AddDocstringTemplate", action_request_test(0, 1))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

@testitem "Update docstring signature" begin
    include("../test_shared_server.jl")
    
    doc = settestdoc("""
        "hello"
        f(x) = x

        \"\"\"hello\"\"\"
        g(x) = x

        \"\"\"
            h()

        hello
        \"\"\"
        function h(x)
        end

        i(x) = x

        "not a docstring for function"
        foobar
        """)

    # In signature
    @test any(c.command == "UpdateDocstringSignature" for c in action_request_test(1, 0))
    @test any(c.command == "UpdateDocstringSignature" for c in action_request_test(4, 0))
    @test any(c.command == "UpdateDocstringSignature" for c in action_request_test(11, 0))
    @test !any(c.command == "UpdateDocstringSignature" for c in action_request_test(14, 0))
    @test !any(c.command == "UpdateDocstringSignature" for c in action_request_test(17, 0))

    c = filter(c -> c.command == "UpdateDocstringSignature", action_request_test(1, 0))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)

    # In docstring
    @test any(c.command == "UpdateDocstringSignature" for c in action_request_test(0, 0))
    @test any(c.command == "UpdateDocstringSignature" for c in action_request_test(7, 0))
    @test !any(c.command == "UpdateDocstringSignature" for c in action_request_test(16, 0))

    c = filter(c -> c.command == "UpdateDocstringSignature", action_request_test(0, 0))[1]
    LanguageServer.workspace_executeCommand_request(LanguageServer.ExecuteCommandParams(missing, c.command, c.arguments), server, server.jr_endpoint)
end

module URIs2

import URIs

export URI, uri2filepath, filepath2uri, @uri_str

struct URI
    scheme::Union{String,Nothing}
    authority::Union{String,Nothing}
    path::String
    query::Union{String,Nothing}
    fragment::Union{String,Nothing}
end

@static if Sys.iswindows()
    function Base.:(==)(a::URI, b::URI)
        if a.scheme=="file" && b.scheme=="file"
            a_path_norm = lowercase(a.path)
            b_path_norm = lowercase(b.path)

            return a.scheme == b.scheme &&
                a.authority == b.authority &&
                a_path_norm == b_path_norm &&
                a.query == b.query &&
                a.fragment == b.fragment
        else
            return a.scheme == b.scheme &&
                a.authority == b.authority &&
                a.path == b.path &&
                a.query == b.query &&
                a.fragment == b.fragment
        end
    end

    function Base.hash(a::URI, h::UInt)
        if a.scheme=="file"
            path_norm = lowercase(a.path)
            return hash((a.scheme, a.authority, path_norm, a.query, a.fragment), h)
        else
            return hash((a.scheme, a.authority, a.path, a.query, a.fragment), h)
        end
    end
end

function percent_decode(str::AbstractString)
    return URIs.unescapeuri(str)
end

function URI(value::AbstractString)
    m = match(r"^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?", value)

    m===nothing && error("Invalid argument.")

    return URI(
        m.captures[2],
        m.captures[4]===nothing ? nothing : percent_decode(m.captures[4]),
        m.captures[5]===nothing ? nothing : percent_decode(m.captures[5]),
        m.captures[7]===nothing ? nothing : percent_decode(m.captures[7]),
        m.captures[9]===nothing ? nothing : percent_decode(m.captures[9])
    )
end

URI(uri::URI) = uri

function URI(;
    scheme::Union{AbstractString,Nothing}=nothing,
    authority::Union{AbstractString,Nothing}=nothing,
    path::AbstractString="",
    query::Union{AbstractString,Nothing}=nothing,
    fragment::Union{AbstractString,Nothing}=nothing
    )
    return URI(scheme, authority, path, query, fragment)
end

@inline function is_rfc3986_unreserved(c::Char)
    return 'A' <= c <= 'Z' ||
        'a' <= c <= 'z' ||
        '0' <= c <= '9' ||
        c == '-' ||
        c == '.' ||
        c == '_' ||
        c == '~'
end

@inline function is_rfc3986_sub_delim(c::Char)
    return c == '!' ||
        c == '$' ||
        c == '&' ||
        c == '\'' ||
        c == '(' ||
        c == ')' ||
        c == '*' ||
        c == '+' ||
        c == ',' ||
        c == ';' ||
        c == '='
end

@inline function is_rfc3986_pchar(c::Char)
    return is_rfc3986_unreserved(c) ||
        is_rfc3986_sub_delim(c) ||
        c == ':' ||
        c == '@'
end

@inline function is_rfc3986_query(c::Char)
    return is_rfc3986_pchar(c) || c=='/' || c=='?'
end

@inline function is_rfc3986_fragment(c::Char)
    return is_rfc3986_pchar(c) || c=='/' || c=='?'
end

@inline function is_rfc3986_userinfo(c::Char)
    return is_rfc3986_unreserved(c) ||
        is_rfc3986_sub_delim(c) ||
        c == ':'
end

@inline function is_rfc3986_reg_name(c::Char)
    return is_rfc3986_unreserved(c) ||
        is_rfc3986_sub_delim(c)
end

function encode(io::IO, s::AbstractString, issafe::Function)
    for c in s
        if issafe(c)
            print(io, c)
        else
            print(io, '%')
            print(io, uppercase(string(Int(c), base=16, pad=2)))
        end
    end
end

@inline function is_ipv4address(s::AbstractString)
    if length(s)==1
        return '0' <= s[1] <= '9'
    elseif length(s)==2
        return '1' <= s[1] <= '9' && '0' <= s[2] <= '9'
    elseif length(s)==3
        return (s[1]=='1' && '0' <= s[2] <= '9' && '0' <= s[3] <= '9') ||
            (s[1]=='2' && '0' <= s[2] <= '4' && '0' <= s[3] <= '9') ||
            (s[1]=='2' && s[2] == '5' && '0' <= s[3] <= '5')
    else
        return false
    end
end

@inline function is_ipliteral(s::AbstractString)
    # TODO Implement this
    return false
end

function encode_host(io::IO, s::AbstractString)
    if is_ipv4address(s) || is_ipliteral(s)
        print(io, s)
    else
        # The host must be a reg-name
        encode(io, s, is_rfc3986_reg_name)
    end
end

function encode_path(io::IO, s::AbstractString)
    # TODO Write our own version
    print(io, URIs.escapepath(s))
end

function Base.print(io::IO, uri::URI)
    scheme = uri.scheme
    authority = uri.authority
    path = uri.path
    query = uri.query
    fragment = uri.fragment

 	if scheme!==nothing
        print(io, scheme)
        print(io, ':')
 	end

 	if authority!==nothing
        print(io, "//")

		idx = findfirst("@", authority)
		if idx !== nothing
			# <user>@<auth>
			userinfo = SubString(authority, 1:idx.start-1)
			host_and_port = SubString(authority, idx.start + 1)
			encode(io, userinfo, is_rfc3986_userinfo)
            print(io, '@')
        else
            host_and_port = SubString(authority, 1)
		end

		idx3 = findfirst(":", host_and_port)
		if idx3 === nothing
            encode_host(io, host_and_port)
		else
			# <auth>:<port>
            encode_host(io, SubString(host_and_port, 1:idx3.start-1))
			print(io, SubString(host_and_port, idx3.start))
        end
     end

     # Append path
     encode_path(io, path)

    if query!==nothing
        print(io, '?')
        encode(io, query, is_rfc3986_query)
    end

 	if fragment!==nothing
        print(io, '#')
        encode(io, fragment, is_rfc3986_fragment)
    end

    return nothing
end

function Base.string(uri::URI)
    io = IOBuffer()

    print(io, uri)

    return String(take!(io))
end

macro uri_str(ex)
    return URI(ex)
end

include("uri_helpers.jl")

end

function cancel_notification(params::CancelParams, server::LanguageServerInstance, conn)
end

function setTrace_notification(params::SetTraceParams, server::LanguageServerInstance, conn)
end

# TODO Provide type for params
function setTraceNotification_notification(params, server::LanguageServerInstance, conn)
end

function julia_getCurrentBlockRange_request(tdpp::VersionedTextDocumentPositionParams, server::LanguageServerInstance, conn)
    fallback = (Position(0, 0), Position(0, 0), tdpp.position)
    uri = tdpp.textDocument.uri

    hasdocument(server, uri) || return nodocument_error(uri)

    doc = getdocument(server, uri)

    if get_version(doc) !== tdpp.version
        return mismatched_version_error(uri, doc, tdpp, "getCurrentBlockRange")
    end

    offset = get_offset(doc, tdpp.position)
    x = getcst(doc)
    loc = 0

    if headof(x) === :file
        for (i, a) in enumerate(x)
            if loc <= offset <= loc + a.fullspan
                # we'll try to use the next expression instead if the current expr is a
                # NOTHING or we're in the whitespace after an expr _and_ that whitespace wraps
                # to a new line
                if !(loc <= offset <= loc + a.span) || headof(a) === :NOTHING
                    if length(x) > i
                        thisline, _ = get_position_from_offset(doc, loc + a.span)
                        if tdpp.position.line > thisline || headof(a) === :NOTHING
                            loc += a.fullspan
                            a = x[i + 1]
                        end
                    end
                end

                if a.head === :macrocall && a.args[1].head === :globalrefdoc && length(a.args) == 4 && CSTParser.defines_module(a.args[4])
                    for i in 1:3
                        loc += a.args[i].fullspan
                    end
                    a = a.args[4]
                end

                if CSTParser.defines_module(a) # Within module at the top-level, lets see if we can select on of the block arguments
                    if loc <= offset <= loc + a.trivia[1].span # Within `module` keyword, so return entire expression
                        return Position(get_position_from_offset(doc, loc)...), Position(get_position_from_offset(doc, loc + a.span)...), Position(get_position_from_offset(doc, loc + a.fullspan)...)
                    end
                    if loc + a.trivia[1].fullspan <= offset <= loc + a.trivia[1].fullspan + a.args[2].span # Within name of the module, so return entire expression
                        return Position(get_position_from_offset(doc, loc)...), Position(get_position_from_offset(doc, loc + a.span)...), Position(get_position_from_offset(doc, loc + a.fullspan)...)
                    end

                    if loc + a.trivia[1].fullspan + a.args[2].fullspan <= offset <= loc + a.trivia[1].fullspan + a.args[2].fullspan + a.args[3].span # Within the body of a module
                        loc += a.trivia[1].fullspan + a.args[2].fullspan
                        for b in a.args[3].args
                            if loc <= offset <= loc + b.span
                                return Position(get_position_from_offset(doc, loc)...), Position(get_position_from_offset(doc, loc + b.span)...), Position(get_position_from_offset(doc, loc + b.fullspan)...)
                            end
                            loc += b.fullspan
                        end
                    elseif loc + a.trivia[1].fullspan + a.args[2].fullspan + a.args[3].fullspan < offset <= loc + a.trivia[1].fullspan + a.args[2].fullspan + a.args[3].fullspan + a.trivia[2].span # Within `end` of the module, so return entire expression
                        return Position(get_position_from_offset(doc, loc)...), Position(get_position_from_offset(doc, loc + a.span)...), Position(get_position_from_offset(doc, loc + a.fullspan)...)
                    end
                else
                    return Position(get_position_from_offset(doc, loc)...), Position(get_position_from_offset(doc, loc + a.span)...), Position(get_position_from_offset(doc, loc + a.fullspan)...)
                end
            end
            loc += a.fullspan
        end
    end
    return fallback
end

function julia_activateenvironment_notification(params::NamedTuple{(:envPath,),Tuple{String}}, server::LanguageServerInstance, conn)
    if server.env_path != params.envPath
        server.env_path = params.envPath

        files_to_check = [joinpath(server.env_path, "Project.toml"), joinpath(server.env_path, "JuliaProject.toml"), joinpath(server.env_path, "Manifest.toml"), joinpath(server.env_path, "JuliaManifest.toml")]

        for file_to_check in files_to_check
            if isfile(file_to_check)
                server.workspace = add_file(server.workspace, filepath2uri(file_to_check))
            end
        end

        trigger_symbolstore_reload(server)
    end
end

julia_refreshLanguageServer_notification(_, server::LanguageServerInstance, conn) =
    trigger_symbolstore_reload(server)

function textDocument_documentLink_request(params::DocumentLinkParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    links = DocumentLink[]
    find_document_links(getcst(doc), doc, 0, links)
    return links
end

function find_document_links(x, doc, offset, links)
    if x isa EXPR && CSTParser.isstringliteral(x)
        if valof(x) isa String && isvalid(valof(x)) && sizeof(valof(x)) < 256 # AUDIT: OK
            try
                if isabspath(valof(x)) && safe_isfile(valof(x))
                    path = valof(x)
                    push!(links, DocumentLink(Range(doc, offset .+ (0:x.span)), filepath2uri(path), missing, missing))
                elseif !isempty(getpath(doc)) && safe_isfile(joinpath(_dirname(getpath(doc)), valof(x)))
                    path = joinpath(_dirname(getpath(doc)), valof(x))
                    push!(links, DocumentLink(Range(doc, offset .+ (0:x.span)), filepath2uri(path), missing, missing))
                end
            catch err
                isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
            end
        end
    end
    if x.args !== nothing
        for arg in x
            find_document_links(arg, doc, offset, links)
            offset += arg.fullspan
        end
    end
end

struct TextDocument
    _uri::URI
    _content::String
    _version::Int
    _line_offsets::Union{Nothing,Vector{Int}} # TODO Legacy, remove eventually
    _line_indices::Union{Nothing,Vector{Int}}
    _language_id::String

    function TextDocument(uri::URI, text::AbstractString, version::Int, lid = nothing)
        # TODO Remove this check eventually
        occursin('\0', text) && throw(LSInvalidFile("Tried to set a text with an embedded NULL as the document content."))

        line_offsets = _compute_line_offsets(text)
        line_indices = _compute_line_indices(text)

        if lid === nothing
            if endswith(uri.path, ".jmd")
                lid = "juliamarkdown"
            elseif endswith(uri.path, ".md")
                lid = "markdown"
            elseif endswith(uri.path, ".jl")
                lid = "julia"
            else
                lid = ""
            end
        end

        return new(uri, text, version, line_offsets, line_indices, lid)
    end
end

function Base.show(io::IO, ::MIME"text/plain", doc::TextDocument)
    print(io, "TextDocument: ", doc._uri)
end

get_text(doc::TextDocument) = doc._content

get_uri(doc::TextDocument) = doc._uri

get_version(doc::TextDocument) = doc._version

get_line_indices(doc::TextDocument) = doc._line_indices

get_language_id(doc::TextDocument) = doc._language_id

"""
    index_at(doc::TextDocument, p::Position, forgiving_mode=false)

Converts a 0-based `Position` that is UTF-16 encoded to a 1-based UTF-8
encoded Julia string index.
"""
function index_at(doc::TextDocument, p::Position, forgiving_mode=false)
    line = p.line
    character = p.character

    line_indices = get_line_indices(doc)
    text = get_text(doc)

    if line >= length(line_indices)
        forgiving_mode || throw(LSOffsetError("index_at crashed. More diagnostics:\nline=$line\nline_indices='$line_indices'"))

        return nextind(text, lastindex(text))
    elseif line < 0
        throw(LSOffsetError("index_at crashed. More diagnostics:\nline=$line\nline_indices='$line_indices'"))
    end

    line_index = line_indices[line + 1]

    next_line_index = line + 1 < length(line_indices) ? line_indices[line + 2] : nextind(text, lastindex(text))

    pos = line_index

    while character > 0
        if pos >= next_line_index
            pos = next_line_index
            break
        end

        if UInt32(text[pos]) >= 0x010000
            character -= 2
        else
            character -= 1
        end

        pos = nextind(text, pos)
    end

    return pos
end

function apply_text_edits(doc::TextDocument, edits, new_version)
    content = doc._content

    for edit in edits
        if ismissing(edit.range) && ismissing(edit.rangeLength)
            # No range given, replace all text
            content = edit.text
        else
            # Rebind doc here so that we compute the range for the updated document in
            # _convert_lsrange_to_jlrange when applying multiple edits
            doc = TextDocument(doc._uri, content, new_version, get_language_id(doc))
            editrange = _convert_lsrange_to_jlrange(doc, edit.range)
            content = string(content[1:prevind(content, editrange.start)], edit.text, content[nextind(content, editrange.stop):lastindex(content)])
        end
    end

    return TextDocument(doc._uri, content, new_version, get_language_id(doc))
end

# =====================
# Internal functions
# =====================

function _convert_lsrange_to_jlrange(doc::TextDocument, range::Range)
    start_index_ls = index_at(doc, range.start)
    stop_index = index_at(doc, range.stop)

    content = doc._content

    # we use prevind for the stop value here because Julia stop values in
    # a range are inclusive, while the stop value is exclusive in a LS
    # range
    return start_index_ls:prevind(content, stop_index)
end

function _compute_line_indices(text)
    line_indices = Int[1]

    ind = firstindex(text)
    while ind <= lastindex(text)
        c = text[ind]
        if c == '\n' || c == '\r'
            if c == '\r' && ind + 1 <= lastindex(text) && text[ind + 1] == '\n'
                ind += 1
            end
            push!(line_indices, ind + 1)
        end

        ind = nextind(text, ind)
    end
    return line_indices
end

# Note: to be removed
function _obscure_text(s)
    i = 1
    io = IOBuffer()
    while i <= sizeof(s) # AUDIT: OK, i is generated by nextind
        di = nextind(s, i) - i
        if di == 1
            if s[i] in ('\n', '\r')
                write(io, s[i])
            else
                write(io, "a")
            end
        elseif di == 2
            write(io, "α")
        elseif di == 3
            write(io, "—")
        else
            write(io, s[i])
        end
        i += di
    end
    String(take!(io))
end

function _get_line_of(doc::TextDocument, offset::Integer)
    line_offsets = doc._line_offsets
    nlines = length(line_offsets)
    if offset > last(line_offsets)
        line = nlines
    else
        line = 1
        while line < nlines
            if line_offsets[line] <= offset < line_offsets[line + 1]
                break
            end
            line += 1
        end
end
    return line, line_offsets[line]
end

# ======================
# TODO The following functions are legacy offset versions that should eventually be removed
# ======================

function _compute_line_offsets(text)
    line_offsets = Int[0]

    ind = firstindex(text)
    while ind <= lastindex(text)
        c = text[ind]
        nl = c == '\n' || c == '\r'
        if c == '\r' && ind + 1 <= lastindex(text) && text[ind + 1] == '\n'
            ind += 1
        end
        nl && push!(line_offsets, ind)
        ind = nextind(text, ind)
    end

    return line_offsets
end

"""
    get_line_offsets(doc::Document)

Updates the doc._line_offsets field, an n length Array each entry of which
gives the byte offset position of the start of each line. This always starts
with 0 for the first line (even if empty).
"""
get_line_offsets(doc::TextDocument) = doc._line_offsets

"""
    get_offset(doc, line, char)

Returns the 0 based byte offset position corresponding to a line/character position.
This takes 0 based line/char inputs. Corresponding functions are available for
Position and Range arguments, the latter returning a UnitRange{Int}.
"""
function get_offset(doc::TextDocument, line::Integer, character::Integer)
    c = ' '
    line_offsets = get_line_offsets(doc)
    io = IOBuffer(get_text(doc))
    try
        seek(io, line_offsets[line + 1])
        while character > 0
            c = read(io, Char)
            character -= 1
            if UInt32(c) >= 0x010000
                character -= 1
            end
        end
        if UInt32(c) < 0x0080
            return position(io)
        elseif UInt32(c) < 0x0800
            return position(io) - 1
        elseif UInt32(c) < 0x010000
            return position(io) - 2
        else
            return position(io) - 3
        end
    catch err
        throw(LSOffsetError("get_offset crashed. More diagnostics:\nline=$line\ncharacter=$character\nposition(io)=$(position(io))\nline_offsets='$line_offsets'\ntext='$(_obscure_text(get_text(doc)))'\n\noriginal_error=$(sprint(Base.display_error, err, catch_backtrace()))"))
    end
end
get_offset(doc::TextDocument, p::Position) = get_offset(doc, p.line, p.character)
get_offset(doc::TextDocument, r::Range) = get_offset(doc, r.start):get_offset(doc, r.stop)

"""
    get_position_from_offset(doc, offset)

Returns the 0-based line and character position within a document of a given
byte offset.
"""
function get_position_from_offset(doc::TextDocument, offset::Integer)
    offset > sizeof(get_text(doc)) && throw(LSPositionToOffsetException("offset[$offset] > sizeof(content)[$(sizeof(get_text(doc)))]")) # OK, offset comes from EXPR spans
    line_offsets = get_line_offsets(doc)
    line, _ = _get_line_of(doc, offset)
    io = IOBuffer(get_text(doc))
    seek(io, line_offsets[line])
    character = 0
    while offset > position(io)
        c = read(io, Char)
        character += 1
        if UInt32(c) >= 0x010000
    character += 1
        end
    end
    close(io)
    return line - 1, character
end

"""
    Range(Doc, rng)
Converts a byte offset range to a LSP Range.
"""
function Range(doc::TextDocument, rng::UnitRange)
    start_l, start_c = get_position_from_offset(doc, first(rng))
    end_l, end_c = get_position_from_offset(doc, last(rng))
    rng = Range(start_l, start_c, end_l, end_c)
end

@testitem "Communication" begin
    import JSON, JSONRPC, Pkg
    using Sockets

    include("test_shared_init_request.jl")

    init_response = JSON.parse("""
    {
        "capabilities": {
            "textDocumentSync": 2,
            "hoverProvider": true,
            "completionProvider": {
                "resolveProvider": false,
                "triggerCharacters": [
                    "."
                ]
            },
            "signatureHelpProvider": {
                "triggerCharacters": [
                    "("
                ]
            },
            "definitionProvider": true,
            "typeDefinitionProvider": false,
            "implementationProvider": false,
            "referencesProvider": true,
            "documentHighlightProvider": false,
            "documentSymbolProvider": true,
            "workspaceSymbolProvider": true,
            "codeActionProvider": true,
            "documentFormattingProvider": true,
            "documentRangeFormattingProvider": false,
            "renameProvider": {
                "prepareProvider": true
            },
            "documentLinkProvider": {
                "resolveProvider": false
            },
            "colorProvider": false,
            "executeCommandProvider": {
                "commands": []
            },
            "workspace": {
                "workspaceFolders": {
                    "supported": true,
                    "changeNotifications": true
                }
            },
            "experimental": null
        }
    }
    """)

    if Sys.iswindows()
        global_socket_name = "\\\\.\\pipe\\julia-language-server-testrun"
    elseif Sys.isunix()
        global_socket_name = joinpath(tempdir(), "julia-language-server-testrun")
    else
        error("Unknown operating system.")
    end

    @async try
        server = listen(global_socket_name)
        try
            sock = accept(server)
            try
                runserver(sock, sock, Pkg.Types.Context().env.project_file, first(DEPOT_PATH))
            finally
                close(sock)
            end
        finally
            close(server)
        end
    catch err
        Base.display_error(stderr, err, catch_backtrace())
        rethrow()
    end

    sleep(1)

    client = connect(global_socket_name)
    try
        endpoint = JSONRPC.JSONRPCEndpoint(client, client)
        run(endpoint)

        response = JSONRPC.send_request(endpoint, "initialize", init_request)

        @test_broken init_response == response
        @test response["capabilities"]["typeDefinitionProvider"] == false
        @test response["capabilities"]["renameProvider"] == Dict("prepareProvider" => true)
    finally
        close(client)
    end
end

@dict_readable struct HoverClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    contentFormat::Union{Vector{String},Missing}
end

@dict_readable struct HoverParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    workDoneToken::Union{Int,String,Missing} # ProgressToken
end

struct HoverOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
end

struct HoverRegistrationOptions <: Outbound
    workDoneProgress::Union{Bool,Missing}
    documentSelector::Union{DocumentSelector,Nothing}
end

struct Hover <: Outbound
    contents::Union{MarkedString,Vector{MarkedString},MarkupContent}
    range::Union{Range,Missing}
end

function textDocument_documentHighlight_request(params::DocumentHighlightParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    offset = get_offset(doc, params.position)
    identifier = get_identifier(getcst(doc), offset)
    identifier !== nothing || return nothing
    highlights = DocumentHighlight[]
    for_each_ref(identifier) do ref, doc1, o
        if get_uri(doc1) == get_uri(doc)
            kind = StaticLint.hasbinding(ref) ? DocumentHighlightKinds.Write : DocumentHighlightKinds.Read
            push!(highlights, DocumentHighlight(Range(doc, o .+ (0:ref.span)), kind))
        end
    end
    return isempty(highlights) ? nothing : highlights
end

const CompletionItemKind = Int
const CompletionItemKinds = (Text = 1,
                            Method = 2,
                            Function = 3,
                            Constructor = 4,
                            Field = 5,
                            Variable = 6,
                            Class = 7,
                            Interface = 8,
                            Module = 9,
                            Property = 10,
                            Unit = 11,
                            Value = 12,
                            Enum = 13,
                            Keyword = 14,
                            Snippet = 15,
                            Color = 16,
                            File = 17,
                            Reference = 18,
                            Folder = 19,
                            EnumMember = 20,
                            Constant = 21,
                            Struct = 22,
                            Event = 23,
                            Operator = 24,
                            TypeParameter = 25)

const CompletionItemTag = Int
const CompletionItemTags = (Deprecated = 1)

const CompletionTriggerKind = Int
const CompletionTriggerKinds = (Invoked = 1,
                                TriggerCharacter = 2,
                                TriggerForIncompleteCompletion = 3)

const InsertTextFormat = Int
const InsertTextFormats = (PlainText = 1,
                           Snippet = 2)

@dict_readable struct CompletionTagClientCapabilities
    valueSet::Vector{CompletionItemTag}
end

@dict_readable struct CompletionItemClientCapabilities <: Outbound
    snippetSupport::Union{Bool,Missing}
    commitCharactersSupport::Union{Bool,Missing}
    documentationFormat::Union{Vector{String},Missing}
    deprecatedSupport::Union{Bool,Missing}
    preselectSupport::Union{Bool,Missing}
    tagSupport::Union{CompletionTagClientCapabilities,Missing}
end

@dict_readable struct CompletionItemKindCapabilities <: Outbound
    valueSet::Union{Vector{CompletionItemKind},Missing}
end

@dict_readable struct CompletionClientCapabilities <: Outbound
    dynamicRegistration::Union{Bool,Missing}
    completionItem::Union{CompletionItemClientCapabilities,Missing}
    completionItemKind::Union{CompletionItemKindCapabilities,Missing}
    contextSupport::Union{Bool,Missing}
end

struct CompletionOptions <: Outbound
    resolveProvider::Union{Bool,Missing}
    triggerCharacters::Union{Vector{String},Missing}
    workDoneProgress::Union{Bool,Missing}
end

struct CompletionRegistrationOptions <: Outbound
    documentSelector::Union{DocumentSelector,Nothing}
    triggerCharacters::Union{Vector{String},Missing}
    allCommitCharacters::Union{Vector{String},Missing}
    resolveProvider::Union{Bool,Missing}
end

struct CompletionContext <: Outbound
    triggerKind::CompletionTriggerKind
    triggerCharacter::Union{String,Missing}
end

function CompletionContext(d::Dict)
    CompletionContext(d["triggerKind"], haskey(d, "triggerCharacter") && d["triggerCharacter"] isa String ? d["triggerCharacter"] : missing)
end

@dict_readable struct CompletionParams <: Outbound
    textDocument::TextDocumentIdentifier
    position::Position
    context::Union{CompletionContext,Missing}
end

struct CompletionItem <: Outbound
    label::String
    kind::Union{Int,Missing}
    tags::Union{CompletionItemTag,Missing}
    detail::Union{String,Missing}
    documentation::Union{String,MarkupContent,Missing}
    deprecated::Union{Bool,Missing}
    preselect::Union{Bool,Missing}
    sortText::Union{String,Missing}
    filterText::Union{String,Missing}
    insertText::Union{String,Missing}
    insertTextFormat::Union{InsertTextFormat,Missing}
    textEdit::Union{TextEdit,Missing}
    additionalTextEdits::Union{Vector{TextEdit},Missing}
    commitCharacters::Union{Vector{String},Missing}
    command::Union{Command,Missing}
    data::Union{Any,Missing}
end
CompletionItem(label, kind, documentation, textEdit) = CompletionItem(label, kind, missing, missing, documentation, missing, missing, missing, missing, missing, InsertTextFormats.PlainText, textEdit, missing, missing, missing, missing)
CompletionItem(label, kind, detail, documentation, textEdit) = CompletionItem(label, kind, missing, detail, documentation, missing, missing, missing, missing, missing, InsertTextFormats.PlainText, textEdit, missing, missing, missing, missing)

struct CompletionList <: Outbound
    isIncomplete::Bool
    items::Vector{CompletionItem}
end

# TODO: should be in StaticLint. visited check is costly.
resolve_shadow_binding(b) = b
function resolve_shadow_binding(b::StaticLint.Binding, visited=StaticLint.Binding[])
    if b in visited
        throw(LSInfiniteLoop("Infinite loop in bindings."))
    else
        push!(visited, b)
    end
    if b.val isa StaticLint.Binding
        return resolve_shadow_binding(b.val, visited)
    else
        return b
    end
end

function get_definitions(x, tls, env, locations) end # Fallback

function get_definitions(x::SymbolServer.ModuleStore, tls, env, locations)
    if haskey(x.vals, :eval) && x[:eval] isa SymbolServer.FunctionStore
        get_definitions(x[:eval], tls, env, locations)
    end
end

function get_definitions(x::Union{SymbolServer.FunctionStore,SymbolServer.DataTypeStore}, tls, env, locations)
    StaticLint.iterate_over_ss_methods(x, tls, env, function (m)
        if safe_isfile(m.file)
            push!(locations, Location(filepath2uri(m.file), Range(m.line - 1, 0, m.line - 1, 0)))
        end
        return false
    end)
end

function get_definitions(b::StaticLint.Binding, tls, env, locations)
    if !(b.val isa EXPR)
        get_definitions(b.val, tls, env, locations)
    end
    if b.type === StaticLint.CoreTypes.Function || b.type === StaticLint.CoreTypes.DataType
        for ref in b.refs
            method = StaticLint.get_method(ref)
            if method !== nothing
                get_definitions(method, tls, env, locations)
            end
        end
    elseif b.val isa EXPR
        get_definitions(b.val, tls, env, locations)
    end
end

function get_definitions(x::EXPR, tls::StaticLint.Scope, env, locations)
    doc1, o = get_file_loc(x)
    if doc1 isa Document
        push!(locations, Location(get_uri(doc1), Range(doc1, o .+ (0:x.span))))
    end
end

safe_isfile(s::Symbol) = safe_isfile(string(s))
safe_isfile(::Nothing) = false
function safe_isfile(s::AbstractString)
    try
        !occursin("\0", s) && isfile(s)
    catch err
        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        false
    end
end

function textDocument_definition_request(params::TextDocumentPositionParams, server::LanguageServerInstance, conn)
    locations = Location[]
    doc = getdocument(server, params.textDocument.uri)
    offset = get_offset(doc, params.position)
    x = get_expr1(getcst(doc), offset)
    if x isa EXPR && StaticLint.hasref(x)
        # Replace with own function to retrieve references (with loop saftey-breaker)
        b = refof(x)
        b = resolve_shadow_binding(b)
        (tls = StaticLint.retrieve_toplevel_scope(x)) === nothing && return locations
        get_definitions(b, tls, getenv(doc, server), locations)
    end

    return unique!(locations)
end

function descend(x::EXPR, target::EXPR, offset=0)
    x == target && return (true, offset)
    for c in x
        if c == target
            return true, offset
        end

        found, o = descend(c, target, offset)
        if found
            return true, o
        end
        offset += c.fullspan
    end
    return false, offset
end
function get_file_loc(x::EXPR, offset=0, c=nothing)
    parent = x
    while parentof(parent) !== nothing
        parent = parentof(parent)
    end

    if parent === nothing
        return nothing, offset
    end

    _, offset = descend(parent, x)

    if headof(parent) === :file && StaticLint.hasmeta(parent)
        return parent.meta.error, offset
    end
    return nothing, offset
end

function search_file(filename, dir, topdir)
    parent_dir = dirname(dir)
    return if (!startswith(dir, topdir) || parent_dir == dir || isempty(dir))
        nothing
    else
        path = joinpath(dir, filename)
        isfile(path) ? path : search_file(filename, parent_dir, topdir)
    end
end

function get_juliaformatter_config(doc, server)
    path = get_path(doc)

    # search through workspace for a `.JuliaFormatter.toml`
    workspace_dirs = sort(filter(f -> startswith(path, f), collect(server.workspaceFolders)), by = length, rev = true)
    config_path = length(workspace_dirs) > 0 ?
        search_file(JuliaFormatter.CONFIG_FILE_NAME, path, workspace_dirs[1]) :
        nothing

    config_path === nothing && return nothing

    @debug "Found JuliaFormatter config at $(config_path)"
    return JuliaFormatter.parse_config(config_path)
end

function default_juliaformatter_config(params)
    return (
        indent = params.options.tabSize,
        annotate_untyped_fields_with_any = false,
        join_lines_based_on_source = true,
        trailing_comma = nothing,
        margin = 10_000,
        always_for_in = nothing,
        whitespace_in_kwargs = false
    )
end

function textDocument_formatting_request(params::DocumentFormattingParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)

    newcontent = try
        config = get_juliaformatter_config(doc, server)
        format_text(get_text(doc), params, config)
    catch err
        return JSONRPC.JSONRPCError(
            -32000,
            "Failed to format document: $err.",
            nothing
        )
    end

    end_l, end_c = get_position_from_offset(doc, sizeof(get_text(doc))) # AUDIT: OK
    lsedits = TextEdit[TextEdit(Range(0, 0, end_l, end_c), newcontent)]

    return lsedits
end

function format_text(text::AbstractString, params, config)
    if config === nothing
        return JuliaFormatter.format_text(text; default_juliaformatter_config(params)...)
    else
        # Some valid options in config file are not valid for format_text
        VALID_OPTIONS = (fieldnames(JuliaFormatter.Options)..., :style)
        config = filter(p -> in(first(p), VALID_OPTIONS), JuliaFormatter.kwargs(config))
        return JuliaFormatter.format_text(text; config...)
    end
end

# Strings broken up and joined with * to make this file formattable
const FORMAT_MARK_BEGIN = "---- BEGIN LANGUAGESERVER" * " RANGE FORMATTING ----"
const FORMAT_MARK_END = "---- END LANGUAGESERVER" * " RANGE FORMATTING ----"

function textDocument_range_formatting_request(params::DocumentRangeFormattingParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    oldcontent = get_text(doc)
    startline = params.range.start.line + 1
    stopline = params.range.stop.line + 1

    # Insert start and stop line comments as markers in the original text
    original_lines = collect(eachline(IOBuffer(oldcontent); keep=true))
    stopline = min(stopline, length(original_lines))
    original_block = join(@view(original_lines[startline:stopline]))
    # If the stopline do not have a trailing newline we need to add that before our stop
    # comment marker. This is removed after formatting.
    stopline_has_newline = original_lines[stopline] != chomp(original_lines[stopline])
    insert!(original_lines, stopline + 1, (stopline_has_newline ? "# " : "\n# ") * FORMAT_MARK_END * "\n")
    insert!(original_lines, startline, "# " * FORMAT_MARK_BEGIN * "\n")
    text_marked = join(original_lines)

    # Format the full marked text
    text_formatted = try
        config = get_juliaformatter_config(doc, server)
        format_text(text_marked, params, config)
    catch err
        return JSONRPC.JSONRPCError(
            -33000,
            "Failed to format document: $err.",
            nothing
        )
    end

    # Find the markers in the formatted text and extract the lines in between
    formatted_lines = collect(eachline(IOBuffer(text_formatted); keep=true))
    start_idx = findfirst(x -> occursin(FORMAT_MARK_BEGIN, x), formatted_lines)
    start_idx === nothing && return TextEdit[]
    stop_idx = findfirst(x -> occursin(FORMAT_MARK_END, x), formatted_lines)
    stop_idx === nothing && return TextEdit[]
    formatted_block = join(@view(formatted_lines[(start_idx+1):(stop_idx-1)]))

    # Remove the extra inserted newline if there was none from the start
    if !stopline_has_newline
        formatted_block = chomp(formatted_block)
    end

    # Don't suggest an edit in case the formatted text is identical to original text
    if formatted_block == original_block
        return TextEdit[]
    end

    # End position is exclusive, replace until start of next line
    return TextEdit[TextEdit(Range(params.range.start.line, 0, params.range.stop.line + 1, 0), formatted_block)]
end

function find_references(textDocument::TextDocumentIdentifier, position::Position, server)
    locations = Location[]
    doc = getdocument(server, textDocument.uri)
    offset = get_offset(doc, position)
    x = get_expr1(getcst(doc), offset)
    x === nothing && return locations
    for_each_ref(x) do r, doc1, o
        push!(locations, Location(get_uri(doc1), Range(doc1, o .+ (0:r.span))))
    end
    return locations
end

function for_each_ref(f, identifier::EXPR)
    if identifier isa EXPR && StaticLint.hasref(identifier) && refof(identifier) isa StaticLint.Binding
        for r in StaticLint.loose_refs(refof(identifier))
            if r isa EXPR
                doc1, o = get_file_loc(r)
                if doc1 isa Document
                    f(r, doc1, o)
                end
            end
        end
    end
end

function textDocument_references_request(params::ReferenceParams, server::LanguageServerInstance, conn)
    return find_references(params.textDocument, params.position, server)
end

function textDocument_rename_request(params::RenameParams, server::LanguageServerInstance, conn)
    tdes = Dict{URI,TextDocumentEdit}()
    locations = find_references(params.textDocument, params.position, server)

    for loc in locations
        if loc.uri in keys(tdes)
            push!(tdes[loc.uri].edits, TextEdit(loc.range, params.newName))
        else
            doc = getdocument(server, loc.uri)
            tdes[loc.uri] = TextDocumentEdit(VersionedTextDocumentIdentifier(loc.uri, get_version(doc)), [TextEdit(loc.range, params.newName)])
        end
    end

    return WorkspaceEdit(missing, collect(values(tdes)))
end

function textDocument_prepareRename_request(params::PrepareRenameParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    x = get_expr1(getcst(doc), get_offset(doc, params.position))
    x isa EXPR || return nothing
    _, x_start_offset = get_file_loc(x)
    x_range = Range(doc, x_start_offset .+ (0:x.span))
    return x_range
end

function is_callable_object_binding(name::EXPR)
    CSTParser.isoperator(headof(name)) && valof(headof(name)) === "::" && length(name.args) >= 1
end
is_valid_binding_name(name) = false
function is_valid_binding_name(name::EXPR)
    (headof(name) === :IDENTIFIER && valof(name) isa String && !isempty(valof(name))) ||
    CSTParser.isoperator(name) ||
    (headof(name) === :NONSTDIDENTIFIER && length(name.args) == 2 && valof(name.args[2]) isa String && !isempty(valof(name.args[2]))) ||
    is_callable_object_binding(name)
end
function get_name_of_binding(name::EXPR)
    if headof(name) === :IDENTIFIER
        valof(name)
    elseif CSTParser.isoperator(name)
        string(to_codeobject(name))
    elseif headof(name) === :NONSTDIDENTIFIER
        valof(name.args[2])
    elseif is_callable_object_binding(name)
        string(to_codeobject(name))
    else
        ""
    end
end

function textDocument_documentSymbol_request(params::DocumentSymbolParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri
    doc = getdocument(server, uri)

    return collect_document_symbols(getcst(doc), server, doc)
end

struct BindingContext
    is_function_def::Bool
    is_datatype_def::Bool
    is_datatype_def_body::Bool
end
BindingContext() = BindingContext(false, false, false)

function collect_document_symbols(x::EXPR, server::LanguageServerInstance, doc, pos=0, ctx=BindingContext(), symbols=DocumentSymbol[])
    is_datatype_def_body = ctx.is_datatype_def_body
    if ctx.is_datatype_def && !is_datatype_def_body
        is_datatype_def_body = x.head === :block && length(x.parent.args) >= 3 && x.parent.args[3] == x
    end
    ctx = BindingContext(
        ctx.is_function_def || CSTParser.defines_function(x),
        ctx.is_datatype_def || CSTParser.defines_datatype(x),
        is_datatype_def_body,
    )

    if bindingof(x) !== nothing
        b =  bindingof(x)
        if b.val isa EXPR && is_valid_binding_name(b.name)
            ds = DocumentSymbol(
                get_name_of_binding(b.name), # name
                missing, # detail
                _binding_kind(b, ctx), # kind
                false, # deprecated
                Range(doc, (pos .+ (0:x.span))), # range
                Range(doc, (pos .+ (0:x.span))), # selection range
                DocumentSymbol[] # children
            )
            push!(symbols, ds)
            symbols = ds.children
        end
    elseif x.head == :macrocall
        # detect @testitem/testset "testname" ...
        child_nodes = filter(i -> !(isa(i, EXPR) && i.head == :NOTHING && i.args === nothing), x.args)
        if length(child_nodes) > 1
            macroname = CSTParser.valof(child_nodes[1])
            if macroname == "@testitem" || macroname == "@testset"
                if (child_nodes[2] isa EXPR && child_nodes[2].head == :STRING)
                    testname = CSTParser.valof(child_nodes[2])
                    ds = DocumentSymbol(
                        "$(macroname) \"$(testname)\"", # name
                        missing, # detail
                        3, # kind (namespace)
                        false, # deprecated
                        Range(doc, (pos .+ (0:x.span))), # range
                        Range(doc, (pos .+ (0:x.span))), # selection range
                        DocumentSymbol[] # children
                    )
                    push!(symbols, ds)
                    symbols = ds.children
                end
            end
        end
    end
    if length(x) > 0
        for a in x
            collect_document_symbols(a, server, doc, pos, ctx, symbols)
            pos += a.fullspan
        end
    end
    return symbols
end

function collect_bindings_w_loc(x::EXPR, pos=0, bindings=Tuple{UnitRange{Int},StaticLint.Binding}[])
    if bindingof(x) !== nothing
        push!(bindings, (pos .+ (0:x.span), bindingof(x)))
    end
    if length(x) > 0
        for a in x
            collect_bindings_w_loc(a, pos, bindings)
            pos += a.fullspan
        end
    end
    return bindings
end

function collect_toplevel_bindings_w_loc(x::EXPR, pos=0, bindings=Tuple{UnitRange{Int},StaticLint.Binding}[]; query="")
    if bindingof(x) isa StaticLint.Binding && valof(bindingof(x).name) isa String && bindingof(x).val isa EXPR && startswith(valof(bindingof(x).name), query)
        push!(bindings, (pos .+ (0:x.span), bindingof(x)))
    end
    if scopeof(x) !== nothing && !(headof(x) === :file || CSTParser.defines_module(x))
        return bindings
    end
    if length(x) > 0
        for a in x
            collect_toplevel_bindings_w_loc(a, pos, bindings, query=query)
            pos += a.fullspan
        end
    end
    return bindings
end

function _binding_kind(b, ctx::BindingContext)
    if b isa StaticLint.Binding
        if b.type === nothing
            if ctx.is_datatype_def_body && !ctx.is_function_def
                return 8
            elseif ctx.is_datatype_def
                return 26
            else
                return 13
            end
        elseif b.type == StaticLint.CoreTypes.Module
            return 2
        elseif b.type == StaticLint.CoreTypes.Function
            return 12
        elseif b.type == StaticLint.CoreTypes.String
            return 15
        elseif b.type == StaticLint.CoreTypes.Int || b.type == StaticLint.CoreTypes.Float64
            return 16
        elseif b.type == StaticLint.CoreTypes.DataType
            if ctx.is_datatype_def && !ctx.is_datatype_def_body
                return 23
            else
                return 26
            end
        else
            return 13
        end
    elseif b isa SymbolServer.ModuleStore
        return 2
    elseif b isa SymbolServer.MethodStore
        return 6
    elseif b isa SymbolServer.FunctionStore
        return 12
    elseif b isa SymbolServer.DataTypeStore
        return 23
    else
        return 13
    end
end

function julia_getModuleAt_request(params::VersionedTextDocumentPositionParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri

    if hasdocument(server, uri)
        doc = getdocument(server, uri)
        if get_version(doc) == params.version
            offset = index_at(doc, params.position, true)
            x, p = get_expr_or_parent(getcst(doc), offset, 1)
            if x isa EXPR
                if x.head === :MODULE || x.head === :IDENTIFIER || x.head === :END
                    if x.parent !== nothing && x.parent.head === :module
                        x = x.parent
                        if CSTParser.defines_module(x)
                            x = x.parent
                        end
                    end
                end
                if CSTParser.defines_module(x) && p <= offset <= p + x[1].fullspan + x[2].fullspan
                    x = x.parent
                end

                scope = StaticLint.retrieve_scope(x)
                if scope !== nothing
                    return get_module_of(scope)
                end
            end
        else
            return mismatched_version_error(uri, doc, params, "getModuleAt")
        end
    else
        return nodocument_error(uri)
    end
    return "Main"
end

function get_module_of(s::StaticLint.Scope, ms=[])
    if CSTParser.defines_module(s.expr) && CSTParser.isidentifier(s.expr.args[2])
        pushfirst!(ms, StaticLint.valofid(s.expr.args[2]))
    end
    if parentof(s) isa StaticLint.Scope
        return get_module_of(parentof(s), ms)
    else
        return isempty(ms) ? "Main" : join(ms, ".")
    end
end

function julia_getDocAt_request(params::VersionedTextDocumentPositionParams, server::LanguageServerInstance, conn)
    uri = params.textDocument.uri
    hasdocument(server, uri) || return nodocument_error(uri)

    doc = getdocument(server, uri)
    env = getenv(doc, server)
    if get_version(doc) !== params.version
        return mismatched_version_error(uri, doc, params, "getDocAt")
    end

    x = get_expr1(getcst(doc), get_offset(doc, params.position))
    x isa EXPR && CSTParser.isoperator(x) && resolve_op_ref(x, env)
    documentation = get_hover(x, "", server, x, env)

    return documentation
end

function _score(needle::Symbol, haystack::Symbol)
    if needle === haystack
        return 0
    end
    needle, haystack = lowercase(string(needle)), lowercase(string(haystack))
    ldist = REPL.levenshtein(needle, haystack)

    if startswith(haystack, needle)
        ldist *= 0.5
    end

    return ldist
end
# TODO: handle documentation resolving properly, respect how Documenter handles that
function julia_getDocFromWord_request(params::NamedTuple{(:word,),Tuple{String}}, server::LanguageServerInstance, conn)
    matches = Pair{Float64, String}[]
    needle = Symbol(params.word)
    nfound = 0
    traverse_by_name(getsymbols(getenv(server))) do sym, val
        # this would ideally use the Damerau-Levenshtein distance or even something fancier:
        score = _score(needle, sym)
        if score < 2
            val = get_hover(val, "", server, nothing, getenv(server))
            if !isempty(val)
                nfound += 1
                push!(matches, score => val)
            end
        end
    end
    if isempty(matches)
        return "No results found."
    else
        return join(map(x -> x.second, sort!(unique!(matches), by = x -> x.first)[1:min(end, 25)]), "\n---\n")
    end
end

function textDocument_selectionRange_request(params::SelectionRangeParams, server::LanguageServerInstance, conn)
    doc = getdocument(server, params.textDocument.uri)
    ret = map(params.positions) do position
        offset = get_offset(doc, position)
        x = get_expr1(getcst(doc), offset)
        get_selection_range_of_expr(x)
    end
    return ret isa Vector{SelectionRange} ?
        ret :
        nothing
end

# Just returns a selection for each parent EXPR, should be more selective
get_selection_range_of_expr(x) = missing
function get_selection_range_of_expr(x::EXPR)
    doc, offset = get_file_loc(x)
    l1, c1 = get_position_from_offset(doc, offset)
    l2, c2 = get_position_from_offset(doc, offset + x.span)
    SelectionRange(Range(l1, c1, l2, c2), get_selection_range_of_expr(x.parent))
end

function textDocument_inlayHint_request(params::InlayHintParams, server::LanguageServerInstance, conn)::Union{Vector{InlayHint},Nothing}
    if !server.inlay_hints
        return nothing
    end

    doc = getdocument(server, params.textDocument.uri)

    start, stop = get_offset(doc, params.range.start), get_offset(doc, params.range.stop)

    return collect_inlay_hints(getcst(doc), server, doc, start, stop)
end

function get_inlay_parameter_hints(x::EXPR, server::LanguageServerInstance, doc, pos=0)
    if server.inlay_hints_parameter_names === :all || (
        server.inlay_hints_parameter_names === :literals &&
        CSTParser.isliteral(x)
    )
        sigs = collect_signatures(x, doc, server)

        nargs = length(parentof(x).args) - 1
        nargs == 0 && return nothing

        filter!(s -> length(s.parameters) == nargs, sigs)
        isempty(sigs) && return nothing

        pars = first(sigs).parameters
        thisarg = 0
        for a in parentof(x).args
            if x == a
                break
            end
            thisarg += 1
        end
        if thisarg <= nargs && thisarg <= length(pars)
            label = pars[thisarg].label
            label == "#unused#" && return nothing

            return InlayHint(
                Position(get_position_from_offset(doc, pos)...),
                string(label, ':'),
                InlayHintKinds.Parameter,
                missing,
                pars[thisarg].documentation,
                false,
                true,
                missing
            )
        end
    end
    return nothing
end

function collect_inlay_hints(x::EXPR, server::LanguageServerInstance, doc, start, stop, pos=0, hints=InlayHint[])
    if x isa EXPR && parentof(x) isa EXPR &&
            CSTParser.iscall(parentof(x)) &&
            !(
                parentof(parentof(x)) isa EXPR &&
                CSTParser.defines_function(parentof(parentof(x)))
            ) &&
            parentof(x).args[1] != x # function calls
        maybe_hint = get_inlay_parameter_hints(x, server, doc, pos)
        if maybe_hint !== nothing
            push!(hints, maybe_hint)
        end
    elseif x isa EXPR && parentof(x) isa EXPR &&
            CSTParser.isassignment(parentof(x)) &&
            parentof(x).args[1] == x &&
            StaticLint.hasbinding(x) # assignment
        if server.inlay_hints_variable_types
            typ = _completion_type(StaticLint.bindingof(x))
            if typ !== missing
                push!(
                    hints,
                    InlayHint(
                        Position(get_position_from_offset(doc, pos + x.span)...),
                        string("::", typ),
                        InlayHintKinds.Type,
                        missing,
                        missing,
                        missing,
                        missing,
                        missing
                    )
                )
            end
        end
    end
    if length(x) > 0
        for a in x
            if pos < stop && pos + a.fullspan > start
                collect_inlay_hints(a, server, doc, start, stop, pos, hints)
            end
            pos += a.fullspan
            pos > stop && break
        end
    end
    return hints
end

import Pkg
using LanguageServer.URIs2
using LanguageServer: LanguageServerInstance

include("test_shared_init_request.jl")

function settestdoc(text)
    empty!(server._documents)
    LanguageServer.textDocument_didOpen_notification(LanguageServer.DidOpenTextDocumentParams(LanguageServer.TextDocumentItem(uri"untitled:testdoc", "julia", 0, text)), server, nothing)

    doc = LanguageServer.getdocument(server, uri"untitled:testdoc")
    LanguageServer.parse_all(doc, server)
    doc
end

completion_test(line, char) = LanguageServer.textDocument_completion_request(LanguageServer.CompletionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char), missing), server, server.jr_endpoint)
action_request_test(line0, char0, line1=line0, char1=char0; diags=[]) = LanguageServer.textDocument_codeAction_request(LanguageServer.CodeActionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Range(LanguageServer.Position(line0, char0), LanguageServer.Position(line1, char1)), LanguageServer.CodeActionContext(diags, missing)), server, server.jr_endpoint)
sig_test(line, char) = LanguageServer.textDocument_signatureHelp_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char)), server, server.jr_endpoint)
def_test(line, char) = LanguageServer.textDocument_definition_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char)), server, server.jr_endpoint)
ref_test(line, char) = LanguageServer.textDocument_references_request(LanguageServer.ReferenceParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char), missing, missing, LanguageServer.ReferenceContext(true)), server, server.jr_endpoint)
rename_test(line, char) = LanguageServer.textDocument_rename_request(LanguageServer.RenameParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char), missing, "newname"), server, server.jr_endpoint)
hover_test(line, char) = LanguageServer.textDocument_hover_request(LanguageServer.TextDocumentPositionParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Position(line, char)), server, server.jr_endpoint)
range_formatting_test(line0, char0, line1, char1) = LanguageServer.textDocument_range_formatting_request(LanguageServer.DocumentRangeFormattingParams(LanguageServer.TextDocumentIdentifier(uri"untitled:testdoc"), LanguageServer.Range(LanguageServer.Position(line0, char0), LanguageServer.Position(line1, char1)), LanguageServer.FormattingOptions(4, true, missing, missing, missing)), server, server.jr_endpoint)

# TODO Replace this with a proper mock endpoint
JSONRPC.send(::Nothing, ::Any, ::Any) = nothing

server = LanguageServerInstance(IOBuffer(), IOBuffer(), dirname(Pkg.Types.Context().env.project_file), first(Base.DEPOT_PATH))
server.runlinter = true
server.jr_endpoint = nothing
LanguageServer.initialize_request(init_request, server, nothing)

# TODO:
# - refactor, simplify branching, unify duplications
# - (maybe) export latex completions into a separate package

struct CompletionState
    offset::Int
    completions::Dict{String,CompletionItem}
    range::Range
    x::Union{Nothing, EXPR}
    doc::Document
    server::LanguageServerInstance
    using_stmts::Dict{String,Any}
end

function add_completion_item(state::CompletionState, completion::CompletionItem)
    if haskey(state.completions, completion.label) && ismissing(state.completions[completion.label].data)
        # For the above statement: we've (1) already got a completion which (2) doesn't require adding an explicit import statement.
        return
    end
    state.completions[completion.label] = completion
end

StaticLint.getenv(state::CompletionState) = getenv(state.doc, state.server)

using REPL

"""
    is_completion_match(s::AbstractString, prefix::AbstractString, cutoff=3)

Returns true if `s` starts with `prefix` or has a sufficiently high fuzzy score.
"""
function is_completion_match(s::AbstractString, prefix::AbstractString, cutoff=3)
    starter = if !any(isuppercase, prefix)
        startswith(lowercase(s), prefix)
    else
        startswith(s, prefix)
    end
    starter || REPL.fuzzyscore(prefix, s) >= cutoff
end

function textDocument_completion_request(params::CompletionParams, server::LanguageServerInstance, conn)
    state = let
        doc = getdocument(server, params.textDocument.uri)
        offset = get_offset3(get_text_document(doc), params.position)
        rng = Range(doc, offset:offset)
        x = get_expr(getcst(doc), offset)
        using_stmts = server.completion_mode == :import ? get_preexisting_using_stmts(x, doc) : Dict()
        CompletionState(offset, Dict{String,CompletionItem}(), rng, x, doc, server, using_stmts)
    end

    ppt, pt, t, is_at_end  = get_partial_completion(state)

    if pt isa CSTParser.Tokens.Token && pt.kind == CSTParser.Tokenize.Tokens.BACKSLASH
        latex_completions(string("\\", CSTParser.Tokenize.untokenize(t)), state)
    elseif ppt isa CSTParser.Tokens.Token && ppt.kind == CSTParser.Tokenize.Tokens.BACKSLASH && pt isa CSTParser.Tokens.Token && (pt.kind === CSTParser.Tokens.CIRCUMFLEX_ACCENT || pt.kind === CSTParser.Tokens.COLON)
        latex_completions(string("\\", CSTParser.Tokenize.untokenize(pt), CSTParser.Tokenize.untokenize(t)), state)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokenize.Tokens.COMMENT
        partial = is_latex_comp(t.val, state.offset - t.startbyte)
        !isempty(partial) && latex_completions(partial, state)
    elseif t isa CSTParser.Tokens.Token && (t.kind in (CSTParser.Tokenize.Tokens.STRING,
                                                       CSTParser.Tokenize.Tokens.TRIPLE_STRING,
                                                       CSTParser.Tokenize.Tokens.CMD,
                                                       CSTParser.Tokenize.Tokens.TRIPLE_CMD))
        string_completion(t, state)
    elseif state.x isa EXPR && is_in_import_statement(state.x)
        import_completions(ppt, pt, t, is_at_end, state.x, state)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.DOT && pt isa CSTParser.Tokens.Token && pt.kind == CSTParser.Tokens.IDENTIFIER
        # getfield completion, no partial
        px = get_expr(getcst(state.doc), state.offset - (1 + t.endbyte - t.startbyte))
        _get_dot_completion(px, "", state)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.IDENTIFIER && pt isa CSTParser.Tokens.Token && pt.kind == CSTParser.Tokens.DOT && ppt isa CSTParser.Tokens.Token && ppt.kind == CSTParser.Tokens.IDENTIFIER
        # getfield completion, partial
        px = get_expr(getcst(state.doc), state.offset - (1 + t.endbyte - t.startbyte) - (1 + pt.endbyte - pt.startbyte)) # get offset 2 tokens back
        _get_dot_completion(px, t.val, state)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.IDENTIFIER
        # token completion
        if is_at_end && state.x !== nothing
            if pt isa CSTParser.Tokens.Token && pt.kind == CSTParser.Tokens.AT_SIGN
                spartial = string("@", t.val)
            else
                spartial = t.val
            end
            kw_completion(spartial, state)
            rng = Range(state.doc, state.offset:state.offset)
            collect_completions(state.x, spartial, state, false)
        end
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.AT_SIGN
        # only `@` given
        state.x !== nothing && collect_completions(state.x, "@", state, false)
    elseif t isa CSTParser.Tokens.Token && Tokens.iskeyword(t.kind) && is_at_end
        kw_completion(CSTParser.Tokenize.untokenize(t), state)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.IN && is_at_end && state.x !== nothing
        collect_completions(state.x, "in", state, false)
    elseif t isa CSTParser.Tokens.Token && t.kind == CSTParser.Tokens.ISA && is_at_end && state.x !== nothing
        collect_completions(state.x, "isa", state, false)
    end

    return CompletionList(true, unique(values(state.completions)))
end


function get_partial_completion(state::CompletionState)
    ppt, pt, t = get_toks(state.doc, state.offset)
    is_at_end = state.offset == t.endbyte + 1
    return ppt, pt, t, is_at_end
end

function latex_completions(partial::String, state::CompletionState)
    for (k, v) in Iterators.flatten((REPL.REPLCompletions.latex_symbols, REPL.REPLCompletions.emoji_symbols))
        if is_completion_match(string(k), partial)
            # t1 = TextEdit(Range(state.doc, (state.offset - sizeof(partial)):state.offset), v)
            add_completion_item(state, CompletionItem(k, CompletionItemKinds.Unit, missing, v, v, missing, missing, missing, missing, missing, missing, texteditfor(state, partial, v), missing, missing, missing, missing))
        end
    end
end

function kw_completion(partial::String, state::CompletionState)
    length(partial) == 0 && return
    for (kw, comp) in snippet_completions
        if startswith(kw, partial)
            kind = occursin("\$0", comp) ? CompletionItemKinds.Snippet : CompletionItemKinds.Keyword
            add_completion_item(state, CompletionItem(kw, kind, missing, missing, kw, missing, missing, missing, missing, missing, InsertTextFormats.Snippet, texteditfor(state, partial, comp), missing, missing, missing, missing))
        end
    end
end

const snippet_completions = Dict{String,String}(
    "abstract" => "abstract type \$0 end",
    "baremodule" => "baremodule \$1\n\t\$0\nend",
    "begin" => "begin\n\t\$0\nend",
    "break" => "break",
    "catch" => "catch",
    "const" => "const ",
    "continue" => "continue",
    "do" => "do \$1\n\t\$0\nend",
    "else" => "else",
    "elseif" => "elseif ",
    "end" => "end",
    "export" => "export ",
    "false" => "false",
    "finally" => "finally",
    "for" => "for \$1 in \$2\n\t\$0\nend",
    "function" => "function \$1(\$2)\n\t\$0\nend",
    "global" => "global ",
    "if" => "if \$1\n\t\$0\nend",
    "import" => "import",
    "let" => "let \$1\n\t\$0\nend",
    "local" => "local ",
    "macro" => "macro \$1(\$2)\n\t\$0\nend",
    "module" => "module \$1\n\t\$0\nend",
    "mutable" => "mutable struct \$0\nend",
    "outer" => "outer ",
    "primitive" => "primitive type \$1 \$0 end",
    "quote" => "quote\n\t\$0\nend",
    "return" => "return",
    "struct" => "struct \$0 end",
    "true" => "true",
    "try" => "try\n\t\$0\ncatch\nend",
    "using" => "using ",
    "while" => "while \$1\n\t\$0\nend"
    )


function texteditfor(state::CompletionState, partial, n)
    TextEdit(Range(Position(state.range.start.line, max(state.range.start.character - length(partial), 0)), state.range.stop), n)
end

function string_macro_altname(s)
    if startswith(s, "@") && endswith(s, "_str")
        return chop(s; head=1, tail=4) * '"'
    else
        return nothing
    end
end

function collect_completions(m::SymbolServer.ModuleStore, spartial, state::CompletionState, inclexported=false, dotcomps=false)
    possible_names = String[]
    for val in m.vals
        n, v = String(val[1]), val[2]
        (startswith(n, ".") || startswith(n, "#")) && continue
        # Keep track of the canonical name and some possible alternatives
        # (e.g. string macros can complete as '@foo_str' and also 'foo"')
        canonical_name = n
        resize!(possible_names, 0)
        if is_completion_match(n, spartial)
            push!(possible_names, n) # Direct match
        end
        if (nn = string_macro_altname(n); nn !== nothing) && is_completion_match(nn, spartial)
            # Match for string macro without initial @ and trailing _str
            push!(possible_names, nn)
        end
        length(possible_names) == 0 && continue # No matches, continue
        if v isa SymbolServer.VarRef
            v = SymbolServer._lookup(v, getsymbols(getenv(state)), true)
            v === nothing && return
        end
        if StaticLint.isexportedby(canonical_name, m) || inclexported
            foreach(possible_names) do n
                add_completion_item(state, CompletionItem(n, _completion_kind(v), get_typed_definition(v), MarkupContent(sanitize_docstring(v.doc)), texteditfor(state, spartial, n)))
            end
        elseif dotcomps
            foreach(possible_names) do n
                push!(state.completions, CompletionItem(n, _completion_kind(v), get_typed_definition(v), MarkupContent(sanitize_docstring(v.doc)), texteditfor(state, spartial, string(m.name, ".", n))))
            end
        elseif length(spartial) > 3 && !variable_already_imported(m, canonical_name, state)
            if state.server.completion_mode === :import
                # These are non-exported names and require the insertion of a :using statement.
                # We need to insert this statement at the start of the current top-level scope (e.g. Main or a module) and tag it onto existing :using statements if possible.
                foreach(possible_names) do n
                    ci = CompletionItem(n, _completion_kind(v), missing, "This is an unexported symbol and will be explicitly imported.",
                        MarkupContent(sanitize_docstring(v.doc)), missing, missing, missing, missing, missing, InsertTextFormats.PlainText,
                        texteditfor(state, spartial, n), textedit_to_insert_using_stmt(m, canonical_name, state), missing, missing, "import")
                    add_completion_item(state, ci)
                end
            elseif state.server.completion_mode === :qualify
                foreach(possible_names) do n
                    add_completion_item(state, CompletionItem(string(m.name, ".", n), _completion_kind(v), missing,
                        missing, MarkupContent(sanitize_docstring(v.doc)), missing,
                        missing, string(n), missing, missing, InsertTextFormats.PlainText, texteditfor(state, spartial, string(m.name, ".", n)),
                        missing, missing, missing, missing))
                end
            end
        end
    end
end

function variable_already_imported(m, n, state)
    haskey(state.using_stmts, String(m.name.name)) && import_has_x(state.using_stmts[String(m.name.name)][1], n)
end

function import_has_x(expr::EXPR, x::String)
    if length(expr.args) == 1 && length(expr.args[1]) > 1
        for i = 2:length(expr.args[1].args)
            arg = expr.args[1].args[i]
            if CSTParser.isoperator(arg.head) && length(arg.args) == 1 && CSTParser.isidentifier(arg.args[1]) && CSTParser.valof(arg.args[1]) == x
                return true
            end
        end
    end
    return false
end

function collect_completions(x::EXPR, spartial, state::CompletionState, inclexported=false, dotcomps=false)
    if scopeof(x) !== nothing
        collect_completions(scopeof(x), spartial, state, inclexported, dotcomps)
        if scopeof(x).modules isa Dict
            for m in scopeof(x).modules
                collect_completions(m[2], spartial, state, inclexported, dotcomps)
            end
        end
    end
    if parentof(x) !== nothing && !CSTParser.defines_module(x)
        return collect_completions(parentof(x), spartial, state, inclexported, dotcomps)
    end
end

function collect_completions(x::StaticLint.Scope, spartial, state::CompletionState, inclexported=false, dotcomps=false)
    if x.names !== nothing
        possible_names = String[]
        for n in x.names
            resize!(possible_names, 0)
            if is_completion_match(n[1], spartial)
                push!(possible_names, n[1])
            end
            if (nn = string_macro_altname(n[1]); nn !== nothing) && is_completion_match(nn, spartial)
                push!(possible_names, nn)
            end
            if length(possible_names) > 0
                documentation = ""
                if n[2] isa StaticLint.Binding
                    documentation = get_tooltip(n[2], documentation, state.server)
                    sanitize_docstring(documentation)
                end
                foreach(possible_names) do nn
                    add_completion_item(state, CompletionItem(nn, _completion_kind(n[2]), get_typed_definition(n[2]), MarkupContent(documentation), texteditfor(state, spartial, nn)))
                end
            end
        end
    end
end


function is_rebinding_of_module(x)
    x isa EXPR && refof(x).type === StaticLint.CoreTypes.Module && # binding is a Module
    refof(x).val isa EXPR && CSTParser.isassignment(refof(x).val) && # binding expr is an assignment
    StaticLint.hasref(refof(x).val.args[2]) && refof(refof(x).val.args[2]).type === StaticLint.CoreTypes.Module &&
    refof(refof(x).val.args[2]).val isa EXPR && CSTParser.defines_module(refof(refof(x).val.args[2]).val)# double check the rhs points to a module
end

function _get_dot_completion(px, spartial, state::CompletionState) end
function _get_dot_completion(px::EXPR, spartial, state::CompletionState)
    if px !== nothing
        if refof(px) isa StaticLint.Binding
            if refof(px).val isa StaticLint.SymbolServer.ModuleStore
                collect_completions(refof(px).val, spartial, state, true)
            elseif refof(px).val isa EXPR && CSTParser.defines_module(refof(px).val) && scopeof(refof(px).val) isa StaticLint.Scope
                collect_completions(scopeof(refof(px).val), spartial, state, true)
            elseif is_rebinding_of_module(px)
                collect_completions(scopeof(refof(refof(px).val.args[2]).val), spartial, state, true)
            elseif refof(px).type isa SymbolServer.DataTypeStore
                for a in refof(px).type.fieldnames
                    a = String(a)
                    if is_completion_match(a, spartial)
                        add_completion_item(state, CompletionItem(a, CompletionItemKinds.Method, get_typed_definition(a), MarkupContent(a), texteditfor(state, spartial, a)))
                    end
                end
            elseif refof(px).type isa StaticLint.Binding && refof(px).type.val isa SymbolServer.DataTypeStore
                for a in refof(px).type.val.fieldnames
                    a = String(a)
                    if is_completion_match(a, spartial)
                        add_completion_item(state, CompletionItem(a, CompletionItemKinds.Method, get_typed_definition(a), MarkupContent(a), texteditfor(state, spartial, a)))
                    end
                end
            elseif refof(px).type isa StaticLint.Binding && refof(px).type.val isa EXPR && CSTParser.defines_struct(refof(px).type.val) && scopeof(refof(px).type.val) isa StaticLint.Scope
                collect_completions(scopeof(refof(px).type.val), spartial, state, true)
            end
        elseif refof(px) isa StaticLint.SymbolServer.ModuleStore
            collect_completions(refof(px), spartial, state, true)
        end
    end
end

function _completion_kind(b)
    if b isa StaticLint.Binding
        if b.type == StaticLint.CoreTypes.String
            return CompletionItemKinds.Text
        elseif b.type == StaticLint.CoreTypes.Function
            return CompletionItemKinds.Method
        elseif b.type == StaticLint.CoreTypes.Module
            return CompletionItemKinds.Module
        elseif b.type == Int || b.type == StaticLint.CoreTypes.Float64
            return CompletionItemKinds.Value
        elseif b.type == StaticLint.CoreTypes.DataType
            return CompletionItemKinds.Struct
        else
            return CompletionItemKinds.Variable
        end
    elseif b isa SymbolServer.ModuleStore || b isa SymbolServer.VarRef
        return CompletionItemKinds.Module
    elseif b isa SymbolServer.MethodStore
        return CompletionItemKinds.Method
    elseif b isa SymbolServer.FunctionStore
        return CompletionItemKinds.Function
    elseif b isa SymbolServer.DataTypeStore
        return CompletionItemKinds.Struct
    else
        return CompletionItemKinds.Variable
    end
end



function get_import_root(x::EXPR)
    if CSTParser.isoperator(headof(x.args[1])) && valof(headof(x.args[1])) == ":"
        return last(x.args[1].args[1].args)
    end
end

function string_completion(t, state::CompletionState)
    path_completion(t, state)
    # Need to adjust things for quotation marks
    if t.kind in (CSTParser.Tokenize.Tokens.STRING,CSTParser.Tokenize.Tokens.CMD)
        t.startbyte + 1 < state.offset <= t.endbyte || return
        relative_offset = state.offset - t.startbyte - 1
        content = t.val[2:prevind(t.val, lastindex(t.val))]
    else
        t.startbyte + 3 < state.offset <= t.endbyte - 2 || return
        relative_offset = state.offset - t.startbyte - 3
        content = t.val[4:prevind(t.val, lastindex(t.val), 3)]
    end
    relative_offset = clamp(relative_offset, firstindex(content), lastindex(content))
    partial = is_latex_comp(content, relative_offset)
    !isempty(partial) && latex_completions(partial, state)
end

function is_latex_comp(s, i)
    firstindex(s) <= i <= lastindex(s) || return ""
    i0 = i = thisind(s, i)
    while firstindex(s) <= i
        s[i] == '\\' && return s[i:i0]
        !is_latex_comp_char(s[i]) && return ""
        i = prevind(s, i)
    end
    return ""
end

is_latex_comp_char(c::Char) = UInt32(c) <= typemax(UInt8) ? is_latex_comp_char(UInt8(c)) : false
function is_latex_comp_char(u)
    # Checks whether a Char (represented as a UInt8) is in the set of those those used to trigger
    # latex completions.
    # from: UInt8.(sort!(unique(prod([k[2:end] for (k,_) in Iterators.flatten((REPL.REPLCompletions.latex_symbols, REPL.REPLCompletions.emoji_symbols))]))))
    u === 0x21 ||
    u === 0x28 ||
    u === 0x29 ||
    u === 0x2b ||
    u === 0x2d ||
    u === 0x2f ||
    0x30 <= u <= 0x39 ||
    u === 0x3a ||
    u === 0x3d ||
    0x41 <= u <= 0x5a ||
    u === 0x5e ||
    u === 0x5f ||
    0x61 <= u <= 0x7a
end

function path_completion(t, state::CompletionState)
    if t.kind == CSTParser.Tokenize.Tokens.STRING
        path = t.val[2:prevind(t.val, lastindex(t.val))]
        if startswith(path, "~")
            path = replace(path, '~' => homedir())
            dir, partial = _splitdir(path)
        else
            dir, partial = _splitdir(path)
            if !startswith(dir, "/")
                doc_path = getpath(state.doc)
                isempty(doc_path) && return
                dir = joinpath(_dirname(doc_path), dir)
            end
        end
        try
            fs = readdir(dir)
            for f in fs
                if startswith(f, partial)
                    try
                        if isdir(joinpath(dir, f))
                            f = string(f, "/")
                        end
                        rng1 = Range(state.doc, state.offset - sizeof(partial):state.offset)
                        add_completion_item(state, CompletionItem(f, CompletionItemKinds.File, f, TextEdit(rng1, f)))
                    catch err
                        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
                    end
                end
            end
        catch err
            isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
        end
    end
end

is_in_import_statement(x::EXPR) = is_in_fexpr(x, x -> headof(x) in (:using, :import))

function import_completions(ppt, pt, t, is_at_end, x, state::CompletionState)
    import_statement = StaticLint.get_parent_fexpr(x, x -> headof(x) === :using || headof(x) === :import)

    import_root = get_import_root(import_statement)

    if (t.kind == CSTParser.Tokens.WHITESPACE && pt.kind ∈ (CSTParser.Tokens.USING, CSTParser.Tokens.IMPORT, CSTParser.Tokens.IMPORTALL, CSTParser.Tokens.COMMA, CSTParser.Tokens.COLON)) ||
        (t.kind in (CSTParser.Tokens.COMMA, CSTParser.Tokens.COLON))
        # no partial, no dot
        if import_root !== nothing && refof(import_root) isa SymbolServer.ModuleStore
            for (n, m) in refof(import_root).vals
                n = String(n)
                if is_completion_match(n, t.val) && !startswith(n, "#")
                    add_completion_item(state, CompletionItem(n, _completion_kind(m), get_typed_definition(m), MarkupContent(m isa SymbolServer.SymStore ? sanitize_docstring(m.doc) : n), texteditfor(state, t.val, n)))
                end
            end
        else
            for (n, m) in StaticLint.getsymbols(getenv(state))
                n = String(n)
                (startswith(n, ".") || startswith(n, "#")) && continue
                add_completion_item(state, CompletionItem(n, CompletionItemKinds.Module, get_typed_definition(m), MarkupContent(sanitize_docstring(m.doc)), TextEdit(state.range, n)))
            end
        end
    elseif t.kind == CSTParser.Tokens.DOT && pt.kind == CSTParser.Tokens.IDENTIFIER
        # no partial, dot
        if haskey(getsymbols(getenv(state)), Symbol(pt.val))
            collect_completions(getsymbols(getenv(state))[Symbol(pt.val)], "", state)
        end
    elseif t.kind == CSTParser.Tokens.IDENTIFIER && is_at_end
        # partial
        if pt.kind == CSTParser.Tokens.DOT && ppt.kind == CSTParser.Tokens.IDENTIFIER
            if haskey(StaticLint.getsymbols(getenv(state)), Symbol(ppt.val))
                rootmod = StaticLint.getsymbols(getenv(state))[Symbol(ppt.val)]
                for (n, m) in rootmod.vals
                    n = String(n)
                    if is_completion_match(n, t.val) && !startswith(n, "#")
                        add_completion_item(state, CompletionItem(n, _completion_kind(m), get_typed_definition(m), MarkupContent(m isa SymbolServer.SymStore ? sanitize_docstring(m.doc) : n), texteditfor(state, t.val, n)))
                    end
                end
            end
        else
            if import_root !== nothing && refof(import_root) isa SymbolServer.ModuleStore
                for (n, m) in refof(import_root).vals
                    n = String(n)
                    if is_completion_match(n, t.val) && !startswith(n, "#")
                        add_completion_item(state, CompletionItem(n, _completion_kind(m), get_typed_definition(m), MarkupContent(m isa SymbolServer.SymStore ? sanitize_docstring(m.doc) : n), texteditfor(state, t.val, n)))
                    end
                end
            else
                for (n, m) in StaticLint.getsymbols(getenv(state))
                    n = String(n)
                    if is_completion_match(n, t.val)
                        add_completion_item(state, CompletionItem(n, CompletionItemKinds.Module, get_typed_definition(m), MarkupContent(m isa SymbolServer.SymStore ? m.doc : n), texteditfor(state, t.val, n)))
                    end
                end
            end
        end
    end
end



function get_preexisting_using_stmts(x::EXPR, doc::Document)
    using_stmts = Dict{String,Any}()
    tls = StaticLint.retrieve_toplevel_scope(x)
    file_level_arg = get_file_level_parent(x)

    if scopeof(getcst(doc)) == tls
        # check for :using stmts in current file
        for a in getcst(doc).args
            if headof(a) === :using
                add_using_stmt(a, using_stmts)
            end
            a == file_level_arg && break
        end
    end

    if tls !== nothing
        args = get_tls_arglist(tls)
        for a in args
            if headof(a) === :using
                add_using_stmt(a, using_stmts)
            end

        end
    end
    return using_stmts
end

function add_using_stmt(x::EXPR, using_stmts)
    if length(x.args) > 0 && CSTParser.is_colon(x.args[1].head)
        if CSTParser.is_dot(x.args[1].args[1].head) && length(x.args[1].args[1].args) == 1
            using_stmts[valof(x.args[1].args[1].args[1])] = (x, get_file_loc(x))
        end
    end
end

function get_file_level_parent(x::EXPR)
    if x.parent isa EXPR && x.parent.head === :file
        x
    else
        if x.parent === nothing
            return nothing
        end
        get_file_level_parent(x.parent)
    end
end

function textedit_to_insert_using_stmt(m::SymbolServer.ModuleStore, n::String, state::CompletionState)
    tls = StaticLint.retrieve_toplevel_scope(state.x)
    if haskey(state.using_stmts, String(m.name.name))
        (using_stmt, (using_doc, using_offset)) = state.using_stmts[String(m.name.name)]

        l, c = get_position_from_offset(using_doc, using_offset + using_stmt.span)
        return [TextEdit(Range(l, c, l, c), ", $n")]
    elseif tls !== nothing
        if tls.expr.head === :file
            # Insert at the head of the file
            tlsdoc, offset1 = get_file_loc(tls.expr)
            return [TextEdit(Range(0, 0, 0, 0), "using $(m.name): $(n)\n")]
        elseif tls.expr.head === :module
            # Insert at start of module
            tlsdoc, offset1 = get_file_loc(tls.expr)
            offset2 = tls.expr.trivia[1].fullspan + tls.expr.args[2].fullspan
            l, c = get_position_from_offset(tlsdoc, offset1 + offset2)

            return [TextEdit(Range(l, c, l, c), "using $(m.name): $(n)\n")]
        else
            error()
        end
    else
        # Fallback, add it to the start of the current file.
        return [TextEdit(Range(0, 0, 0, 0), "using $(m.name): $(n)\n")]
    end
end

function get_tls_arglist(tls::StaticLint.Scope)
    if tls.expr.head === :file
        tls.expr.args
    elseif tls.expr.head === :module
        tls.expr.args[3].args
    else
        error()
    end
end

module LanguageServer
using JSON, REPL, CSTParser, JuliaFormatter, SymbolServer, StaticLint
using CSTParser: EXPR, Tokenize.Tokens, Tokenize.Tokens.kind, headof, parentof, valof, to_codeobject
using StaticLint: refof, scopeof, bindingof
using UUIDs
using Base.Docs, Markdown
import JSONRPC
using JSONRPC: Outbound, @dict_readable
import TestItemDetection
import Logging
using PrecompileTools

export LanguageServerInstance, runserver

include("URIs2/URIs2.jl")
using .URIs2

JSON.lower(uri::URI) = string(uri)

include("exception_types.jl")
include("protocol/protocol.jl")
include("extensions/extensions.jl")
include("textdocument.jl")
include("document.jl")
include("juliaworkspace.jl")
include("languageserverinstance.jl")
include("multienv.jl")
include("runserver.jl")
include("staticlint.jl")

include("requests/misc.jl")
include("requests/textdocument.jl")
include("requests/features.jl")
include("requests/hover.jl")
include("requests/completions.jl")
include("requests/workspace.jl")
include("requests/actions.jl")
include("requests/init.jl")
include("requests/signatures.jl")
include("requests/highlight.jl")
include("utilities.jl")
include("precompile.jl")

end

@testitem "Edit" begin
    using JSON, Pkg, LanguageServer.URIs2
    using LanguageServer: get_uri, get_text_document
    import JSONRPC, CSTParser

    # TODO Replace this with a proper mock endpoint
    JSONRPC.send(::Nothing, ::Any, ::Any) = nothing

    server = LanguageServer.LanguageServerInstance(IOBuffer(), IOBuffer(), dirname(Pkg.Types.Context().env.project_file), first(Base.DEPOT_PATH))

    mktempdir() do dir

        # TODO use types directly and skip the string JSON entirely
        initstr = """{"processId":17712,"rootPath":"","rootUri":"$(LanguageServer.filepath2uri(dir))","capabilities":{"workspace":{"applyEdit":true,"workspaceEdit":{"documentChanges":true},"didChangeConfiguration":{"dynamicRegistration":true},"didChangeWatchedFiles":{"dynamicRegistration":true},"symbol":{"dynamicRegistration":true,"symbolKind":{"valueSet":[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26]}},"executeCommand":{"dynamicRegistration":true},"configuration":true,"workspaceFolders":true},"textDocument":{"publishDiagnostics":{"relatedInformation":true},"synchronization":{"dynamicRegistration":true,"willSave":true,"willSaveWaitUntil":true,"didSave":true},"completion":{"dynamicRegistration":true,"contextSupport":true,"completionItem":{"snippetSupport":true,"commitCharactersSupport":true,"documentationFormat":["markdown","plaintext"],"deprecatedSupport":true},"completionItemKind":{"valueSet":[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25]}},"hover":{"dynamicRegistration":true,"contentFormat":["markdown","plaintext"]},"signatureHelp":{"dynamicRegistration":true,"signatureInformation":{"documentationFormat":["markdown","plaintext"]}},"definition":{"dynamicRegistration":true},"references":{"dynamicRegistration":true},"documentHighlight":{"dynamicRegistration":true},"documentSymbol":{"dynamicRegistration":true,"symbolKind":{"valueSet":[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26]}},"codeAction":{"dynamicRegistration":true,"codeActionLiteralSupport":{"codeActionKind":{"valueSet":["","quickfix","refactor","refactor.extract","refactor.inline","refactor.rewrite","source","source.organizeImports"]}}},"codeLens":{"dynamicRegistration":true},"formatting":{"dynamicRegistration":true},"rangeFormatting":{"dynamicRegistration":true},"onTypeFormatting":{"dynamicRegistration":true},"rename":{"dynamicRegistration":true},"documentLink":{"dynamicRegistration":true},"typeDefinition":{"dynamicRegistration":true},"implementation":{"dynamicRegistration":true},"colorProvider":{"dynamicRegistration":true}}},"trace":"off","workspaceFolders":[{"uri":"$(LanguageServer.filepath2uri(dir))","name":"CSTParser"}]}"""
        init_params = LanguageServer.InitializeParams(JSON.parse(initstr))

        server.runlinter = true
        server.jr_endpoint = nothing
        LanguageServer.initialize_request(init_params, server, nothing)
        # LanguageServer.process(LanguageServer.JSONRPC.Request{Val{Symbol("initialized")},Any}(0, nothing), server)

        function test_edit(server, text, s1, s2, insert)
            LanguageServer.textDocument_didOpen_notification(LanguageServer.LanguageServer.DidOpenTextDocumentParams(LanguageServer.TextDocumentItem(uri"untitled:none", "julia", 0, text)), server, nothing)
            doc = LanguageServer.getdocument(server, uri"untitled:none")
            LanguageServer.parse_all(doc, server)
            params = LanguageServer.DidChangeTextDocumentParams(
                LanguageServer.VersionedTextDocumentIdentifier(get_uri(doc), 5),
                [LanguageServer.TextDocumentContentChangeEvent(LanguageServer.Range(LanguageServer.Position(s1...), LanguageServer.Position(s2...)), 0, insert)]
            )
            tdcce = params.contentChanges

            # TODO: This should only re-parse necessary parts of the document
            LanguageServer.set_text_document!(doc, LanguageServer.apply_text_edits(get_text_document(doc), tdcce, 1))
            LanguageServer.parse_all(doc, server)

            new_cst = CSTParser.parse(LanguageServer.get_text(doc), true)

            CSTParser.to_codeobject(doc.cst) == CSTParser.to_codeobject(new_cst), doc.cst, new_cst
        end

        # techinically tests the same as test_document.jl, but should be changed to incremental re-parsing
        # once that's implemented again
        @testset "text edits" begin
            @test test_edit(server, "a", (0, 0), (0, 0), "a")[1]
            @test test_edit(server, "a", (0, 1), (0, 1), "a")[1]
            @test test_edit(server, "a", (0, 0), (0, 1), "abc")[1]
            @test test_edit(server, "a\n", (1, 0), (1, 0), "b")[1]
            @test test_edit(server, "a", (0, 0), (0, 1), "")[1]
            @test test_edit(server, "a\na", (1, 0), (1, 1), "b")[1]
            @test test_edit(server, "a\na", (1, 0), (1, 1), "")[1]
            @test test_edit(server, "begin\nend", (0, 4), (0, 5), "")[1]
            @test test_edit(server, "a\nb", (1, 1), (1, 1), "\n")[1]
            @test test_edit(server, "bein\nend", (0, 2), (0, 2), "g")[1]
            @test test_edit(server, "a\nb\nc", (2, 0), (2, 1), "")[1]
            @test test_edit(server, "a\nb\nc", (1, 0), (1, 1), "")[1]
            @test test_edit(server, "begin while f end end", (0, 10), (0, 11), "")[1]
            @test test_edit(server, "begin while true end end\nf() = 1", (0, 12), (0, 16), "")[1]
            @test test_edit(server, "for i ", (0, 6), (0, 6), ";")[1]

            @test test_edit(server, "a\n\nc", (1, 0), (1, 0), "b")[1]
            @test test_edit(server, "a\nb\ne", (1, 1), (1, 1), "\nc\nd")[1]
            @test test_edit(server, "aaa\nbbb", (0, 0), (0, 0), "\n")[1]
        end

    end
end

function uri2filepath(uri::URI)
    if uri.scheme != "file"
        return nothing
    end

    path = uri.path
    host = uri.authority

    if host!==nothing && host != "" && length(path) > 1
        # unc path: file://shares/c$/far/boo
        value = "//$host$path"
    elseif length(path) >= 3 &&
            path[1] == '/' &&
            isascii(path[2]) && isletter(path[2]) &&
            path[3] == ':'
        # windows drive letter: file:///c:/far/boo
        value = lowercase(path[2]) * path[3:end]
    else
        # other path
        value = path
    end

    if Sys.iswindows()
        value = replace(value, '/' => '\\')
    end

    return value
end

function filepath2uri(path::String)
    isabspath(path) || error("Relative path `$path` is not valid.")

    path = normpath(path)

    if Sys.iswindows()
        path = replace(path, "\\" => "/")
    end

    authority = ""

    if startswith(path, "//")
        # UNC path //foo/bar/foobar
        idx = findnext("/", path, 3)
        if idx===nothing
            authority = path[3:end]
            path = "/"
        else
            authority = path[3:idx.start-1]
            path = path[idx.start:end]
        end
    elseif length(path)>=2 && isascii(path[1]) && isletter(path[1]) && path[2]==':'
        path = string('/', lowercase(path[1]), SubString(path, 2))
    end

    return URI(scheme="file", authority=authority, path=path)
end

function workspace_didChangeWatchedFiles_notification(params::DidChangeWatchedFilesParams, server::LanguageServerInstance, conn)
    for change in params.changes
        uri = change.uri

        uri.scheme=="file" || continue

        if change.type == FileChangeTypes.Created || change.type == FileChangeTypes.Changed
            if change.type == FileChangeTypes.Created
                server.workspace = add_file(server.workspace, uri)
            elseif change.type == FileChangeTypes.Changed
                server.workspace = update_file(server.workspace, uri)
            end

            if hasdocument(server, uri)
                doc = getdocument(server, uri)

                # Currently managed by the client, we don't do anything
                if get_open_in_editor(doc)
                    continue
                else
                    filepath = uri2filepath(uri)
                    content = try
                        s = read(filepath, String)
                        if !our_isvalid(s)
                            deletedocument!(server, uri)
                            continue
                        end
                        s
                    catch err
                        isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
                        deletedocument!(server, uri)
                        continue
                    end

                    set_text_document!(doc, TextDocument(uri, content, 0))
                    set_is_workspace_file(doc, true)
                    parse_all(doc, server)
                end
            else
                filepath = uri2filepath(uri)
                content = try
                    s = read(filepath, String)
                    our_isvalid(s) || continue
                    s
                catch err
                    isa(err, Base.IOError) || isa(err, Base.SystemError) || rethrow()
                    continue
                end

                doc = Document(TextDocument(uri, content, 0), true, server)
                setdocument!(server, uri, doc)
                parse_all(doc, server)
            end
        elseif change.type == FileChangeTypes.Deleted
            server.workspace = delete_file(server.workspace, uri)

            if hasdocument(server, uri)
                doc = getdocument(server, uri)

                # We only handle if currently not managed by client
                if !get_open_in_editor(doc)
                    deletedocument!(server, uri)

                    publishDiagnosticsParams = PublishDiagnosticsParams(uri, missing, Diagnostic[])
                    JSONRPC.send(conn, textDocument_publishDiagnostics_notification_type, publishDiagnosticsParams)
                else
                    # TODO replace with accessor function once the other PR
                    # that introduces the accessor is merged
                    doc._workspace_file = false
                end
            end
        else
            error("Unknown change type.")
        end
    end
end

function workspace_didChangeConfiguration_notification(params::DidChangeConfigurationParams, server::LanguageServerInstance, conn)
    if !server.clientcapability_workspace_didChangeConfiguration
        @debug "Client sent a `workspace/didChangeConfiguration` request despite claiming no support for it. " *
               "The request will be handled regardless, but this behavior can be reported to the client."
    end
    request_julia_config(server, conn)
end

@static if VERSION < v"1.1"
    isnothing(::Any) = false
    isnothing(::Nothing) = true
end

const LINT_DIABLED_DIRS = ["test", "docs"]

function request_julia_config(server::LanguageServerInstance, conn)
    (ismissing(server.clientCapabilities.workspace) || server.clientCapabilities.workspace.configuration !== true) && return

    response = JSONRPC.send(conn, workspace_configuration_request_type, ConfigurationParams([
        ConfigurationItem(missing, "julia.lint.call"), # LintOptions
        ConfigurationItem(missing, "julia.lint.iter"),
        ConfigurationItem(missing, "julia.lint.nothingcomp"),
        ConfigurationItem(missing, "julia.lint.constif"),
        ConfigurationItem(missing, "julia.lint.lazy"),
        ConfigurationItem(missing, "julia.lint.datadecl"),
        ConfigurationItem(missing, "julia.lint.typeparam"),
        ConfigurationItem(missing, "julia.lint.modname"),
        ConfigurationItem(missing, "julia.lint.pirates"),
        ConfigurationItem(missing, "julia.lint.useoffuncargs"),
        ConfigurationItem(missing, "julia.lint.run"),
        ConfigurationItem(missing, "julia.lint.missingrefs"),
        ConfigurationItem(missing, "julia.lint.disabledDirs"),
        ConfigurationItem(missing, "julia.completionmode"),
        ConfigurationItem(missing, "julia.inlayHints.static.enabled"),
        ConfigurationItem(missing, "julia.inlayHints.static.variableTypes.enabled"),
        ConfigurationItem(missing, "julia.inlayHints.static.parameterNames.enabled"),
    ]))

    new_runlinter = something(response[11], true)
    new_SL_opts = StaticLint.LintOptions(response[1:10]...)

    new_lint_missingrefs = Symbol(something(response[12], :all))
    new_lint_disableddirs = something(response[13], LINT_DIABLED_DIRS)
    new_completion_mode = Symbol(something(response[14], :import))
    inlayHints = something(response[15], true)
    inlayHintsVariableTypes = something(response[16], true)
    inlayHintsParameterNames = Symbol(something(response[17], :literals))

    rerun_lint = begin
        any(getproperty(server.lint_options, opt) != getproperty(new_SL_opts, opt) for opt in fieldnames(StaticLint.LintOptions)) ||
        server.runlinter != new_runlinter ||
        server.lint_missingrefs != new_lint_missingrefs ||
        server.lint_disableddirs != new_lint_disableddirs
    end

    server.lint_options = new_SL_opts
    server.runlinter = new_runlinter
    server.lint_missingrefs = new_lint_missingrefs
    server.lint_disableddirs = new_lint_disableddirs
    server.completion_mode = new_completion_mode
    server.inlay_hints = inlayHints
    server.inlay_hints_variable_types = inlayHintsVariableTypes
    server.inlay_hints_parameter_names = inlayHintsParameterNames

    if rerun_lint
        relintserver(server)
    end
end

function workspace_didChangeWorkspaceFolders_notification(params::DidChangeWorkspaceFoldersParams, server::LanguageServerInstance, conn)
    for wksp in params.event.added
        push!(server.workspaceFolders, uri2filepath(wksp.uri))
        load_folder(wksp, server)
        server.workspace = add_workspace_folder(server.workspace, wksp.uri)
    end
    for wksp in params.event.removed
        delete!(server.workspaceFolders, uri2filepath(wksp.uri))
        remove_workspace_files(wksp, server)
        server.workspace = remove_workspace_folder(server.workspace, wksp.uri)
    end
end

function workspace_symbol_request(params::WorkspaceSymbolParams, server::LanguageServerInstance, conn)
    syms = SymbolInformation[]
    for doc in getdocuments_value(server)
        bs = collect_toplevel_bindings_w_loc(getcst(doc), query=params.query)
        for x in bs
            p, b = x[1], x[2]
            push!(syms, SymbolInformation(valof(b.name), 1, false, Location(get_uri(doc), Range(doc, p)), missing))
        end
    end

    return syms
end

struct JuliaPackage
    project_file_uri::URI
    name::String
    uuid::UUID
end

struct JuliaDevedPackage
    name::String
    uuid::UUID
end

struct JuliaProject
    project_file_uri::URI
    deved_packages::Dict{URI,JuliaDevedPackage}
end

struct JuliaWorkspace
    _workspace_folders::Set{URI}

    # Text content
    _text_documents::Dict{URI,TextDocument}

    # Parsed syntax trees
    # TODO Replace this with a concrete syntax tree for TOML
    _toml_syntax_trees::Dict{URI,Dict}

    # Semantic information
    _packages::Dict{URI,JuliaPackage} # For now we just record all the packages, later we would want to extract the semantic content
    _projects::Dict{URI,JuliaProject} # For now we just record all the projects, later we would want to extract the semantic content
end

JuliaWorkspace() = JuliaWorkspace(Set{URI}(), Dict{URI,TextDocument}(), Dict{URI,Dict}(), Dict{URI,JuliaPackage}(), Dict{URI,JuliaProject}())

function JuliaWorkspace(workspace_folders::Set{URI})
    text_documents = isempty(workspace_folders) ? Dict{URI,TextDocument}() : merge((read_path_into_textdocuments(path) for path in workspace_folders)...)

    toml_syntax_trees = Dict{URI,Dict}()
    for (k,v) in pairs(text_documents)
        if endswith(lowercase(string(k)), ".toml")
            try
                toml_syntax_trees[k] = parse_toml_file(get_text(v))
            catch err
                # TODO Add some diagnostics
            end
        end
    end

    new_jw = JuliaWorkspace(workspace_folders, text_documents, toml_syntax_trees, semantic_pass_toml_files(toml_syntax_trees)...)
    return new_jw
end

function parse_toml_file(content)
    return Pkg.TOML.parse(content)
end

function is_path_project_file(path)
    basename_lower_case = basename(lowercase(path))

    return basename_lower_case=="project.toml" || basename_lower_case=="juliaproject.toml"
end

function is_path_manifest_file(path)
    basename_lower_case = basename(lowercase(path))

    return basename_lower_case=="manifest.toml" || basename_lower_case=="juliamanifest.toml"
end

function read_textdocument_from_uri(uri::URI)
    path = uri2filepath(uri)

    content = try
        s = read(path, String)
        our_isvalid(s) || return nothing
        s
    catch err
        is_walkdir_error(err) || rethrow()
        return nothing
    end
    return TextDocument(uri, content, 0)
end

function read_path_into_textdocuments(uri::URI)
    path = uri2filepath(uri)
    result = Dict{URI,TextDocument}()

    if load_rootpath(path)
        try
            for (root, _, files) in walkdir(path, onerror=x -> x)
                for file in files
                    filepath = joinpath(root, file)
                    if is_path_project_file(filepath) || is_path_manifest_file(filepath)
                        uri = filepath2uri(filepath)
                        doc = read_textdocument_from_uri(uri)
                        doc === nothing && continue
                        result[uri] = doc
                    end
                end
            end
        catch err
            is_walkdir_error(err) || rethrow()
        end
    end

    return result
end

function add_workspace_folder(jw::JuliaWorkspace, folder::URI)
    new_roots = push!(copy(jw._workspace_folders), folder)
    new_toml_syntax_trees = copy(jw._toml_syntax_trees)

    additional_documents = read_path_into_textdocuments(folder)
    for (k,v) in pairs(additional_documents)
        if endswith(lowercase(string(k)), ".toml")
            try
                new_toml_syntax_trees[k] = parse_toml_file(get_text(v))
            catch err
                # TODO Add some diagnostics
            end
        end
    end

    new_text_documents = merge(jw._text_documents, additional_documents)

    new_jw = JuliaWorkspace(new_roots, new_text_documents, new_toml_syntax_trees, semantic_pass_toml_files(new_toml_syntax_trees)...)
    return new_jw
end

function remove_workspace_folder(jw::JuliaWorkspace, folder::URI)
    new_roots = delete!(copy(jw._workspace_folders), folder)

    new_text_documents = filter(jw._text_documents) do i
        # TODO Eventually use FilePathsBase functionality to properly test this
        return any(startswith(string(i.first), string(j)) for j in new_roots )
    end

    new_toml_syntax_trees = filter(jw._toml_syntax_trees) do i
        return haskey(new_text_documents, i.first)
    end

    new_jw = JuliaWorkspace(new_roots, new_text_documents, new_toml_syntax_trees, semantic_pass_toml_files(new_toml_syntax_trees)...)
    return new_jw
end

function add_file(jw::JuliaWorkspace, uri::URI)
    new_doc = read_textdocument_from_uri(uri)

    new_jw = jw

    if new_doc!==nothing
        new_text_documents = copy(jw._text_documents)
        new_text_documents[uri] = new_doc

        new_toml_syntax_trees = jw._toml_syntax_trees
        try
            new_toml_syntax_tree = parse_toml_file(get_text(new_doc))

            new_toml_syntax_trees = copy(jw._toml_syntax_trees)

            new_toml_syntax_trees[uri] = new_toml_syntax_tree
        catch err
            nothing
        end

        new_jw =  JuliaWorkspace(jw._workspace_folders, new_text_documents, new_toml_syntax_trees, semantic_pass_toml_files(new_toml_syntax_trees)...)
    end

    return new_jw
end

function update_file(jw::JuliaWorkspace, uri::URI)
    new_doc = read_textdocument_from_uri(uri)

    new_jw = jw

    if new_doc!==nothing
        new_text_documents = copy(jw._text_documents)
        new_text_documents[uri] = new_doc

        new_toml_syntax_trees = jw._toml_syntax_trees
        try
            new_toml_syntax_tree = parse_toml_file(get_text(new_doc))

            new_toml_syntax_trees = copy(jw._toml_syntax_trees)

            new_toml_syntax_trees[uri] = new_toml_syntax_tree
        catch err
            delete!(new_toml_syntax_trees, uri)
        end

        new_jw = JuliaWorkspace(jw._workspace_folders, new_text_documents, new_toml_syntax_trees, semantic_pass_toml_files(new_toml_syntax_trees)...)
    end

    return new_jw
end

function delete_file(jw::JuliaWorkspace, uri::URI)
    new_text_documents = copy(jw._text_documents)
    delete!(new_text_documents, uri)

    new_toml_syntax_trees = jw._toml_syntax_trees
    if haskey(jw._toml_syntax_trees, uri)
        new_toml_syntax_trees = copy(jw._toml_syntax_trees)
        delete!(new_toml_syntax_trees, uri)
    end

    new_jw = JuliaWorkspace(jw._workspace_folders, new_text_documents, new_toml_syntax_trees, semantic_pass_toml_files(new_toml_syntax_trees)...)

    return new_jw
end

function semantic_pass_toml_files(toml_syntax_trees)
    # Extract all packages & paths with a manifest
    packages = Dict{URI,JuliaPackage}()
    paths_with_manifest = Dict{String,Dict}()
    for (k,v) in pairs(toml_syntax_trees)
        # TODO Maybe also check the filename here and only do the package detection for Project.toml and JuliaProject.toml
        if haskey(v, "name") && haskey(v, "uuid") && haskey(v, "version")
            parsed_uuid = tryparse(UUID, v["uuid"])
            if parsed_uuid!==nothing
                folder_uri = k |> uri2filepath |> dirname |> filepath2uri
                packages[folder_uri] = JuliaPackage(k, v["name"], parsed_uuid)
            end
        end

        path = uri2filepath(k)
        dname = dirname(path)
        filename = basename(path)
        filename_lc = lowercase(filename)
        if filename_lc == "manifest.toml" || filename_lc == "juliamanifest.toml"
            paths_with_manifest[dname] = v
        end
    end

    # Extract all projects
    projects = Dict{URI,JuliaProject}()
    for (k,_) in pairs(toml_syntax_trees)
        path = uri2filepath(k)
        dname = dirname(path)
        filename = basename(path)
        filename_lc = lowercase(filename)

        if (filename_lc=="project.toml" || filename_lc=="juliaproject.toml" ) && haskey(paths_with_manifest, dname)
            manifest_content = paths_with_manifest[dname]
            manifest_content isa Dict || continue
            deved_packages = Dict{URI,JuliaDevedPackage}()
            manifest_version = get(manifest_content, "manifest_format", "1.0")

            manifest_deps = if manifest_version=="1.0"
                manifest_content
            elseif manifest_version=="2.0" && haskey(manifest_content, "deps") && manifest_content["deps"] isa Dict
                manifest_content["deps"]
            else
                continue
            end

            for (k_entry, v_entry) in pairs(manifest_deps)
                v_entry isa Vector || continue
                length(v_entry)==1 || continue
                v_entry[1] isa Dict || continue
                haskey(v_entry[1], "path") || continue
                haskey(v_entry[1], "uuid") || continue
                uuid_of_deved_package = tryparse(UUID, v_entry[1]["uuid"])
                uuid_of_deved_package !== nothing || continue

                path_of_deved_package = v_entry[1]["path"]
                if !isabspath(path_of_deved_package)
                    path_of_deved_package = normpath(joinpath(dname, path_of_deved_package))
                    if endswith(path_of_deved_package, '\\') || endswith(path_of_deved_package, '/')
                        path_of_deved_package = path_of_deved_package[1:end-1]
                    end
                end

                uri_of_deved_package = filepath2uri(path_of_deved_package)

                deved_packages[uri_of_deved_package] = JuliaDevedPackage(k_entry, uuid_of_deved_package)
            end

            folder_uri = k |> uri2filepath |> dirname |> filepath2uri
            projects[folder_uri] = JuliaProject(k, deved_packages)
        end
    end

    return packages, projects
end

##############################################################################


struct CreateFileOptions <: Outbound
    overwrite::Union{Bool,Missing}
    ignoreIfExists::Union{Bool,Missing}
end

struct CreateFile <: Outbound
    kind::String
    uri::DocumentUri
    options::Union{CreateFileOptions,Missing}
    CreateFile(uri, options=missing) = new("create", uri, options)
end

struct RenameFileOptions <: Outbound
    overwrite::Union{Bool,Missing}
    ignoreIfExists::Union{Bool,Missing}
end

struct RenameFile <: Outbound
    kind::String
    oldUri::DocumentUri
    newUri::DocumentUri
    options::Union{RenameFileOptions,Missing}
    RenameFile(uri, options=missing) = new("rename", uri, options)
end

struct DeleteFileOptions <: Outbound
    recursive::Union{Bool,Missing}
    ignoreIfNotExists::Union{Bool,Missing}
end

struct DeleteFile <: Outbound
    kind::String
    uri::DocumentUri
    options::Union{DeleteFileOptions,Missing}
    DeleteFile(uri, options=missing) = new("delete", uri, options)
end


@dict_readable struct TextDocumentIdentifier
    uri::DocumentUri
end

@dict_readable struct TextDocumentItem
    uri::DocumentUri
    languageId::String
    version::Int
    text::String
end

@dict_readable struct VersionedTextDocumentIdentifier <: Outbound
    uri::DocumentUri
    version::Union{Int,Nothing}
end

@dict_readable struct TextDocumentPositionParams
    textDocument::TextDocumentIdentifier
    position::Position
end

mutable struct TextDocumentEdit
    textDocument::VersionedTextDocumentIdentifier
    edits::Vector{TextEdit}
end

mutable struct WorkspaceEdit <: Outbound
    changes::Union{Any,Missing}
    documentChanges::Union{Vector{TextDocumentEdit},Missing}
    # documentChanges::Union{Vector{TextDocumentEdit},Vector{Union{TextDocumentEdit,CreateFile,RenameFile,DeleteFile}}}
end

@dict_readable struct DidOpenTextDocumentParams
    textDocument::TextDocumentItem
end

@dict_readable struct TextDocumentContentChangeEvent  <: Outbound
    range::Union{Range,Missing}
    rangeLength::Union{Int,Missing}
    text::String
end

@dict_readable struct DidChangeTextDocumentParams
    textDocument::VersionedTextDocumentIdentifier
    contentChanges::Vector{TextDocumentContentChangeEvent}
end

@dict_readable struct DidSaveTextDocumentParams <: Outbound
    textDocument::TextDocumentIdentifier
    text::Union{String,Missing}
end

@dict_readable struct DidCloseTextDocumentParams
    textDocument::TextDocumentIdentifier
end

const TextDocumentSaveReason = Int
const TextDocumentSaveReasons = (Manual = 1,
                                 AfterDelay = 2,
                                 FocusOut = 3)

@dict_readable struct WillSaveTextDocumentParams
    textDocument::TextDocumentIdentifier
    reason::TextDocumentSaveReason
end

#!/bin/bash

JULIABIN="julia"

while [[ $# -gt 0 ]]
    do
    key="$1"

    case $key in
        -j|--julia)
            JULIABIN="$2"
            shift
        ;;
        *)
            echo "unknown option: $key" >&2
            exit
        ;;
    esac
    shift
done

$JULIABIN --startup-file=no --history-file=no -e \
    "using LanguageServer; import SymbolServer; server = LanguageServer.LanguageServerInstance(stdin, stdout); server.runlinter = true; run(server);" \
    <&0 >&1 &

PID=$!

while true; do
    # quit if server exited
    kill -0 "$PID" || break
    # if the current process is orphan, kill it and its children
    if [ $(ps -o ppid= -p "$$") -eq 1 ]; then
        kill -9 "$PID" $(pgrep -P "$PID")
        exit
    fi
    sleep 1
done

# Syntax Reference

```@index
Modules = [LanguageServer]
Pages   = ["syntax.md"]
```

## Main
```@autodocs
Modules = [LanguageServer]
Pages   = readdir("../src")
```

## Requests
```@autodocs
Modules = [LanguageServer]
Pages   = readdir("../src/requests")
```

## Protocol
```@autodocs
Modules = [LanguageServer]
Pages   = readdir("../src/protocol")
```

```@meta
CurrentModule = LanguageServer
```

# LanguageServer

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/LanguageServer.jl/dev)
[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
![](https://github.com/julia-vscode/LanguageServer.jl/workflows/Run%20CI%20on%20master/badge.svg)
[![codecov](https://codecov.io/gh/julia-vscode/LanguageServer.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/julia-vscode/LanguageServer.jl)


## Overview

This package implements the Microsoft [Language Server Protocol](https://github.com/Microsoft/language-server-protocol)
for the [Julia](http://julialang.org/) programming language.

Text editors with a client for the Language Server Protocol are able to
make use of the Julia Language Server for various code editing features:

- [VS Code](https://marketplace.visualstudio.com/items?itemName=julialang.language-julia)
- [Atom](https://github.com/pfitzseb/atom-julia-lsp-client)
- [Vim and Neovim](https://github.com/julia-vscode/LanguageServer.jl/wiki/Vim-and-Neovim)
- [Emacs](https://github.com/julia-vscode/LanguageServer.jl/wiki/Emacs)
- [Sublime Text](https://github.com/tomv564/LSP)


## Installation and Usage
**Documentation**: [![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://www.julia-vscode.org/LanguageServer.jl/dev)

```julia
using Pkg
Pkg.add("LanguageServer")
```

Instantiate an instance of the language server with
`LanguageServerInstance` and `run` it:

```julia
using LanguageServer

server = LanguageServerInstance(stdin, stdout, "/path/to/environment")
run(server)
```
